diff -pruN 1.8.0-3/.github/PULL_REQUEST_TEMPLATE.md 1.8.1-1/.github/PULL_REQUEST_TEMPLATE.md
--- 1.8.0-3/.github/PULL_REQUEST_TEMPLATE.md	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/.github/PULL_REQUEST_TEMPLATE.md	2024-07-26 00:19:02.000000000 +0000
@@ -5,7 +5,7 @@
 
 ## New Service Completion Status
 <!-- This section is only applicable if you're adding a new service -->
-* [ ] apprise/plugins/Notify<!--ServiceName goes here-->.py
+* [ ] apprise/plugins/<!--new plugin name -->.py
 * [ ] KEYWORDS
     - add new service into this file (alphabetically).
 * [ ] README.md
diff -pruN 1.8.0-3/.github/workflows/pkgbuild.yml 1.8.1-1/.github/workflows/pkgbuild.yml
--- 1.8.0-3/.github/workflows/pkgbuild.yml	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/.github/workflows/pkgbuild.yml	2024-07-26 00:19:02.000000000 +0000
@@ -38,7 +38,7 @@ jobs:
       # items within the `services` section of `docker-compose.yml`.
       matrix:
         target: [
-          "rpmbuild.el8",
+          "rpmbuild.el9",
         ]
 
     defaults:
diff -pruN 1.8.0-3/.github/workflows/tests.yml 1.8.1-1/.github/workflows/tests.yml
--- 1.8.0-3/.github/workflows/tests.yml	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/.github/workflows/tests.yml	2024-07-26 00:19:02.000000000 +0000
@@ -49,10 +49,6 @@ jobs:
             python-version: "3.11"
 
           # Test more available versions of CPython on Linux.
-          - os: "ubuntu-20.04"
-            # v3.6 (exclusively referenced) is not supported by GitHub anymore)
-            # v3.6.8 is fixed since it is the version CentOS/Rocky/RedHat v8 uses
-            python-version: "3.6.8"
           - os: "ubuntu-latest"
             python-version: "3.7"
           - os: "ubuntu-latest"
@@ -88,7 +84,7 @@ jobs:
         sudo apt-get install libdbus-1-dev
 
     - name: Setup Python
-      uses: actions/setup-python@v4
+      uses: actions/setup-python@v5
       with:
         python-version: ${{ matrix.python-version }}
         architecture: x64
@@ -102,25 +98,25 @@ jobs:
 
     - name: Install project dependencies (Baseline)
       run: |
-        pip install wheel
-        pip install -r requirements.txt -r dev-requirements.txt
+        pip install --use-pep517 wheel
+        pip install --use-pep517 -r requirements.txt -r dev-requirements.txt
 
     - name: Install project dependencies (All plugins)
       if: matrix.bare != true
       run: |
-        pip install -r all-plugin-requirements.txt
+        pip install --use-pep517 -r all-plugin-requirements.txt
         
     - name: Install project dependencies (Windows)
       if: runner.os == 'Windows'
       run: |
-        pip install -r win-requirements.txt || true
+        pip install --use-pep517 -r win-requirements.txt || true
 
     # Install package in editable mode,
     # and run project-specific tasks.
     - name: Setup project
       run: |
         python -m pip install --upgrade pip setuptools wheel
-        pip install --editable=.
+        pip install --use-pep517 --editable=.
         python setup.py compile_catalog
 
     # For saving resources, code style checking is
diff -pruN 1.8.0-3/Dockerfile.el8 1.8.1-1/Dockerfile.el8
--- 1.8.0-3/Dockerfile.el8	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/Dockerfile.el8	1970-01-01 00:00:00.000000000 +0000
@@ -1,64 +0,0 @@
-# -*- coding: utf-8 -*-
-# BSD 2-Clause License
-#
-# Apprise - Push Notification Library.
-# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions are met:
-#
-# 1. Redistributions of source code must retain the above copyright notice,
-#    this list of conditions and the following disclaimer.
-#
-# 2. Redistributions in binary form must reproduce the above copyright notice,
-#    this list of conditions and the following disclaimer in the documentation
-#    and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
-# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
-# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
-# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
-# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
-# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
-# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
-# POSSIBILITY OF SUCH DAMAGE.
-
-# Base
-FROM rockylinux:8
-ENV container docker
-RUN ( \
-	cd /lib/systemd/system/sysinit.target.wants/; for i in *; do [ $i == \
-	systemd-tmpfiles-setup.service ] || rm -f $i; done); \
-	rm -f /lib/systemd/system/multi-user.target.wants/*;\
-	rm -f /etc/systemd/system/*.wants/*;\
-	rm -f /lib/systemd/system/local-fs.target.wants/*; \
-	rm -f /lib/systemd/system/sockets.target.wants/*udev*; \
-	rm -f /lib/systemd/system/sockets.target.wants/*initctl*; \
-	rm -f /lib/systemd/system/basic.target.wants/*;\
-	rm -f /lib/systemd/system/anaconda.target.wants/*; \
-   echo "assumeyes=1" >> /etc/yum.conf; \
-   dnf install -y epel-release; \
-   dnf install -y rpm-build rpmlint python3-pip python3-virtualenv rubygem-ronn \
-                  dnf-plugins-core 'dnf-command(config-manager)' \
-                 'dnf-command(builddep)' sudo rsync rpmdevtools; \
-   dnf config-manager --set-enabled powertools;
-
-COPY packaging/redhat/python-apprise.spec /
-# Place our build file into the path
-COPY bin/build-rpm.sh /usr/bin
-RUN rpmspec -q --buildrequires /python-apprise.spec | cut -f1 -d' ' | \
-    xargs dnf install -y
-
-# RPM Build Structure Setup
-ENV FLAVOR=rpmbuild OS=centos DIST=el8
-RUN useradd builder -u 1000 -m -G users,wheel &>/dev/null && \
-    echo "builder ALL=(ALL:ALL) NOPASSWD:ALL" >> /etc/sudoers
-
-VOLUME ["/apprise"]
-WORKDIR /apprise
-
-# RPMs should never be built as root
-USER builder
diff -pruN 1.8.0-3/Dockerfile.el9 1.8.1-1/Dockerfile.el9
--- 1.8.0-3/Dockerfile.el9	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/Dockerfile.el9	2024-07-26 00:19:02.000000000 +0000
@@ -29,9 +29,7 @@
 # Base
 FROM rockylinux:9
 ENV container docker
-RUN ( \
-	cd /lib/systemd/system/sysinit.target.wants/; for i in *; do [ $i == \
-	systemd-tmpfiles-setup.service ] || rm -f $i; done); \
+RUN \
 	rm -f /lib/systemd/system/multi-user.target.wants/*;\
 	rm -f /etc/systemd/system/*.wants/*;\
 	rm -f /lib/systemd/system/local-fs.target.wants/*; \
diff -pruN 1.8.0-3/Dockerfile.py36 1.8.1-1/Dockerfile.py36
--- 1.8.0-3/Dockerfile.py36	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/Dockerfile.py36	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-# -*- coding: utf-8 -*-
-# BSD 2-Clause License
-#
-# Apprise - Push Notification Library.
-# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions are met:
-#
-# 1. Redistributions of source code must retain the above copyright notice,
-#    this list of conditions and the following disclaimer.
-#
-# 2. Redistributions in binary form must reproduce the above copyright notice,
-#    this list of conditions and the following disclaimer in the documentation
-#    and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
-# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
-# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
-# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
-# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
-# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
-# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
-# POSSIBILITY OF SUCH DAMAGE.
-
-# Base
-FROM python:3.6-buster
-RUN apt-get update && \
-    apt-get install -y --no-install-recommends libdbus-1-dev libgirepository1.0-dev build-essential musl-dev bash dbus && \
-    rm -rf /var/lib/apt/lists/*
-RUN pip install --no-cache-dir dbus-python PyGObject
-
-# Apprise Setup
-VOLUME ["/apprise"]
-WORKDIR /apprise
-COPY requirements.txt /
-COPY dev-requirements.txt /
-ENV PYTHONPATH /apprise
-ENV PYTHONPYCACHEPREFIX /apprise/__pycache__/py36
-
-
-RUN pip install --no-cache-dir -r /requirements.txt -r /dev-requirements.txt
diff -pruN 1.8.0-3/KEYWORDS 1.8.1-1/KEYWORDS
--- 1.8.0-3/KEYWORDS	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/KEYWORDS	2024-07-26 00:19:02.000000000 +0000
@@ -1,3 +1,4 @@
+Africas Talking
 Alerts
 Apprise API
 Automated Packet Reporting System
@@ -63,6 +64,7 @@ PagerDuty
 PagerTree
 ParsePlatform
 PopcornNotify
+Power Automate
 Prowl
 PushBullet
 Pushed
@@ -81,6 +83,7 @@ Ryver
 SendGrid
 ServerChan
 SES
+SFR
 Signal
 SimplePush
 Sinch
@@ -90,6 +93,7 @@ SMS Manager
 SMTP2Go
 SNS
 SparkPost
+Splunk
 Streamlabs
 Stride
 Synology Chat
@@ -100,12 +104,14 @@ Threema Gateway
 Twilio
 Twist
 Twitter
+VictorOps
 Voipms
 Vonage
 Webex
 WeCom Bot
 WhatsApp
 Windows
+Workflows
 XBMC
 XML
 Zulip
diff -pruN 1.8.0-3/README.md 1.8.1-1/README.md
--- 1.8.0-3/README.md	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/README.md	2024-07-26 00:19:02.000000000 +0000
@@ -83,6 +83,7 @@ The table below identifies the services
 | [Mastodon](https://github.com/caronc/apprise/wiki/Notify_mastodon) | mastodon:// or mastodons://| (TCP) 80 or 443  | mastodon://access_key@hostname<br />mastodon://access_key@hostname/@user<br />mastodon://access_key@hostname/@user1/@user2/@userN
 | [Matrix](https://github.com/caronc/apprise/wiki/Notify_matrix) | matrix:// or matrixs://  | (TCP) 80 or 443 | matrix://hostname<br />matrix://user@hostname<br />matrixs://user:pass@hostname:port/#room_alias<br />matrixs://user:pass@hostname:port/!room_id<br />matrixs://user:pass@hostname:port/#room_alias/!room_id/#room2<br />matrixs://token@hostname:port/?webhook=matrix<br />matrix://user:token@hostname/?webhook=slack&format=markdown
 | [Mattermost](https://github.com/caronc/apprise/wiki/Notify_mattermost) | mmost:// or mmosts:// | (TCP) 8065 | mmost://hostname/authkey<br />mmost://hostname:80/authkey<br />mmost://user@hostname:80/authkey<br />mmost://hostname/authkey?channel=channel<br />mmosts://hostname/authkey<br />mmosts://user@hostname/authkey<br />
+| [Microsoft Power Automate / Workflows (MSTeams)](https://github.com/caronc/apprise/wiki/Notify_workflows) | workflows://  | (TCP) 443   | workflows://WorkflowID/Signature/
 | [Microsoft Teams](https://github.com/caronc/apprise/wiki/Notify_msteams) | msteams://  | (TCP) 443   | msteams://TokenA/TokenB/TokenC/
 | [Misskey](https://github.com/caronc/apprise/wiki/Notify_misskey) | misskey:// or misskeys://| (TCP) 80 or 443  | misskey://access_token@hostname
 | [MQTT](https://github.com/caronc/apprise/wiki/Notify_mqtt) | mqtt://  or mqtts:// | (TCP) 1883 or 8883   | mqtt://hostname/topic<br />mqtt://user@hostname/topic<br />mqtts://user:pass@hostname:9883/topic
@@ -120,23 +121,25 @@ The table below identifies the services
 | [SimplePush](https://github.com/caronc/apprise/wiki/Notify_simplepush) | spush://   | (TCP) 443    | spush://apikey<br />spush://salt:password@apikey<br />spush://apikey?event=Apprise
 | [Slack](https://github.com/caronc/apprise/wiki/Notify_slack) | slack://  | (TCP) 443   | slack://TokenA/TokenB/TokenC/<br />slack://TokenA/TokenB/TokenC/Channel<br />slack://botname@TokenA/TokenB/TokenC/Channel<br />slack://user@TokenA/TokenB/TokenC/Channel1/Channel2/ChannelN
 | [SMTP2Go](https://github.com/caronc/apprise/wiki/Notify_smtp2go) | smtp2go:// | (TCP) 443 | smtp2go://user@hostname/apikey<br />smtp2go://user@hostname/apikey/email<br />smtp2go://user@hostname/apikey/email1/email2/emailN<br />smtp2go://user@hostname/apikey/?name="From%20User"
-| [Streamlabs](https://github.com/caronc/apprise/wiki/Notify_streamlabs) | strmlabs:// | (TCP) 443 | strmlabs://AccessToken/<br/>strmlabs://AccessToken/?name=name&identifier=identifier&amount=0&currency=USD
 | [SparkPost](https://github.com/caronc/apprise/wiki/Notify_sparkpost) | sparkpost:// | (TCP) 443 | sparkpost://user@hostname/apikey<br />sparkpost://user@hostname/apikey/email<br />sparkpost://user@hostname/apikey/email1/email2/emailN<br />sparkpost://user@hostname/apikey/?name="From%20User"
+| [Spunk](https://github.com/caronc/apprise/wiki/Notify_splunk) | splunk:// or victorops:/ | (TCP) 443 | splunk://route_key@apikey<br />splunk://route_key@apikey/entity_id
+| [Streamlabs](https://github.com/caronc/apprise/wiki/Notify_streamlabs) | strmlabs:// | (TCP) 443 | strmlabs://AccessToken/<br/>strmlabs://AccessToken/?name=name&identifier=identifier&amount=0&currency=USD
 | [Synology Chat](https://github.com/caronc/apprise/wiki/Notify_synology_chat) | synology:// or synologys:// |  (TCP) 80 or 443 | synology://hostname/token<br />synology://hostname:port/token
 | [Syslog](https://github.com/caronc/apprise/wiki/Notify_syslog) | syslog://  | n/a | syslog://<br />syslog://Facility
 | [Telegram](https://github.com/caronc/apprise/wiki/Notify_telegram) | tgram://  | (TCP) 443   | tgram://bottoken/ChatID<br />tgram://bottoken/ChatID1/ChatID2/ChatIDN
 | [Twitter](https://github.com/caronc/apprise/wiki/Notify_twitter) | twitter://  | (TCP) 443   | twitter://CKey/CSecret/AKey/ASecret<br/>twitter://user@CKey/CSecret/AKey/ASecret<br/>twitter://CKey/CSecret/AKey/ASecret/User1/User2/User2<br/>twitter://CKey/CSecret/AKey/ASecret?mode=tweet
 | [Twist](https://github.com/caronc/apprise/wiki/Notify_twist) | twist://  | (TCP) 443   | twist://pasword:login<br/>twist://password:login/#channel<br/>twist://password:login/#team:channel<br/>twist://password:login/#team:channel1/channel2/#team3:channel
-| [XBMC](https://github.com/caronc/apprise/wiki/Notify_xbmc) | xbmc:// or xbmcs://    | (TCP) 8080 or 443   | xbmc://hostname<br />xbmc://user@hostname<br />xbmc://user:password@hostname:port
 | [Webex Teams (Cisco)](https://github.com/caronc/apprise/wiki/Notify_wxteams) | wxteams://  | (TCP) 443   | wxteams://Token
 | [WeCom Bot](https://github.com/caronc/apprise/wiki/Notify_wecombot) | wecombot://  | (TCP) 443   | wecombot://BotKey
 | [WhatsApp](https://github.com/caronc/apprise/wiki/Notify_whatsapp) | whatsapp://  | (TCP) 443   | whatsapp://AccessToken@FromPhoneID/ToPhoneNo<br/> whatsapp://Template:AccessToken@FromPhoneID/ToPhoneNo
+| [XBMC](https://github.com/caronc/apprise/wiki/Notify_xbmc) | xbmc:// or xbmcs://    | (TCP) 8080 or 443   | xbmc://hostname<br />xbmc://user@hostname<br />xbmc://user:password@hostname:port
 | [Zulip Chat](https://github.com/caronc/apprise/wiki/Notify_zulip) | zulip://  | (TCP) 443   | zulip://botname@Organization/Token<br />zulip://botname@Organization/Token/Stream<br />zulip://botname@Organization/Token/Email
 
 ## SMS Notifications
 
 | Notification Service | Service ID | Default Port | Example Syntax |
 | -------------------- | ---------- | ------------ | -------------- |
+| [Africas Talking](https://github.com/caronc/apprise/wiki/Notify_africas_talking) | atalk://  | (TCP) 443   | atalk://AppUser@ApiKey/ToPhoneNo<br/>atalk://AppUser@ApiKey/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
 | [Automated Packet Reporting System (ARPS)](https://github.com/caronc/apprise/wiki/Notify_aprs)  | aprs:// | (TCP) 10152 | aprs://user:pass@callsign<br/>aprs://user:pass@callsign1/callsign2/callsignN
 | [AWS SNS](https://github.com/caronc/apprise/wiki/Notify_sns)  | sns://   | (TCP) 443   | sns://AccessKeyID/AccessSecretKey/RegionName/+PhoneNo<br/>sns://AccessKeyID/AccessSecretKey/RegionName/+PhoneNo1/+PhoneNo2/+PhoneNoN<br/>sns://AccessKeyID/AccessSecretKey/RegionName/Topic<br/>sns://AccessKeyID/AccessSecretKey/RegionName/Topic1/Topic2/TopicN
 | [BulkSMS](https://github.com/caronc/apprise/wiki/Notify_bulksms) | bulksms://  | (TCP) 443   | bulksms://user:password@ToPhoneNo<br/>bulksms://User:Password@ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
@@ -148,14 +151,15 @@ The table below identifies the services
 | [D7 Networks](https://github.com/caronc/apprise/wiki/Notify_d7networks) | d7sms://  | (TCP) 443   | d7sms://token@PhoneNo<br/>d7sms://token@ToPhoneNo1/ToPhoneNo2/ToPhoneNoN
 | [DingTalk](https://github.com/caronc/apprise/wiki/Notify_dingtalk)  | dingtalk://   | (TCP) 443   | dingtalk://token/<br />dingtalk://token/ToPhoneNo<br />dingtalk://token/ToPhoneNo1/ToPhoneNo2/ToPhoneNo1/
 | [Free-Mobile](https://github.com/caronc/apprise/wiki/Notify_freemobile)  | freemobile://   | (TCP) 443   | freemobile://user@password/
- [httpSMS](https://github.com/caronc/apprise/wiki/Notify_httpsms) | httpsms://  | (TCP) 443   | httpsms://ApiKey@FromPhoneNo<br/>httpsms://ApiKey@FromPhoneNo/ToPhoneNo<br/>httpsms://ApiKey@FromPhoneNo/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
+| [httpSMS](https://github.com/caronc/apprise/wiki/Notify_httpsms) | httpsms://  | (TCP) 443   | httpsms://ApiKey@FromPhoneNo<br/>httpsms://ApiKey@FromPhoneNo/ToPhoneNo<br/>httpsms://ApiKey@FromPhoneNo/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
 | [Kavenegar](https://github.com/caronc/apprise/wiki/Notify_kavenegar) | kavenegar://  | (TCP) 443   | kavenegar://ApiKey/ToPhoneNo<br/>kavenegar://FromPhoneNo@ApiKey/ToPhoneNo<br/>kavenegar://ApiKey/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN
 | [MessageBird](https://github.com/caronc/apprise/wiki/Notify_messagebird) | msgbird://  | (TCP) 443   | msgbird://ApiKey/FromPhoneNo<br/>msgbird://ApiKey/FromPhoneNo/ToPhoneNo<br/>msgbird://ApiKey/FromPhoneNo/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
 | [MSG91](https://github.com/caronc/apprise/wiki/Notify_msg91) | msg91://  | (TCP) 443   | msg91://TemplateID@AuthKey/ToPhoneNo<br/>msg91://TemplateID@AuthKey/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
+| [Société Française du Radiotéléphone (SFR)](https://github.com/caronc/apprise/wiki/Notify_sfr) | sfr://   | (TCP) 443    | sfr://user:password>@spaceId/ToPhoneNo<br/>sfr://user:password>@spaceId/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
 | [Signal API](https://github.com/caronc/apprise/wiki/Notify_signal) | signal://  or signals:// | (TCP) 80 or 443  | signal://hostname:port/FromPhoneNo<br/>signal://hostname:port/FromPhoneNo/ToPhoneNo<br/>signal://hostname:port/FromPhoneNo/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
 | [Sinch](https://github.com/caronc/apprise/wiki/Notify_sinch) | sinch://  | (TCP) 443   | sinch://ServicePlanId:ApiToken@FromPhoneNo<br/>sinch://ServicePlanId:ApiToken@FromPhoneNo/ToPhoneNo<br/>sinch://ServicePlanId:ApiToken@FromPhoneNo/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/<br/>sinch://ServicePlanId:ApiToken@ShortCode/ToPhoneNo<br/>sinch://ServicePlanId:ApiToken@ShortCode/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
 | [SMSEagle](https://github.com/caronc/apprise/wiki/Notify_smseagle) | smseagle:// or smseagles:// | (TCP) 80 or 443  | smseagles://hostname:port/ToPhoneNo<br/>smseagles://hostname:port/@ToContact<br/>smseagles://hostname:port/#ToGroup<br/>smseagles://hostname:port/ToPhoneNo1/#ToGroup/@ToContact/
- [SMS Manager](https://github.com/caronc/apprise/wiki/Notify_sms_manager) | smsmgr://  | (TCP) 443   | smsmgr://ApiKey@ToPhoneNo<br/>smsmgr://ApiKey@ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
+| [SMS Manager](https://github.com/caronc/apprise/wiki/Notify_sms_manager) | smsmgr://  | (TCP) 443   | smsmgr://ApiKey@ToPhoneNo<br/>smsmgr://ApiKey@ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
 | [Threema Gateway](https://github.com/caronc/apprise/wiki/Notify_threema) | threema://  | (TCP) 443   | threema://GatewayID@secret/ToPhoneNo<br/>threema://GatewayID@secret/ToEmail<br/>threema://GatewayID@secret/ToThreemaID/<br/>threema://GatewayID@secret/ToEmail/ToThreemaID/ToPhoneNo/...
 | [Twilio](https://github.com/caronc/apprise/wiki/Notify_twilio) | twilio://  | (TCP) 443   | twilio://AccountSid:AuthToken@FromPhoneNo<br/>twilio://AccountSid:AuthToken@FromPhoneNo/ToPhoneNo<br/>twilio://AccountSid:AuthToken@FromPhoneNo/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/<br/>twilio://AccountSid:AuthToken@FromPhoneNo/ToPhoneNo?apikey=Key<br/>twilio://AccountSid:AuthToken@ShortCode/ToPhoneNo<br/>twilio://AccountSid:AuthToken@ShortCode/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
 | [Voipms](https://github.com/caronc/apprise/wiki/Notify_voipms) | voipms://  | (TCP) 443   | voipms://password:email/FromPhoneNo<br/>voipms://password:email/FromPhoneNo/ToPhoneNo<br/>voipms://password:email/FromPhoneNo/ToPhoneNo1/ToPhoneNo2/ToPhoneNoN/
diff -pruN 1.8.0-3/apprise/__init__.py 1.8.1-1/apprise/__init__.py
--- 1.8.0-3/apprise/__init__.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/__init__.py	2024-07-26 00:19:02.000000000 +0000
@@ -27,7 +27,7 @@
 # POSSIBILITY OF SUCH DAMAGE.
 
 __title__ = 'Apprise'
-__version__ = '1.8.0'
+__version__ = '1.8.1'
 __author__ = 'Chris Caron'
 __license__ = 'BSD'
 __copywrite__ = 'Copyright (C) 2024 Chris Caron <lead2gold@gmail.com>'
@@ -60,7 +60,9 @@ from .locale import AppriseLocale
 from .asset import AppriseAsset
 from .apprise_config import AppriseConfig
 from .apprise_attachment import AppriseAttachment
-
+from .manager_attachment import AttachmentManager
+from .manager_config import ConfigurationManager
+from .manager_plugins import NotificationManager
 from . import decorators
 
 # Inherit our logging with our additional entries added to it
@@ -84,6 +86,9 @@ __all__ = [
     'ContentLocation', 'CONTENT_LOCATIONS',
     'PrivacyMode',
 
+    # Managers
+    'NotificationManager', 'ConfigurationManager', 'AttachmentManager',
+
     # Decorator
     'decorators',
 
diff -pruN 1.8.0-3/apprise/apprise_attachment.py 1.8.1-1/apprise/apprise_attachment.py
--- 1.8.0-3/apprise/apprise_attachment.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/apprise_attachment.py	2024-07-26 00:19:02.000000000 +0000
@@ -142,13 +142,8 @@ class AppriseAttachment:
             # prepare default asset
             asset = self.asset
 
-        if isinstance(attachments, AttachBase):
-            # Go ahead and just add our attachments into our list
-            self.attachments.append(attachments)
-            return True
-
-        elif isinstance(attachments, str):
-            # Save our path
+        if isinstance(attachments, (AttachBase, str)):
+            # store our instance
             attachments = (attachments, )
 
         elif not isinstance(attachments, (tuple, set, list)):
diff -pruN 1.8.0-3/apprise/asset.py 1.8.1-1/apprise/asset.py
--- 1.8.0-3/apprise/asset.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/asset.py	2024-07-26 00:19:02.000000000 +0000
@@ -70,6 +70,9 @@ class AppriseAsset:
         NotifyType.WARNING: '#CACF29',
     }
 
+    # The default color to return if a mapping isn't found in our table above
+    default_html_color = '#888888'
+
     # Ascii Notification
     ascii_notify_map = {
         NotifyType.INFO: '[i]',
@@ -78,8 +81,8 @@ class AppriseAsset:
         NotifyType.WARNING: '[~]',
     }
 
-    # The default color to return if a mapping isn't found in our table above
-    default_html_color = '#888888'
+    # The default ascii to return if a mapping isn't found in our table above
+    default_ascii_chars = '[?]'
 
     # The default image extension to use
     default_extension = '.png'
@@ -223,9 +226,8 @@ class AppriseAsset:
         Returns an ascii representation based on passed in notify type
 
         """
-
         # look our response up
-        return self.ascii_notify_map.get(notify_type, self.default_html_color)
+        return self.ascii_notify_map.get(notify_type, self.default_ascii_chars)
 
     def image_url(self, notify_type, image_size, logo=False, extension=None):
         """
diff -pruN 1.8.0-3/apprise/attachment/base.py 1.8.1-1/apprise/attachment/base.py
--- 1.8.0-3/apprise/attachment/base.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/attachment/base.py	2024-07-26 00:19:02.000000000 +0000
@@ -148,6 +148,9 @@ class AttachBase(URLBase):
         # Absolute path to attachment
         self.download_path = None
 
+        # Track open file pointers
+        self.__pointers = set()
+
         # Set our cache flag; it can be True, False, None, or a (positive)
         # integer... nothing else
         if cache is not None:
@@ -226,15 +229,14 @@ class AttachBase(URLBase):
         Content is cached once determied to prevent overhead of future
         calls.
         """
+        if not self.exists():
+            # we could not obtain our attachment
+            return None
 
         if self._mimetype:
             # return our pre-calculated cached content
             return self._mimetype
 
-        if not self.exists():
-            # we could not obtain our attachment
-            return None
-
         if not self.detected_mimetype:
             # guess_type() returns: (type, encoding) and sets type to None
             # if it can't otherwise determine it.
@@ -258,6 +260,9 @@ class AttachBase(URLBase):
         Simply returns true if the object has downloaded and stored the
         attachment AND the attachment has not expired.
         """
+        if self.location == ContentLocation.INACCESSIBLE:
+            # our content is inaccessible
+            return False
 
         cache = self.template_args['cache']['default'] \
             if self.cache is None else self.cache
@@ -295,6 +300,11 @@ class AttachBase(URLBase):
           - download_path: Must contain a absolute path to content
           - detected_mimetype: Should identify mimetype of content
         """
+
+        # Remove all open pointers
+        while self.__pointers:
+            self.__pointers.pop().close()
+
         self.detected_name = None
         self.download_path = None
         self.detected_mimetype = None
@@ -314,6 +324,26 @@ class AttachBase(URLBase):
         raise NotImplementedError(
             "download() is implimented by the child class.")
 
+    def open(self, mode='rb'):
+        """
+        return our file pointer and track it (we'll auto close later
+        """
+        pointer = open(self.path, mode=mode)
+        self.__pointers.add(pointer)
+        return pointer
+
+    def __enter__(self):
+        """
+        support with keyword
+        """
+        return self.open()
+
+    def __exit__(self, value_type, value, traceback):
+        """
+        stub to do nothing; but support exit of with statement gracefully
+        """
+        return
+
     @staticmethod
     def parse_url(url, verify_host=True, mimetype_db=None, sanitize=True):
         """Parses the URL and returns it broken apart into a dictionary.
@@ -376,3 +406,9 @@ class AttachBase(URLBase):
         True is returned if our content was downloaded correctly.
         """
         return True if self.path else False
+
+    def __del__(self):
+        """
+        Perform any house cleaning
+        """
+        self.invalidate()
diff -pruN 1.8.0-3/apprise/attachment/file.py 1.8.1-1/apprise/attachment/file.py
--- 1.8.0-3/apprise/attachment/file.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/attachment/file.py	2024-07-26 00:19:02.000000000 +0000
@@ -78,7 +78,8 @@ class AttachFile(AttachBase):
 
         return 'file://{path}{params}'.format(
             path=self.quote(self.dirty_path),
-            params='?{}'.format(self.urlencode(params)) if params else '',
+            params='?{}'.format(self.urlencode(params, safe='/'))
+            if params else '',
         )
 
     def download(self, **kwargs):
diff -pruN 1.8.0-3/apprise/attachment/http.py 1.8.1-1/apprise/attachment/http.py
--- 1.8.0-3/apprise/attachment/http.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/attachment/http.py	2024-07-26 00:19:02.000000000 +0000
@@ -352,7 +352,7 @@ class AttachHTTP(AttachBase):
             port='' if self.port is None or self.port == default_port
                  else ':{}'.format(self.port),
             fullpath=self.quote(self.fullpath, safe='/'),
-            params=self.urlencode(params),
+            params=self.urlencode(params, safe='/'),
         )
 
     @staticmethod
diff -pruN 1.8.0-3/apprise/attachment/memory.py 1.8.1-1/apprise/attachment/memory.py
--- 1.8.0-3/apprise/attachment/memory.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/apprise/attachment/memory.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,212 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+import re
+import os
+import io
+from .base import AttachBase
+from ..common import ContentLocation
+from ..locale import gettext_lazy as _
+import uuid
+
+
+class AttachMemory(AttachBase):
+    """
+    A wrapper for Memory based attachment sources
+    """
+
+    # The default descriptive name associated with the service
+    service_name = _('Memory')
+
+    # The default protocol
+    protocol = 'memory'
+
+    # Content is local to the same location as the apprise instance
+    # being called (server-side)
+    location = ContentLocation.LOCAL
+
+    def __init__(self, content=None, name=None, mimetype=None,
+                 encoding='utf-8', **kwargs):
+        """
+        Initialize Memory Based Attachment Object
+
+        """
+        # Create our BytesIO object
+        self._data = io.BytesIO()
+
+        if content is None:
+            # Empty; do nothing
+            pass
+
+        elif isinstance(content, str):
+            content = content.encode(encoding)
+            if mimetype is None:
+                mimetype = 'text/plain'
+
+            if not name:
+                # Generate a unique filename
+                name = str(uuid.uuid4()) + '.txt'
+
+        elif not isinstance(content, bytes):
+            raise TypeError(
+                'Provided content for memory attachment is invalid')
+
+        # Store our content
+        if content:
+            self._data.write(content)
+
+        if mimetype is None:
+            # Default mimetype
+            mimetype = 'application/octet-stream'
+
+        if not name:
+            # Generate a unique filename
+            name = str(uuid.uuid4()) + '.dat'
+
+        # Initialize our base object
+        super().__init__(name=name, mimetype=mimetype, **kwargs)
+
+        return
+
+    def url(self, privacy=False, *args, **kwargs):
+        """
+        Returns the URL built dynamically based on specified arguments.
+        """
+
+        # Define any URL parameters
+        params = {
+            'mime': self._mimetype,
+        }
+
+        return 'memory://{name}?{params}'.format(
+            name=self.quote(self._name),
+            params=self.urlencode(params, safe='/')
+        )
+
+    def open(self, *args, **kwargs):
+        """
+        return our memory object
+        """
+        # Return our object
+        self._data.seek(0, 0)
+        return self._data
+
+    def __enter__(self):
+        """
+        support with clause
+        """
+        # Return our object
+        self._data.seek(0, 0)
+        return self._data
+
+    def download(self, **kwargs):
+        """
+        Handle memory download() call
+        """
+
+        if self.location == ContentLocation.INACCESSIBLE:
+            # our content is inaccessible
+            return False
+
+        if self.max_file_size > 0 and len(self) > self.max_file_size:
+            # The content to attach is to large
+            self.logger.error(
+                'Content exceeds allowable maximum memory size '
+                '({}KB): {}'.format(
+                    int(self.max_file_size / 1024), self.url(privacy=True)))
+
+            # Return False (signifying a failure)
+            return False
+
+        return True
+
+    def invalidate(self):
+        """
+        Removes data
+        """
+        self._data.truncate(0)
+        return
+
+    def exists(self):
+        """
+        over-ride exists() call
+        """
+        size = len(self)
+        return True if self.location != ContentLocation.INACCESSIBLE \
+            and size > 0 and (
+                self.max_file_size <= 0 or
+                (self.max_file_size > 0 and size <= self.max_file_size)) \
+            else False
+
+    @staticmethod
+    def parse_url(url):
+        """
+        Parses the URL so that we can handle all different file paths
+        and return it as our path object
+
+        """
+
+        results = AttachBase.parse_url(url, verify_host=False)
+        if not results:
+            # We're done early; it's not a good URL
+            return results
+
+        if 'name' not in results:
+            # Allow fall-back to be from URL
+            match = re.match(r'memory://(?P<path>[^?]+)(\?.*)?', url, re.I)
+            if match:
+                # Store our filename only (ignore any defined paths)
+                results['name'] = \
+                    os.path.basename(AttachMemory.unquote(match.group('path')))
+        return results
+
+    @property
+    def path(self):
+        """
+        return the filename
+        """
+        if not self.exists():
+            # we could not obtain our path
+            return None
+
+        return self._name
+
+    def __len__(self):
+        """
+        Returns the size of he memory attachment
+
+        """
+        return self._data.getbuffer().nbytes
+
+    def __bool__(self):
+        """
+        Allows the Apprise object to be wrapped in an based 'if statement'.
+        True is returned if our content was downloaded correctly.
+        """
+
+        return self.exists()
diff -pruN 1.8.0-3/apprise/cli.py 1.8.1-1/apprise/cli.py
--- 1.8.0-3/apprise/cli.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/cli.py	2024-07-26 00:19:02.000000000 +0000
@@ -121,7 +121,7 @@ if platform.system() == 'Windows':
         # Global Support
         #
 
-        # C:\ProgramData\Apprise\
+        # C:\ProgramData\Apprise
         expandvars('%ALLUSERSPROFILE%\\Apprise\\apprise'),
         expandvars('%ALLUSERSPROFILE%\\Apprise\\apprise.conf'),
         expandvars('%ALLUSERSPROFILE%\\Apprise\\apprise.yml'),
diff -pruN 1.8.0-3/apprise/conversion.py 1.8.1-1/apprise/conversion.py
--- 1.8.0-3/apprise/conversion.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/conversion.py	2024-07-26 00:19:02.000000000 +0000
@@ -180,8 +180,10 @@ class HTMLConverter(HTMLParser, object):
             self._result.append('\n')
 
         elif tag == 'hr':
-            if self._result:
+            if self._result and isinstance(self._result[-1], str):
                 self._result[-1] = self._result[-1].rstrip(' ')
+            else:
+                pass
 
             self._result.append('\n---\n')
 
diff -pruN 1.8.0-3/apprise/i18n/apprise.pot 1.8.1-1/apprise/i18n/apprise.pot
--- 1.8.0-3/apprise/i18n/apprise.pot	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/i18n/apprise.pot	2024-07-26 00:19:02.000000000 +0000
@@ -6,16 +6,16 @@
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: apprise 1.8.0\n"
+"Project-Id-Version: apprise 1.8.1\n"
 "Report-Msgid-Bugs-To: lead2gold@gmail.com\n"
-"POT-Creation-Date: 2024-05-11 16:13-0400\n"
+"POT-Creation-Date: 2024-07-25 18:31-0400\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.13.1\n"
+"Generated-By: Babel 2.15.0\n"
 
 msgid "A local Gnome environment is required."
 msgstr ""
@@ -35,6 +35,9 @@ msgstr ""
 msgid "API Token"
 msgstr ""
 
+msgid "API Version"
+msgstr ""
+
 msgid "Access Key"
 msgstr ""
 
@@ -56,6 +59,9 @@ msgstr ""
 msgid "Action"
 msgstr ""
 
+msgid "Action Mapping"
+msgstr ""
+
 msgid "Add Tokens"
 msgstr ""
 
@@ -74,6 +80,9 @@ msgstr ""
 msgid "App ID"
 msgstr ""
 
+msgid "App User Name"
+msgstr ""
+
 msgid "App Version"
 msgstr ""
 
@@ -182,6 +191,9 @@ msgstr ""
 msgid "Currency"
 msgstr ""
 
+msgid "Custom Data"
+msgstr ""
+
 msgid "Custom Details"
 msgstr ""
 
@@ -200,6 +212,9 @@ msgstr ""
 msgid "Data Entries"
 msgstr ""
 
+msgid "Decode Template Args"
+msgstr ""
+
 msgid "Delay"
 msgstr ""
 
@@ -242,9 +257,15 @@ msgstr ""
 msgid "Embed URL"
 msgstr ""
 
+msgid "Enable Contents"
+msgstr ""
+
 msgid "Entity"
 msgstr ""
 
+msgid "Entity ID"
+msgstr ""
+
 msgid "Event"
 msgstr ""
 
@@ -284,6 +305,9 @@ msgstr ""
 msgid "Free-Mobile"
 msgstr ""
 
+msgid "From"
+msgstr ""
+
 msgid "From Email"
 msgstr ""
 
@@ -398,6 +422,9 @@ msgstr ""
 msgid "Matrix API Verion"
 msgstr ""
 
+msgid "Media Type"
+msgstr ""
+
 msgid "Memory"
 msgstr ""
 
@@ -478,13 +505,10 @@ msgstr ""
 msgid "Payload Extras"
 msgstr ""
 
-msgid "Ping Discord Role"
-msgstr ""
-
-msgid "Ping Discord User"
+msgid "Port"
 msgstr ""
 
-msgid "Port"
+msgid "Postback Data"
 msgstr ""
 
 msgid "Prefix"
@@ -511,6 +535,9 @@ msgstr ""
 msgid "Query Method"
 msgstr ""
 
+msgid "Recipient Phone Number"
+msgstr ""
+
 msgid "Region"
 msgstr ""
 
@@ -541,6 +568,9 @@ msgstr ""
 msgid "Route Group"
 msgstr ""
 
+msgid "SMS Mode"
+msgstr ""
+
 msgid "SMTP Server"
 msgstr ""
 
@@ -571,6 +601,9 @@ msgstr ""
 msgid "Sender ID"
 msgstr ""
 
+msgid "Sender Name"
+msgstr ""
+
 msgid "Sensitive Attachments"
 msgstr ""
 
@@ -580,6 +613,12 @@ msgstr ""
 msgid "Server Timeout"
 msgstr ""
 
+msgid "Service ID"
+msgstr ""
+
+msgid "Service Password"
+msgstr ""
+
 msgid "Severity"
 msgstr ""
 
@@ -589,9 +628,15 @@ msgstr ""
 msgid "Show Status"
 msgstr ""
 
+msgid "Signature"
+msgstr ""
+
 msgid "Silent Notification"
 msgstr ""
 
+msgid "Société Française du Radiotéléphone"
+msgstr ""
+
 msgid "Socket Connect Timeout"
 msgstr ""
 
@@ -613,9 +658,15 @@ msgstr ""
 msgid "Source Phone No"
 msgstr ""
 
+msgid "Space ID"
+msgstr ""
+
 msgid "Special Text Color"
 msgstr ""
 
+msgid "Splunk On-Call"
+msgstr ""
+
 msgid "Spoiler Text"
 msgstr ""
 
@@ -625,6 +676,9 @@ msgstr ""
 msgid "Subtitle"
 msgstr ""
 
+msgid "TTS Voice"
+msgstr ""
+
 msgid "Tags"
 msgstr ""
 
@@ -667,6 +721,9 @@ msgstr ""
 msgid "Target Group ID"
 msgstr ""
 
+msgid "Target Phone"
+msgstr ""
+
 msgid "Target Phone No"
 msgstr ""
 
@@ -682,6 +739,9 @@ msgstr ""
 msgid "Target Room ID"
 msgstr ""
 
+msgid "Target Routing Key"
+msgstr ""
+
 msgid "Target Schedule"
 msgstr ""
 
@@ -757,6 +817,9 @@ msgstr ""
 msgid "Thread Key"
 msgstr ""
 
+msgid "Timeout"
+msgstr ""
+
 msgid "To Channel ID"
 msgstr ""
 
@@ -862,9 +925,15 @@ msgstr ""
 msgid "Webhook Token"
 msgstr ""
 
+msgid "Workflow ID"
+msgstr ""
+
 msgid "Workspace"
 msgstr ""
 
+msgid "Wrap Text"
+msgstr ""
+
 msgid "X-Axis"
 msgstr ""
 
diff -pruN 1.8.0-3/apprise/manager.py 1.8.1-1/apprise/manager.py
--- 1.8.0-3/apprise/manager.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/manager.py	2024-07-26 00:19:02.000000000 +0000
@@ -223,7 +223,7 @@ class PluginManager(metaclass=Singleton)
                     if not hasattr(plugin, 'app_id'):
                         # Filter out non-notification modules
                         logger.trace(
-                            "(%s) import failed; no app_id defined in %s",
+                            "(%s.%s) import failed; no app_id defined in %s",
                             self.name, m_class, os.path.join(module_path, f))
                         continue
 
diff -pruN 1.8.0-3/apprise/plugins/africas_talking.py 1.8.1-1/apprise/plugins/africas_talking.py
--- 1.8.0-3/apprise/plugins/africas_talking.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/apprise/plugins/africas_talking.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,461 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+# To use this plugin, you must have a Africas Talking Account setup; See here:
+#  https://account.africastalking.com/
+#  From here... acquire your APIKey
+#
+# API Details: https://developers.africastalking.com/docs/sms/sending/bulk
+import requests
+
+from .base import NotifyBase
+from ..common import NotifyType
+from ..utils import is_phone_no
+from ..utils import parse_bool
+from ..utils import parse_phone_no
+from ..utils import validate_regex
+from ..locale import gettext_lazy as _
+
+
+class AfricasTalkingSMSMode:
+    """
+    Africas Talking SMS Mode
+    """
+    # BulkSMS Mode
+    BULKSMS = 'bulksms'
+
+    # Premium Mode
+    PREMIUM = 'premium'
+
+    # Sandbox Mode
+    SANDBOX = 'sandbox'
+
+
+# Define the types in a list for validation purposes
+AFRICAS_TALKING_SMS_MODES = (
+    AfricasTalkingSMSMode.BULKSMS,
+    AfricasTalkingSMSMode.PREMIUM,
+    AfricasTalkingSMSMode.SANDBOX,
+)
+
+
+# Extend HTTP Error Messages
+AFRICAS_TALKING_HTTP_ERROR_MAP = {
+    100: 'Processed',
+    101: 'Sent',
+    102: 'Queued',
+    401: 'Risk Hold',
+    402: 'Invalid Sender ID',
+    403: 'Invalid Phone Number',
+    404: 'Unsupported Number Type',
+    405: 'Insufficient Balance',
+    406: 'User In Blacklist',
+    407: 'Could Not Route',
+    409: 'Do Not Disturb Rejection',
+    500: 'Internal Server Error',
+    501: 'Gateway Error',
+    502: 'Rejected By Gateway',
+}
+
+
+class NotifyAfricasTalking(NotifyBase):
+    """
+    A wrapper for Africas Talking Notifications
+    """
+
+    # The default descriptive name associated with the Notification
+    service_name = 'Africas Talking'
+
+    # The services URL
+    service_url = 'https://africastalking.com/'
+
+    # The default secure protocol
+    secure_protocol = 'atalk'
+
+    # A URL that takes you to the setup/help of the specific protocol
+    setup_url = 'https://github.com/caronc/apprise/wiki/Notify_africas_talking'
+
+    # Africas Talking API Request URLs
+    notify_url = {
+        AfricasTalkingSMSMode.BULKSMS:
+        'https://api.africastalking.com/version1/messaging',
+        AfricasTalkingSMSMode.PREMIUM:
+        'https://content.africastalking.com/version1/messaging',
+        AfricasTalkingSMSMode.SANDBOX:
+        'https://api.sandbox.africastalking.com/version1/messaging',
+    }
+
+    # The maximum allowable characters allowed in the title per message
+    title_maxlen = 0
+
+    # The maximum allowable characters allowed in the body per message
+    body_maxlen = 160
+
+    # The maximum amount of phone numbers that can reside within a single
+    # batch transfer
+    default_batch_size = 50
+
+    # Define object templates
+    templates = (
+        '{schema}://{appuser}@{apikey}/{targets}',
+    )
+
+    # Define our template tokens
+    template_tokens = dict(NotifyBase.template_tokens, **{
+        'appuser': {
+            'name': _('App User Name'),
+            'type': 'string',
+            'regex': (r'^[A-Z0-9_-]+$', 'i'),
+            'required': True,
+        },
+        'apikey': {
+            'name': _('API Key'),
+            'type': 'string',
+            'required': True,
+            'private': True,
+            'regex': (r'^[A-Z0-9_-]+$', 'i'),
+        },
+        'target_phone': {
+            'name': _('Target Phone'),
+            'type': 'string',
+            'map_to': 'targets',
+        },
+        'targets': {
+            'name': _('Targets'),
+            'type': 'list:string',
+        },
+    })
+
+    # Define our template arguments
+    template_args = dict(NotifyBase.template_args, **{
+        'to': {
+            'alias_of': 'targets',
+        },
+        'apikey': {
+            'alias_of': 'apikey',
+        },
+        'from': {
+            # Your registered short code or alphanumeric
+            'name': _('From'),
+            'type': 'string',
+            'default': 'AFRICASTKNG',
+            'map_to': 'sender',
+        },
+        'batch': {
+            'name': _('Batch Mode'),
+            'type': 'bool',
+            'default': False,
+        },
+        'mode': {
+            'name': _('SMS Mode'),
+            'type': 'choice:string',
+            'values': AFRICAS_TALKING_SMS_MODES,
+            'default': AFRICAS_TALKING_SMS_MODES[0],
+        },
+    })
+
+    def __init__(self, appuser, apikey, targets=None, sender=None, batch=None,
+                 mode=None, **kwargs):
+        """
+        Initialize Africas Talking Object
+        """
+        super().__init__(**kwargs)
+
+        self.appuser = validate_regex(
+            appuser, *self.template_tokens['appuser']['regex'])
+        if not self.appuser:
+            msg = 'The Africas Talking appuser specified ({}) is invalid.'\
+                .format(appuser)
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        self.apikey = validate_regex(
+            apikey, *self.template_tokens['apikey']['regex'])
+        if not self.apikey:
+            msg = 'The Africas Talking apikey specified ({}) is invalid.'\
+                .format(apikey)
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        # Prepare Sender
+        self.sender = self.template_args['from']['default'] \
+            if sender is None else sender
+
+        # Prepare Batch Mode Flag
+        self.batch = self.template_args['batch']['default'] \
+            if batch is None else batch
+
+        self.mode = self.template_args['mode']['default'] \
+            if not isinstance(mode, str) else mode.lower()
+
+        if isinstance(mode, str) and mode:
+            self.mode = next(
+                (a for a in AFRICAS_TALKING_SMS_MODES if a.startswith(
+                    mode.lower())), None)
+
+            if self.mode not in AFRICAS_TALKING_SMS_MODES:
+                msg = 'The Africas Talking mode specified ({}) is invalid.'\
+                    .format(mode)
+                self.logger.warning(msg)
+                raise TypeError(msg)
+        else:
+            self.mode = self.template_args['mode']['default']
+
+        # Parse our targets
+        self.targets = list()
+
+        for target in parse_phone_no(targets):
+            # Validate targets and drop bad ones:
+            result = is_phone_no(target)
+            if not result:
+                self.logger.warning(
+                    'Dropped invalid phone # '
+                    '({}) specified.'.format(target),
+                )
+                continue
+
+            # store valid phone number
+            # Carry forward '+' if defined, otherwise do not...
+            self.targets.append(
+                ('+' + result['full'])
+                if target.lstrip()[0] == '+' else result['full'])
+
+    def send(self, body, title='', notify_type=NotifyType.INFO, **kwargs):
+        """
+        Perform Africas Talking Notification
+        """
+
+        if not self.targets:
+            # There is no one to email; we're done
+            self.logger.warning(
+                'There are no Africas Talking recipients to notify')
+            return False
+
+        headers = {
+            'User-Agent': self.app_id,
+            'Content-Type': 'application/x-www-form-urlencoded',
+            'Accept': 'application/json',
+            'apiKey': self.apikey,
+        }
+
+        # error tracking (used for function return)
+        has_error = False
+
+        # Send in batches if identified to do so
+        batch_size = 1 if not self.batch else self.default_batch_size
+
+        # Create a copy of the target list
+        for index in range(0, len(self.targets), batch_size):
+            # Prepare our payload
+            payload = {
+                'username': self.appuser,
+                'to': ','.join(self.targets[index:index + batch_size]),
+                'from': self.sender,
+                'message': body,
+            }
+
+            # Acquire our URL
+            notify_url = self.notify_url[self.mode]
+
+            self.logger.debug(
+                'Africas Talking POST URL: %s (cert_verify=%r)' % (
+                    notify_url, self.verify_certificate))
+            self.logger.debug('Africas Talking Payload: %s' % str(payload))
+
+            # Printable target detail
+            p_target = self.targets[index] if batch_size == 1 \
+                else '{} target(s)'.format(
+                    len(self.targets[index:index + batch_size]))
+
+            # Always call throttle before any remote server i/o is made
+            self.throttle()
+            try:
+                r = requests.post(
+                    notify_url,
+                    data=payload,
+                    headers=headers,
+                    verify=self.verify_certificate,
+                    timeout=self.request_timeout,
+                )
+                # Sample response
+                # {
+                #     "SMSMessageData": {
+                #         "Message": "Sent to 1/1 Total Cost: KES 0.8000",
+                #         "Recipients": [{
+                #             "statusCode": 101,
+                #             "number": "+254711XXXYYY",
+                #             "status": "Success",
+                #             "cost": "KES 0.8000",
+                #             "messageId": "ATPid_SampleTxnId123"
+                #         }]
+                #     }
+                # }
+
+                if r.status_code not in (100, 101, 102, requests.codes.ok):
+                    # We had a problem
+                    status_str = \
+                        NotifyAfricasTalking.http_response_code_lookup(
+                            r.status_code, AFRICAS_TALKING_HTTP_ERROR_MAP)
+
+                    self.logger.warning(
+                        'Failed to send Africas Talking notification to {}: '
+                        '{}{}error={}.'.format(
+                            p_target,
+                            status_str,
+                            ', ' if status_str else '',
+                            r.status_code))
+
+                    self.logger.debug(
+                        'Response Details:\r\n{}'.format(r.content))
+
+                    # Mark our failure
+                    has_error = True
+                    continue
+
+                else:
+                    self.logger.info(
+                        'Sent Africas Talking notification to {}.'
+                        .format(p_target))
+
+            except requests.RequestException as e:
+                self.logger.warning(
+                    'A Connection error occurred sending Africas Talking '
+                    'notification to {}.'.format(p_target))
+                self.logger.debug('Socket Exception: %s' % str(e))
+
+                # Mark our failure
+                has_error = True
+                continue
+
+        return not has_error
+
+    def url(self, privacy=False, *args, **kwargs):
+        """
+        Returns the URL built dynamically based on specified arguments.
+        """
+
+        # Define any URL parameters
+        params = {
+            'batch': 'yes' if self.batch else 'no',
+        }
+
+        if self.sender != self.template_args['from']['default']:
+            # Set our sender if it was set
+            params['from'] = self.sender
+
+        if self.mode != self.template_args['mode']['default']:
+            # Set our mode
+            params['mode'] = self.mode
+
+        # Extend our parameters
+        params.update(self.url_parameters(privacy=privacy, *args, **kwargs))
+
+        return '{schema}://{appuser}@{apikey}/{targets}?{params}'.format(
+            schema=self.secure_protocol,
+            appuser=NotifyAfricasTalking.quote(self.appuser, safe=''),
+            apikey=self.pprint(self.apikey, privacy, safe=''),
+            targets='/'.join(
+                [NotifyAfricasTalking.quote(x, safe='+')
+                 for x in self.targets]),
+            params=NotifyAfricasTalking.urlencode(params),
+        )
+
+    def __len__(self):
+        """
+        Returns the number of targets associated with this notification
+        """
+        #
+        # Factor batch into calculation
+        #
+        batch_size = 1 if not self.batch else self.default_batch_size
+        targets = len(self.targets)
+        if batch_size > 1:
+            targets = int(targets / batch_size) + \
+                (1 if targets % batch_size else 0)
+
+        return targets if targets > 0 else 1
+
+    @staticmethod
+    def parse_url(url):
+        """
+        Parses the URL and returns enough arguments that can allow
+        us to re-instantiate this object.
+
+        """
+        results = NotifyBase.parse_url(url, verify_host=False)
+        if not results:
+            # We're done early as we couldn't load the results
+            return results
+
+        # The Application User ID
+        results['appuser'] = NotifyAfricasTalking.unquote(results['user'])
+
+        # Prepare our targets
+        results['targets'] = []
+
+        # Our Application APIKey
+        if 'apikey' in results['qsd'] and len(results['qsd']['apikey']):
+            # Store our apikey if specified as keyword
+            results['apikey'] = \
+                NotifyAfricasTalking.unquote(results['qsd']['apikey'])
+
+            # This means our host is actually a phone number (target)
+            results['targets'].append(
+                NotifyAfricasTalking.unquote(results['host']))
+
+        else:
+            # First item is our apikey
+            results['apikey'] = NotifyAfricasTalking.unquote(results['host'])
+
+        # Store our remaining targets found on path
+        results['targets'].extend(
+            NotifyAfricasTalking.split_path(results['fullpath']))
+
+        # The 'from' makes it easier to use yaml configuration
+        if 'from' in results['qsd'] and len(results['qsd']['from']):
+            results['sender'] = \
+                NotifyAfricasTalking.unquote(results['qsd']['from'])
+
+        # Support the 'to' variable so that we can support targets this way too
+        # The 'to' makes it easier to use yaml configuration
+        if 'to' in results['qsd'] and len(results['qsd']['to']):
+            results['targets'] += \
+                NotifyAfricasTalking.parse_phone_no(results['qsd']['to'])
+
+        # Get our Mode
+        if 'mode' in results['qsd'] and len(results['qsd']['mode']):
+            results['mode'] = \
+                NotifyAfricasTalking.unquote(results['qsd']['mode'])
+
+        # Get Batch Mode Flag
+        results['batch'] = \
+            parse_bool(results['qsd'].get(
+                'batch',
+                NotifyAfricasTalking.template_args['batch']['default']))
+
+        return results
diff -pruN 1.8.0-3/apprise/plugins/base.py 1.8.1-1/apprise/plugins/base.py
--- 1.8.0-3/apprise/plugins/base.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/base.py	2024-07-26 00:19:02.000000000 +0000
@@ -364,6 +364,17 @@ class NotifyBase(URLBase):
             color_type=color_type,
         )
 
+    def ascii(self, notify_type):
+        """
+        Returns the ascii characters associated with the notify_type
+        """
+        if notify_type not in NOTIFY_TYPES:
+            return None
+
+        return self.asset.ascii(
+            notify_type=notify_type,
+        )
+
     def notify(self, *args, **kwargs):
         """
         Performs notification
diff -pruN 1.8.0-3/apprise/plugins/bulksms.py 1.8.1-1/apprise/plugins/bulksms.py
--- 1.8.0-3/apprise/plugins/bulksms.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/bulksms.py	2024-07-26 00:19:02.000000000 +0000
@@ -269,7 +269,7 @@ class NotifyBulkSMS(NotifyBase):
             'to': None,
             'body': body,
             'routingGroup': self.route,
-            'encoding': BulkSMSEncoding.UNICODE \
+            'encoding': BulkSMSEncoding.UNICODE
             if self.unicode else BulkSMSEncoding.TEXT,
             # Options are NONE, ALL and ERRORS
             'deliveryReports': "ERRORS"
diff -pruN 1.8.0-3/apprise/plugins/lametric.py 1.8.1-1/apprise/plugins/lametric.py
--- 1.8.0-3/apprise/plugins/lametric.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/lametric.py	2024-07-26 00:19:02.000000000 +0000
@@ -938,7 +938,7 @@ class NotifyLametric(NotifyBase):
                         LAMETRIC_IS_APP_TOKEN.match(results['password'])) and
 
                     # Scan for app_ flags
-                    next((f for f in results.keys() \
+                    next((f for f in results.keys()
                           if f.startswith('app_')), None) is None) \
                 else LametricMode.CLOUD
 
diff -pruN 1.8.0-3/apprise/plugins/matrix.py 1.8.1-1/apprise/plugins/matrix.py
--- 1.8.0-3/apprise/plugins/matrix.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/matrix.py	2024-07-26 00:19:02.000000000 +0000
@@ -293,6 +293,9 @@ class NotifyMatrix(NotifyBase):
         # This gets initialized after a login/registration
         self.access_token = None
 
+        # This gets incremented for each request made against the v3 API
+        self.transaction_id = 0
+
         # Place an image inline with the message body
         self.include_image = include_image
 
@@ -612,8 +615,10 @@ class NotifyMatrix(NotifyBase):
 
             # Build our path
             if self.version == MatrixVersion.V3:
-                path = '/rooms/{}/send/m.room.message/0'.format(
-                    NotifyMatrix.quote(room_id))
+                path = '/rooms/{}/send/m.room.message/{}'.format(
+                    NotifyMatrix.quote(room_id),
+                    self.transaction_id,
+                )
 
             else:
                 path = '/rooms/{}/send/m.room.message'.format(
@@ -685,6 +690,12 @@ class NotifyMatrix(NotifyBase):
             method = 'PUT' if self.version == MatrixVersion.V3 else 'POST'
             postokay, response = self._fetch(
                 path, payload=payload, method=method)
+
+            # Increment the transaction ID to avoid future messages being
+            # recognized as retransmissions and ignored
+            if self.version == MatrixVersion.V3:
+                self.transaction_id += 1
+
             if not postokay:
                 # Notify our user
                 self.logger.warning(
diff -pruN 1.8.0-3/apprise/plugins/msteams.py 1.8.1-1/apprise/plugins/msteams.py
--- 1.8.0-3/apprise/plugins/msteams.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/msteams.py	2024-07-26 00:19:02.000000000 +0000
@@ -293,7 +293,12 @@ class NotifyMSTeams(NotifyBase):
             self.logger.warning(msg)
             raise TypeError(msg)
 
-        # else:  NoneType - this is okay
+        self.logger.deprecate(
+            "Microsoft is depricating their MSTeams webhooks on "
+            "December 31, 2024. It is advised that you switch to "
+            "Microsoft Power Automate (already supported by Apprise as "
+            "workflows://. For more information visit: "
+            "https://github.com/caronc/apprise/wiki/Notify_workflows")
         return
 
     def gen_payload(self, body, title='', notify_type=NotifyType.INFO,
diff -pruN 1.8.0-3/apprise/plugins/notifiarr.py 1.8.1-1/apprise/plugins/notifiarr.py
--- 1.8.0-3/apprise/plugins/notifiarr.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/notifiarr.py	2024-07-26 00:19:02.000000000 +0000
@@ -37,6 +37,7 @@ from ..locale import gettext_lazy as _
 from ..common import NotifyImageSize
 from ..utils import parse_list, parse_bool
 from ..utils import validate_regex
+from .discord import USER_ROLE_DETECTION_RE
 
 # Used to break path apart into list of channels
 CHANNEL_LIST_DELIM = re.compile(r'[ \t\r\n,#\\/]+')
@@ -118,14 +119,6 @@ class NotifyNotifiarr(NotifyBase):
         'apikey': {
             'alias_of': 'apikey',
         },
-        'discord_user': {
-            'name': _('Ping Discord User'),
-            'type': 'int',
-        },
-        'discord_role': {
-            'name': _('Ping Discord Role'),
-            'type': 'int',
-        },
         'event': {
             'name': _('Discord Event ID'),
             'type': 'int',
@@ -149,7 +142,6 @@ class NotifyNotifiarr(NotifyBase):
     })
 
     def __init__(self, apikey=None, include_image=None,
-                 discord_user=None, discord_role=None,
                  event=None, targets=None, source=None, **kwargs):
         """
         Initialize Notifiarr Object
@@ -172,30 +164,6 @@ class NotifyNotifiarr(NotifyBase):
             if isinstance(include_image, bool) \
             else self.template_args['image']['default']
 
-        # Set up our user if specified
-        self.discord_user = 0
-        if discord_user:
-            try:
-                self.discord_user = int(discord_user)
-
-            except (ValueError, TypeError):
-                msg = 'An invalid Notifiarr User ID ' \
-                      '({}) was specified.'.format(discord_user)
-                self.logger.warning(msg)
-                raise TypeError(msg)
-
-        # Set up our role if specified
-        self.discord_role = 0
-        if discord_role:
-            try:
-                self.discord_role = int(discord_role)
-
-            except (ValueError, TypeError):
-                msg = 'An invalid Notifiarr Role ID ' \
-                      '({}) was specified.'.format(discord_role)
-                self.logger.warning(msg)
-                raise TypeError(msg)
-
         # Prepare our source (if set)
         self.source = validate_regex(source)
 
@@ -244,12 +212,6 @@ class NotifyNotifiarr(NotifyBase):
         if self.source:
             params['source'] = self.source
 
-        if self.discord_user:
-            params['discord_user'] = self.discord_user
-
-        if self.discord_role:
-            params['discord_role'] = self.discord_role
-
         if self.event:
             params['event'] = self.event
 
@@ -287,6 +249,29 @@ class NotifyNotifiarr(NotifyBase):
         # Acquire image_url
         image_url = self.image_url(notify_type)
 
+        # Define our mentions
+        mentions = {
+            'pingUser': [],
+            'pingRole': [],
+            'content': [],
+        }
+
+        # parse for user id's <@123> and role IDs <@&456>
+        results = USER_ROLE_DETECTION_RE.findall(body)
+        if results:
+            for (is_role, no, value) in results:
+                if value:
+                    # @everybody, @admin, etc - unsupported
+                    mentions['content'].append(f'@{value}')
+
+                elif is_role:
+                    mentions['pingRole'].append(no)
+                    mentions['content'].append(f'<@&{no}>')
+
+                else:  # is_user
+                    mentions['pingUser'].append(no)
+                    mentions['content'].append(f'<@{no}>')
+
         for idx, channel in enumerate(self.targets['channels']):
             # prepare Notifiarr Object
             payload = {
@@ -301,14 +286,17 @@ class NotifyNotifiarr(NotifyBase):
                 'discord': {
                     'color': self.color(notify_type),
                     'ping': {
-                        'pingUser': self.discord_user
-                        if not idx and self.discord_user else 0,
-                        'pingRole': self.discord_role
-                        if not idx and self.discord_role else 0,
+                        # Only 1 user is supported, so truncate the rest
+                        'pingUser': 0 if not mentions['pingUser']
+                        else mentions['pingUser'][0],
+                        # Only 1 role is supported, so truncate the rest
+                        'pingRole': 0 if not mentions['pingRole']
+                        else mentions['pingRole'][0],
                     },
                     'text': {
                         'title': title,
-                        'content': '',
+                        'content': '' if not mentions['content']
+                        else '👉 ' + ' '.join(mentions['content']),
                         'description': body,
                         'footer': self.app_desc,
                     },
@@ -410,17 +398,6 @@ class NotifyNotifiarr(NotifyBase):
         # Get channels
         results['targets'] = NotifyNotifiarr.split_path(results['fullpath'])
 
-        if 'discord_user' in results['qsd'] and \
-                len(results['qsd']['discord_user']):
-            results['discord_user'] = \
-                NotifyNotifiarr.unquote(
-                    results['qsd']['discord_user'])
-
-        if 'discord_role' in results['qsd'] and \
-                len(results['qsd']['discord_role']):
-            results['discord_role'] = \
-                NotifyNotifiarr.unquote(results['qsd']['discord_role'])
-
         if 'event' in results['qsd'] and \
                 len(results['qsd']['event']):
             results['event'] = \
diff -pruN 1.8.0-3/apprise/plugins/ntfy.py 1.8.1-1/apprise/plugins/ntfy.py
--- 1.8.0-3/apprise/plugins/ntfy.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/ntfy.py	2024-07-26 00:19:02.000000000 +0000
@@ -53,6 +53,7 @@ from ..utils import is_ipaddr
 from ..utils import validate_regex
 from ..url import PrivacyMode
 from ..attachment.base import AttachBase
+from ..attachment.memory import AttachMemory
 
 
 class NtfyMode:
@@ -172,6 +173,20 @@ class NotifyNtfy(NotifyBase):
     # Support attachments
     attachment_support = True
 
+    # Maximum title length
+    title_maxlen = 200
+
+    # Maximum body length
+    body_maxlen = 7800
+
+    # Message size calculates title and body together
+    overflow_amalgamate_title = True
+
+    # Defines the number of bytes our JSON object can not exceed in size or we
+    # know the upstream server will reject it.  We convert these into
+    # attachments
+    ntfy_json_upstream_size_limit = 8000
+
     # Allows the user to specify the NotifyImageSize object
     image_size = NotifyImageSize.XY_256
 
@@ -504,7 +519,7 @@ class NotifyNtfy(NotifyBase):
             # Prepare our Header
             virt_payload['filename'] = attach.name
 
-            with open(attach.path, 'rb') as fp:
+            with attach as fp:
                 data = fp.read()
 
         if image_url:
@@ -538,18 +553,39 @@ class NotifyNtfy(NotifyBase):
         self.logger.debug('ntfy POST URL: %s (cert_verify=%r)' % (
             notify_url, self.verify_certificate,
         ))
-        self.logger.debug('ntfy Payload: %s' % str(virt_payload))
-        self.logger.debug('ntfy Headers: %s' % str(headers))
-
-        # Always call throttle before any remote server i/o is made
-        self.throttle()
 
         # Default response type
         response = None
 
         if not attach:
             data = dumps(data)
+            if len(data) > self.ntfy_json_upstream_size_limit:
+                # Convert to an attachment
 
+                if self.notify_format == NotifyFormat.MARKDOWN:
+                    mimetype = 'text/markdown'
+
+                elif self.notify_format == NotifyFormat.TEXT:
+                    mimetype = 'text/plain'
+
+                else:  # self.notify_format == NotifyFormat.HTML:
+                    mimetype = 'text/html'
+
+                attach = AttachMemory(
+                    mimetype=mimetype,
+                    content='{title}{body}'.format(
+                        title=title + '\n' if title else '', body=body))
+
+                # Recursively send the message body as an attachment instead
+                return self._send(
+                    topic=topic, body='', title='', attach=attach,
+                    image_url=image_url, **kwargs)
+
+        self.logger.debug('ntfy Payload: %s' % str(virt_payload))
+        self.logger.debug('ntfy Headers: %s' % str(headers))
+
+        # Always call throttle before any remote server i/o is made
+        self.throttle()
         try:
             r = requests.post(
                 notify_url,
diff -pruN 1.8.0-3/apprise/plugins/one_signal.py 1.8.1-1/apprise/plugins/one_signal.py
--- 1.8.0-3/apprise/plugins/one_signal.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/one_signal.py	2024-07-26 00:19:02.000000000 +0000
@@ -40,6 +40,8 @@ from itertools import chain
 from .base import NotifyBase
 from ..common import NotifyType
 from ..common import NotifyImageSize
+from ..utils import decode_b64_dict
+from ..utils import encode_b64_dict
 from ..utils import validate_regex
 from ..utils import parse_list
 from ..utils import parse_bool
@@ -82,7 +84,7 @@ class NotifyOneSignal(NotifyBase):
     setup_url = 'https://github.com/caronc/apprise/wiki/Notify_onesignal'
 
     # Notification
-    notify_url = "https://onesignal.com/api/v1/notifications"
+    notify_url = "https://api.onesignal.com/notifications"
 
     # Allows the user to specify the NotifyImageSize object
     image_size = NotifyImageSize.XY_72
@@ -161,6 +163,18 @@ class NotifyOneSignal(NotifyBase):
             'type': 'bool',
             'default': False,
         },
+        'contents': {
+            'name': _('Enable Contents'),
+            'type': 'bool',
+            'default': True,
+            'map_to': 'use_contents',
+        },
+        'decode': {
+            'name': _('Decode Template Args'),
+            'type': 'bool',
+            'default': False,
+            'map_to': 'decode_tpl_args',
+        },
         'template': {
             'alias_of': 'template',
         },
@@ -175,9 +189,22 @@ class NotifyOneSignal(NotifyBase):
         },
     })
 
+    # Define our token control
+    template_kwargs = {
+        'custom': {
+            'name': _('Custom Data'),
+            'prefix': ':',
+        },
+        'postback': {
+            'name': _('Postback Data'),
+            'prefix': '+',
+        },
+    }
+
     def __init__(self, app, apikey, targets=None, include_image=True,
-                 template=None, subtitle=None, language=None, batch=False,
-                 **kwargs):
+                 template=None, subtitle=None, language=None, batch=None,
+                 use_contents=None, decode_tpl_args=None,
+                 custom=None, postback=None, **kwargs):
         """
         Initialize OneSignal
 
@@ -201,7 +228,19 @@ class NotifyOneSignal(NotifyBase):
             raise TypeError(msg)
 
         # Prepare Batch Mode Flag
-        self.batch_size = self.default_batch_size if batch else 1
+        self.batch_size = self.default_batch_size if (
+            batch if batch is not None else
+            self.template_args['batch']['default']) else 1
+
+        # Prepare Use Contents Flag
+        self.use_contents = True if (
+            use_contents if use_contents is not None else
+            self.template_args['contents']['default']) else False
+
+        # Prepare Decode Template Arguments Flag
+        self.decode_tpl_args = True if (
+            decode_tpl_args if decode_tpl_args is not None else
+            self.template_args['decode']['default']) else False
 
         # Place a thumbnail image inline with the message body
         self.include_image = include_image
@@ -273,6 +312,30 @@ class NotifyOneSignal(NotifyBase):
                     'Detected OneSignal Player ID: %s' %
                     self.targets[OneSignalCategory.PLAYER][-1])
 
+        # Custom Data
+        self.custom_data = {}
+        if custom and isinstance(custom, dict):
+            if self.decode_tpl_args:
+                custom = decode_b64_dict(custom)
+
+            self.custom_data.update(custom)
+
+        elif custom:
+            msg = 'The specified OneSignal Custom Data ' \
+                  '({}) are not identified as a dictionary.'.format(custom)
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        # Postback Data
+        self.postback_data = {}
+        if postback and isinstance(postback, dict):
+            self.postback_data.update(postback)
+
+        elif postback:
+            msg = 'The specified OneSignal Postback Data ' \
+                  '({}) are not identified as a dictionary.'.format(postback)
+            self.logger.warning(msg)
+            raise TypeError(msg)
         return
 
     def send(self, body, title='', notify_type=NotifyType.INFO, **kwargs):
@@ -291,14 +354,9 @@ class NotifyOneSignal(NotifyBase):
 
         payload = {
             'app_id': self.app,
-
-            'headings': {
-                self.language: title if title else self.app_desc,
-            },
             'contents': {
                 self.language: body,
             },
-
             # Sending true wakes your app from background to run custom native
             # code (Apple interprets this as content-available=1).
             # Note: Not applicable if the app is in the "force-quit" state
@@ -307,6 +365,33 @@ class NotifyOneSignal(NotifyBase):
             'content_available': True,
         }
 
+        if self.template_id:
+            # Store template information
+            payload['template_id'] = self.template_id
+
+            if not self.use_contents:
+                # Only if a template is defined can contents be removed
+                del payload['contents']
+
+        # Set our data if defined
+        if self.custom_data:
+            payload.update({
+                'custom_data': self.custom_data,
+            })
+
+        # Set our postback data if defined
+        if self.postback_data:
+            payload.update({
+                'data': self.postback_data,
+            })
+
+        if title:
+            # Display our title if defined
+            payload.update({
+                'headings': {
+                    self.language: title,
+                }})
+
         if self.subtitle:
             payload.update({
                 'subtitle': {
@@ -314,9 +399,6 @@ class NotifyOneSignal(NotifyBase):
                 },
             })
 
-        if self.template_id:
-            payload['template_id'] = self.template_id
-
         # Acquire our large_icon image URL (if set)
         image_url = None if not self.include_image \
             else self.image_url(notify_type)
@@ -406,6 +488,25 @@ class NotifyOneSignal(NotifyBase):
         # Extend our parameters
         params.update(self.url_parameters(privacy=privacy, *args, **kwargs))
 
+        custom_data, needs_decoding = encode_b64_dict(self.custom_data)
+        # custom_data, needs_decoding = self.custom_data, False
+        # Save our template data
+        params.update(
+            {':{}'.format(k): v for k, v in custom_data.items()}
+        )
+
+        # Save our postback data
+        params.update(
+            {'+{}'.format(k): v for k, v in self.postback_data.items()})
+
+        if self.use_contents != self.template_args['contents']['default']:
+            params['contents'] = 'yes' if self.use_contents else 'no'
+
+        if (self.decode_tpl_args != self.template_args['decode']['default']
+                or needs_decoding):
+            params['decode'] = 'yes' if (self.decode_tpl_args or
+                                         needs_decoding) else 'no'
+
         return '{schema}://{tp_id}{app}@{apikey}/{targets}?{params}'.format(
             schema=self.secure_protocol,
             tp_id='{}:'.format(
@@ -485,6 +586,20 @@ class NotifyOneSignal(NotifyBase):
                     'batch',
                     NotifyOneSignal.template_args['batch']['default']))
 
+        # Get Use Contents Boolean (if set)
+        results['use_contents'] = \
+            parse_bool(
+                results['qsd'].get(
+                    'contents',
+                    NotifyOneSignal.template_args['contents']['default']))
+
+        # Get Use Contents Boolean (if set)
+        results['decode_tpl_args'] = \
+            parse_bool(
+                results['qsd'].get(
+                    'decode',
+                    NotifyOneSignal.template_args['decode']['default']))
+
         # The API Key is stored in the hostname
         results['apikey'] = NotifyOneSignal.unquote(results['host'])
 
@@ -516,4 +631,10 @@ class NotifyOneSignal(NotifyBase):
             results['language'] = \
                 NotifyOneSignal.unquote(results['qsd']['lang'])
 
+        # Store our custom data
+        results['custom'] = results['qsd:']
+
+        # Store our postback data
+        results['postback'] = results['qsd+']
+
         return results
diff -pruN 1.8.0-3/apprise/plugins/serverchan.py 1.8.1-1/apprise/plugins/serverchan.py
--- 1.8.0-3/apprise/plugins/serverchan.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/serverchan.py	2024-07-26 00:19:02.000000000 +0000
@@ -74,7 +74,7 @@ class NotifyServerChan(NotifyBase):
             'type': 'string',
             'private': True,
             'required': True,
-            'regex': (r'^[a-z0-9]+$', 'i'),
+            'regex': (r'^[a-z0-9-]+$', 'i'),
         },
     })
 
diff -pruN 1.8.0-3/apprise/plugins/sfr.py 1.8.1-1/apprise/plugins/sfr.py
--- 1.8.0-3/apprise/plugins/sfr.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/apprise/plugins/sfr.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,431 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+# For this to work correctly you need to have a valid SFR DMC service account
+# to whicthe API password can be generated. A "space" is also necessary
+# (space = a logical separation between clients), which will give you a
+# specific spaceId
+#
+# Expected credentials looks a little like this:
+# serviceId: 84920958892    - Random numbers
+# servicePassword: XxXXxXXx - Random characters
+# spaceId: 984348           - Random numbers
+#
+# 1. Visit https://www.sfr.fr/
+#
+# 2. Url will look like this
+#    https://www.dmc.sfr-sh.fr/DmcWS/1.5.8/JsonService/<apiGroup>/<apicall>
+
+import requests
+import json
+
+from .base import NotifyBase
+from ..common import NotifyType
+from ..locale import gettext_lazy as _
+from ..utils import is_phone_no
+from ..utils import parse_phone_no
+from ..url import PrivacyMode
+
+
+class NotifySFR(NotifyBase):
+    """
+    A wrapper for SFR French Telecom DMC API
+    """
+
+    # The default descriptive name associated with the Notification
+    service_name = _('Société Française du Radiotéléphone')
+
+    # The services URL
+    service_url = 'https://www.sfr.fr/'
+
+    # The default protocol
+    protocol = 'sfr'
+
+    # A URL that takes you to the setup/help of the specific protocol
+    setup_url = 'https://github.com/caronc/apprise/wiki/Notify_sfr'
+
+    # SFR api
+    notify_url = (
+        'https://www.dmc.sfr-sh.fr/DmcWS/1.5.8/JsonService/'
+        'MessagesUnitairesWS/addSingleCall'  # this is the actual api call
+    )
+
+    # The maximum length of the body
+    body_maxlen = 160
+
+    # A title can not be used for SMS Messages.  Setting this to zero will
+    # cause any title (if defined) to get placed into the message body.
+    title_maxlen = 0
+
+    # Define object templates
+    templates = (
+        '{schema}://{user}:{password}@{space_id}/{targets}',
+    )
+
+    # Define our tokens
+    template_tokens = dict(
+        NotifyBase.template_tokens, **{
+            'user': {
+                'name': _('Service ID'),
+                'type': 'string',
+                'required': True,
+            },
+            'password': {
+                'name': _('Service Password'),
+                'type': 'string',
+                'private': True,
+                'required': True,
+            },
+            'space_id': {
+                'name': _('Space ID'),
+                'type': 'string',
+                'private': True,
+                'required': True,
+            },
+            'target': {
+                'name': _('Recipient Phone Number'),
+                'type': 'string',
+                'regex': (r'^\+?[0-9\s)(+-]+$', 'i'),
+                'map_to': 'targets',
+            },
+            'targets': {
+                'name': _('Targets'),
+                'type': 'list:string',
+                'required': True,
+            },
+        }
+    )
+
+    # Define our template arguments
+    template_args = dict(
+        NotifyBase.template_args, **{
+            'lang': {
+                'name': _('Language'),
+                'type': 'string',
+                'default': 'fr_FR',
+                'required': True,
+            },
+            'sender': {
+                'name': _('Sender Name'),
+                'type': 'string',
+                'required': True,
+                'default': '',
+            },
+            'from': {
+                'alias_of': 'sender'
+            },
+            'media': {
+                'name': _('Media Type'),
+                'type': 'string',
+                'required': True,
+                'default': 'SMSUnicode',
+                'values': ['SMS', 'SMSLong', 'SMSUnicode', 'SMSUnicodeLong'],
+            },
+            'timeout': {
+                'name': _('Timeout'),
+                'type': 'int',
+                'default': 2880,
+                'required': False,
+            },
+            'voice': {
+                'name': _('TTS Voice'),
+                'type': 'string',
+                'default': 'claire08s',
+                'values': ['claire08s', 'laura8k'],
+                'required': False,
+            },
+            'to': {
+                'alias_of': 'targets',
+            },
+        }
+    )
+
+    def __init__(self, space_id=None, targets=None, lang=None, sender=None,
+                 media=None, timeout=None, voice=None, **kwargs):
+        """
+        Initialize SFR Object
+        """
+        super().__init__(**kwargs)
+
+        if not (self.user and self.password):
+            msg = 'A SFR user (serviceId) and password (servicePassword) ' \
+                  'combination was not provided.'
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        self.space_id = space_id
+        if not self.space_id:
+            msg = 'A SFR Space ID is required.'
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        self.voice = voice \
+            if voice else self.template_args['voice']['default']
+        self.lang = lang \
+            if lang else self.template_args['lang']['default']
+        self.media = media \
+            if media else self.template_args['media']['default']
+        self.sender = sender \
+            if sender else self.template_args['sender']['default']
+
+        # Set our Time to Live Flag
+        self.timeout = self.template_args['timeout']['default']
+        try:
+            self.timeout = int(timeout)
+
+        except (ValueError, TypeError):
+            # set default timeout
+            self.timeout = 2880
+            pass
+
+        # Parse our targets
+        self.targets = list()
+
+        for target in parse_phone_no(targets):
+            # Validate targets and drop bad ones:
+            result = is_phone_no(target)
+            if not result:
+                self.logger.warning(
+                    'Dropped invalid phone # '
+                    '({}) specified.'.format(target),
+                )
+                continue
+
+            # store valid phone number
+            self.targets.append(result['full'])
+
+        if not self.targets:
+            msg = ('No receiver phone number has been provided. Please '
+                   'provide as least one valid phone number.')
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        return
+
+    def send(self, body, title='', notify_type=NotifyType.INFO, **kwargs):
+        """
+        Perform the SFR notification
+        """
+
+        # error tracking (used for function return)
+        has_error = False
+
+        # Create a copy of the targets list
+        targets = list(self.targets)
+
+        # Construct the authentication JSON
+        auth_payload = json.dumps({
+            'serviceId': self.user,
+            'servicePassword': self.password,
+            'spaceId': self.space_id,
+            'lang': self.lang,
+        })
+
+        base_payload = {
+            # Can be 'SMS', 'SMSLong', 'SMSUnicode', or 'SMSUnicodeLong'
+            'media': self.media,
+            # Content of the message
+            'textMsg': body,
+            # Receiver's phone number (set below)
+            'to': None,
+            # Optional, default to ''
+            'from': self.sender,
+            # Optional, default 2880 minutes
+            'timeout': self.timeout,
+            # Optional, default to French voice
+            'ttsVoice': self.voice,
+        }
+
+        while len(targets):
+            # Get our target to notify
+            target = targets.pop(0)
+
+            # Prepare our target phone no
+            base_payload['to'] = target
+
+            # Always call throttle before any remote server i/o is made
+            self.throttle()
+
+            # Finalize our payload
+            payload = {
+                'authenticate': auth_payload,
+                'messageUnitaire': json.dumps(base_payload, ensure_ascii=True)
+            }
+
+            # Some Debug Logging
+            self.logger.debug('SFR POST URL: {} (cert_verify={})'.format(
+                self.notify_url, self.verify_certificate))
+            self.logger.debug('SFR Payload: {}' .format(payload))
+
+            try:
+                r = requests.post(
+                    self.notify_url,
+                    params=payload,
+                    verify=self.verify_certificate,
+                    timeout=self.request_timeout,
+                )
+
+                try:
+                    content = json.loads(r.content)
+
+                except (AttributeError, TypeError, ValueError):
+                    # ValueError = r.content is Unparsable
+                    # TypeError = r.content is None
+                    # AttributeError = r is None
+                    content = {}
+
+                # Check if the request was successfull
+                if r.status_code not in (
+                        requests.codes.ok,
+                        requests.codes.no_content,
+                ):
+                    # We had a problem
+                    status_str = \
+                        NotifySFR.http_response_code_lookup(
+                            r.status_code)
+
+                    self.logger.warning(
+                        'Failed to send SFR notification to {}: '
+                        '{}{}error={}.'.format(
+                            target,
+                            status_str,
+                            ', ' if status_str else '',
+                            r.status_code))
+
+                    self.logger.debug(
+                        'Response Details:\r\n{}'.format(r.content))
+
+                    # Mark our failure
+                    has_error = True
+                    continue
+
+                # SFR returns a code 200 even if the authentication fails
+                # It then indicates in the content['success'] field the
+                # Actual state of the transaction
+                if not content.get('success', False):
+                    self.logger.warning(
+                        'SFR Notification to {} was not sent by the server: '
+                        'server_error={}, fatal={}.'.format(
+                            target,
+                            content.get('errorCode', 'UNKNOWN'),
+                            content.get('fatal', 'True'),
+                        ))
+
+                    # Mark our failure
+                    has_error = True
+                    continue
+
+                self.logger.info(
+                    'Sent SFR notification to %s.' % target)
+
+            except requests.RequestException as e:
+                self.logger.warning(
+                    'A Connection error occurred sending SFR:%s '
+                    'notification.' % target
+                )
+                self.logger.debug('Socket Exception: %s' % str(e))
+
+                # Mark our failure
+                has_error = True
+                continue
+
+        return not has_error
+
+    def url(self, privacy=False, *args, **kwargs):
+        """
+        Returns the URL built dynamically based on specified arguments.
+        """
+        # Define any URL parameters
+        params = {
+            'from': self.sender,
+            'timeout': str(self.timeout),
+            'voice': self.voice,
+            'lang': self.lang,
+            'media': self.media,
+        }
+
+        # Extend our parameters
+        params.update(self.url_parameters(privacy=privacy, *args, **kwargs))
+
+        return '{schema}://{user}:{password}@{sid}/{targets}?{params}'.format(
+            schema=self.secure_protocol if self.secure else self.protocol,
+            user=self.user,
+            password=self.pprint(
+                self.password,
+                privacy,
+                mode=PrivacyMode.Secret,
+                safe='',
+            ),
+            sid=self.pprint(self.space_id, privacy, safe=''),
+            targets='/'.join(
+                [NotifySFR.quote(x, safe='') for x in self.targets]),
+            params=self.urlencode(params),
+        )
+
+    def __len__(self):
+        """
+        Returns the number of targets associated with this notification
+        """
+        return len(self.targets)
+
+    @staticmethod
+    def parse_url(url):
+        """
+        Parse the URL and return arguments required to initialize this plugin
+        """
+        # NotifyBase.parse_url() will make the initial parsing of your string
+        # very easy to use. It will tokenize the entire URL for you.  The
+        # tokens are then passed into your __init__() function you defined to
+        # generate you're object
+
+        results = NotifyBase.parse_url(url, verify_host=False)
+
+        if not results:
+            # We're done early as we couldn't load the results
+            return results
+
+        # Extract user and password
+        results['space_id'] = results.get('host')
+        results['targets'] = NotifySFR.split_path(results['fullpath'])
+
+        # Extract additional parameters
+        qsd = results.get('qsd', {})
+        results['sender'] = \
+            NotifySFR.unquote(qsd.get('sender', qsd.get('from')))
+        results['timeout'] = NotifySFR.unquote(qsd.get('timeout'))
+        results['voice'] = NotifySFR.unquote(qsd.get('voice'))
+        results['lang'] = NotifySFR.unquote(qsd.get('lang'))
+        results['media'] = NotifySFR.unquote(qsd.get('media'))
+
+        # Support the 'to' variable so that we can support rooms this way too
+        # The 'to' makes it easier to use yaml configuration
+        if 'to' in results['qsd'] and len(results['qsd']['to']):
+            results['targets'] += \
+                NotifySFR.parse_phone_no(results['qsd']['to'])
+
+        return results
diff -pruN 1.8.0-3/apprise/plugins/slack.py 1.8.1-1/apprise/plugins/slack.py
--- 1.8.0-3/apprise/plugins/slack.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/slack.py	2024-07-26 00:19:02.000000000 +0000
@@ -280,6 +280,40 @@ class NotifySlack(NotifyBase):
         },
     })
 
+    # Formatting requirements are defined here:
+    # https://api.slack.com/docs/message-formatting
+    _re_formatting_map = {
+        # New lines must become the string version
+        r'\r\*\n': '\\n',
+        # Escape other special characters
+        r'&': '&amp;',
+        r'<': '&lt;',
+        r'>': '&gt;',
+    }
+
+    # To notify a channel, one uses <!channel|channel>
+    _re_channel_support = re.compile(
+        r'(?P<match>(?:<|\&lt;)?[ \t]*'
+        r'!(?P<channel>[^| \n]+)'
+        r'(?:[ \t]*\|[ \t]*(?:(?P<val>[^\n]+?)[ \t]*)?(?:>|\&gt;)'
+        r'|(?:>|\&gt;)))', re.IGNORECASE)
+
+    # To notify a user by their ID, one uses <@U6TTX1F9R>
+    _re_user_id_support = re.compile(
+        r'(?P<match>(?:<|\&lt;)?[ \t]*'
+        r'@(?P<userid>[^| \n]+)'
+        r'(?:[ \t]*\|[ \t]*(?:(?P<val>[^\n]+?)[ \t]*)?(?:>|\&gt;)'
+        r'|(?:>|\&gt;)))', re.IGNORECASE)
+
+    # The markdown in slack isn't [desc](url), it's <url|desc>
+    #
+    # To accomodate this, we need to ensure we don't escape URLs that match
+    _re_url_support = re.compile(
+        r'(?P<match>(?:<|\&lt;)?[ \t]*'
+        r'(?P<url>(?:https?|mailto)://[^| \n]+)'
+        r'(?:[ \t]*\|[ \t]*(?:(?P<val>[^\n]+?)[ \t]*)?(?:>|\&gt;)'
+        r'|(?:>|\&gt;)))', re.IGNORECASE)
+
     def __init__(self, access_token=None, token_a=None, token_b=None,
                  token_c=None, targets=None, include_image=True,
                  include_footer=True, use_blocks=None, **kwargs):
@@ -344,39 +378,11 @@ class NotifySlack(NotifyBase):
                 None if self.mode is SlackMode.WEBHOOK
                 else self.default_notification_channel)
 
-        # Formatting requirements are defined here:
-        # https://api.slack.com/docs/message-formatting
-        self._re_formatting_map = {
-            # New lines must become the string version
-            r'\r\*\n': '\\n',
-            # Escape other special characters
-            r'&': '&amp;',
-            r'<': '&lt;',
-            r'>': '&gt;',
-        }
-
-        # To notify a channel, one uses <!channel|channel>
-        self._re_channel_support = re.compile(
-            r'(?P<match>(?:<|\&lt;)?[ \t]*'
-            r'!(?P<channel>[^| \n]+)'
-            r'(?:[ \t]*\|[ \t]*(?:(?P<val>[^\n]+?)[ \t]*)?(?:>|\&gt;)'
-            r'|(?:>|\&gt;)))', re.IGNORECASE)
-
-        # The markdown in slack isn't [desc](url), it's <url|desc>
-        #
-        # To accomodate this, we need to ensure we don't escape URLs that match
-        self._re_url_support = re.compile(
-            r'(?P<match>(?:<|\&lt;)?[ \t]*'
-            r'(?P<url>(?:https?|mailto)://[^| \n]+)'
-            r'(?:[ \t]*\|[ \t]*(?:(?P<val>[^\n]+?)[ \t]*)?(?:>|\&gt;)'
-            r'|(?:>|\&gt;)))', re.IGNORECASE)
-
         # Iterate over above list and store content accordingly
         self._re_formatting_rules = re.compile(
             r'(' + '|'.join(self._re_formatting_map.keys()) + r')',
             re.IGNORECASE,
         )
-
         # Place a thumbnail image inline with the message body
         self.include_image = include_image
 
@@ -478,6 +484,20 @@ class NotifySlack(NotifyBase):
                         body,
                         re.IGNORECASE)
 
+                # Support <@userid|desc>, <@channel> entries
+                for match in self._re_user_id_support.findall(body):
+                    # Swap back any ampersands previously updaated
+                    user = match[1].strip()
+                    desc = match[2].strip()
+
+                    # Update our string
+                    body = re.sub(
+                        re.escape(match[0]),
+                        '<@{user}|{desc}>'.format(user=user, desc=desc)
+                        if desc else '<@{user}>'.format(user=user),
+                        body,
+                        re.IGNORECASE)
+
                 # Support <url|desc>, <url> entries
                 for match in self._re_url_support.findall(body):
                     # Swap back any ampersands previously updaated
@@ -603,16 +623,17 @@ class NotifySlack(NotifyBase):
                             channel if channel[0] == '#' \
                             else '#{}'.format(channel)
 
-                # Store the valid and massaged payload that is recognizable by
-                # slack. This list is used for sending attachments later.
-                attach_channel_list.append(payload['channel'])
-
             response = self._send(url, payload)
             if not response:
                 # Handle any error
                 has_error = True
                 continue
 
+            # Store the valid channel or chat ID (for DMs) that will
+            # be accepted by Slack's attachment method later.
+            if response.get('channel'):
+                attach_channel_list.append(response.get('channel'))
+
             self.logger.info(
                 'Sent Slack notification{}.'.format(
                     ' to {}'.format(channel)
@@ -635,20 +656,57 @@ class NotifySlack(NotifyBase):
                     'Posting Slack attachment {}'.format(
                         attachment.url(privacy=True)))
 
-                # Prepare API Upload Payload
-                _payload = {
+                # Get the URL to which to upload the file.
+                # https://api.slack.com/methods/files.getUploadURLExternal
+                _params = {
                     'filename': attachment.name,
-                    'channels': ','.join(attach_channel_list)
+                    'length': len(attachment),
                 }
+                _url = self.api_url.format('files.getUploadURLExternal')
+                response = self._send(
+                    _url, {}, http_method='get', params=_params
+                )
+                if not (
+                    response and response.get('file_id')
+                    and response.get('upload_url')
+                ):
+                    self.logger.error('Could retrieve file upload URL.')
+                    # We failed to get an upload URL, take an early exit
+                    return False
 
-                # Our URL
-                _url = self.api_url.format('files.upload')
+                file_id = response.get('file_id')
+                upload_url = response.get('upload_url')
 
-                response = self._send(_url, _payload, attach=attachment)
-                if not (response and response.get('file') and
-                        response['file'].get('url_private')):
-                    # We failed to post our attachments, take an early exit
-                    return False
+                # Upload file
+                response = self._send(upload_url, {}, attach=attachment)
+
+                # Send file to channels
+                # https://api.slack.com/methods/files.completeUploadExternal
+                for channel_id in attach_channel_list:
+                    _payload = {
+                        'files': [{
+                            "id": file_id,
+                            "title": attachment.name,
+                        }],
+                        'channel_id': channel_id
+                    }
+                    _url = self.api_url.format('files.completeUploadExternal')
+                    response = self._send(_url, _payload)
+                    # Expected response
+                    # {
+                    #     "ok": true,
+                    #     "files": [
+                    #         {
+                    #             "id": "F123ABC456",
+                    #             "title": "slack-test"
+                    #         }
+                    #     ]
+                    # }
+                    if not (response and response.get('files')):
+                        self.logger.error('Failed to send file to channel.')
+                        # We failed to send the file to the channel,
+                        # take an early exit
+                        return False
 
         return not has_error
 
@@ -808,7 +866,8 @@ class NotifySlack(NotifyBase):
 
         return user_id
 
-    def _send(self, url, payload, attach=None, **kwargs):
+    def _send(self, url, payload, attach=None, http_method='post', params=None,
+              **kwargs):
         """
         Wrapper to the requests (post) object
         """
@@ -842,13 +901,15 @@ class NotifySlack(NotifyBase):
             if attach:
                 files = {'file': (attach.name, open(attach.path, 'rb'))}
 
-            r = requests.post(
+            r = requests.request(
+                http_method,
                 url,
                 data=payload if attach else dumps(payload),
                 headers=headers,
                 files=files,
                 verify=self.verify_certificate,
                 timeout=self.request_timeout,
+                params=params if params else None,
             )
 
             # Posts return a JSON string
@@ -866,11 +927,22 @@ class NotifySlack(NotifyBase):
             #   'ok': False,
             #   'error': 'not_in_channel',
             # }
-            #
-            # The text 'ok' is returned if this is a Webhook request
-            # So the below captures that as well.
-            status_okay = (response and response.get('ok', False)) \
-                if self.mode is SlackMode.BOT else r.content == b'ok'
+            status_okay = False
+            if self.mode is SlackMode.BOT:
+                status_okay = (
+                    (response and response.get('ok', False)) or
+                    # Responses for file uploads look like this
+                    # 'OK - <file length>'
+                    (
+                        r.content and
+                        isinstance(r.content, bytes) and
+                        b'OK' in r.content
+                    )
+                )
+            elif r.content == b'ok':
+                # The text 'ok' is returned if this is a Webhook request
+                # So the below captures that as well.
+                status_okay = True
 
             if r.status_code != requests.codes.ok or not status_okay:
                 # We had a problem
@@ -879,9 +951,9 @@ class NotifySlack(NotifyBase):
                         r.status_code, SLACK_HTTP_ERROR_MAP)
 
                 self.logger.warning(
-                    'Failed to send {}to Slack: '
+                    'Failed to send{} to Slack: '
                     '{}{}error={}.'.format(
-                        attach.name if attach else '',
+                        (' ' + attach.name) if attach else '',
                         status_str,
                         ', ' if status_str else '',
                         r.status_code))
@@ -913,53 +985,15 @@ class NotifySlack(NotifyBase):
             #   "username": "Apprise"
             # }
 
-            # File Attachment Responses look like this
+            # files.completeUploadExternal responses look like this:
             # {
-            #   "file": {
-            #     "channels": [],
-            #     "comments_count": 0,
-            #     "created": 1573617523,
-            #     "display_as_bot": false,
-            #     "editable": false,
-            #     "external_type": "",
-            #     "filetype": "png",
-            #     "groups": [],
-            #     "has_rich_preview": false,
-            #     "id": "FQJJLDAHM",
-            #     "image_exif_rotation": 1,
-            #     "ims": [],
-            #     "is_external": false,
-            #     "is_public": false,
-            #     "is_starred": false,
-            #     "mimetype": "image/png",
-            #     "mode": "hosted",
-            #     "name": "apprise-test.png",
-            #     "original_h": 640,
-            #     "original_w": 640,
-            #     "permalink": "https://{name}.slack.com/files/...
-            #     "permalink_public": "https://slack-files.com/...
-            #     "pretty_type": "PNG",
-            #     "public_url_shared": false,
-            #     "shares": {},
-            #     "size": 238810,
-            #     "thumb_160": "https://files.slack.com/files-tmb/...
-            #     "thumb_360": "https://files.slack.com/files-tmb/...
-            #     "thumb_360_h": 360,
-            #     "thumb_360_w": 360,
-            #     "thumb_480": "https://files.slack.com/files-tmb/...
-            #     "thumb_480_h": 480,
-            #     "thumb_480_w": 480,
-            #     "thumb_64": "https://files.slack.com/files-tmb/...
-            #     "thumb_80": "https://files.slack.com/files-tmb/...
-            #     "thumb_tiny": abcd...
-            #     "timestamp": 1573617523,
-            #     "title": "apprise-test",
-            #     "url_private": "https://files.slack.com/files-pri/...
-            #     "url_private_download": "https://files.slack.com/files-...
-            #     "user": "UADKLLMJT",
-            #     "username": ""
-            #   },
-            #   "ok": true
+            #     "ok": true,
+            #     "files": [
+            #         {
+            #             "id": "F123ABC456",
+            #             "title": "slack-test"
+            #         }
+            #     ]
             # }
         except requests.RequestException as e:
             self.logger.warning(
diff -pruN 1.8.0-3/apprise/plugins/splunk.py 1.8.1-1/apprise/plugins/splunk.py
--- 1.8.0-3/apprise/plugins/splunk.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/apprise/plugins/splunk.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,488 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+# Splunk On-Call
+# API: https://portal.victorops.com/public/api-docs.html
+# Main: https://www.splunk.com/en_us/products/on-call.html
+# Routing Keys https://help.victorops.com/knowledge-base/routing-keys/
+# Setup: https://help.victorops.com/knowledge-base/rest-endpoint-integration\
+#       -guide/
+
+
+import re
+import requests
+from json import dumps
+
+from .base import NotifyBase
+from ..common import NotifyType, NOTIFY_TYPES
+from ..utils import validate_regex
+from ..locale import gettext_lazy as _
+
+
+class SplunkAction:
+    """
+    Tracks the actions supported by Apprise Splunk Plugin
+
+    """
+    # Use mapping (specify :key=arg to over-ride)
+    MAP = 'map'
+
+    # Creates a timeline event but does not trigger an incident
+    INFO = 'info'
+
+    # Triggers a warning (possibly causing incident) in all cases
+    WARNING = 'warning'
+
+    # Triggers an incident in all cases
+    CRITICAL = 'critical'
+
+    # Acknowldege entity_id provided in all cases
+    ACKNOWLEDGE = 'acknowledgement'
+
+    # Recovery entity_id provided in all cases
+    RECOVERY = 'recovery'
+
+    # Resolve (aliase of Recover)
+    RESOLVE = 'resolve'
+
+
+# Define our Splunk Actions
+SPLUNK_ACTIONS = (
+    SplunkAction.MAP,
+    SplunkAction.INFO,
+    SplunkAction.ACKNOWLEDGE,
+    SplunkAction.WARNING,
+    SplunkAction.RECOVERY,
+    SplunkAction.RESOLVE,
+    SplunkAction.CRITICAL,
+)
+
+
+class SplunkMessageType:
+    """
+    Defines the supported splunk message types
+    """
+    # Triggers an incident
+    CRITICAL = 'CRITICAL'
+
+    # May trigger an incident, depending on your settings
+    WARNING = 'WARNING'
+
+    # Acks an incident
+    ACKNOWLEDGEMENT = 'ACKNOWLEDGEMENT'
+
+    # Creates a timeline event but does not trigger an incident
+    INFO = 'INFO'
+
+    # Resolves an incident
+    RECOVERY = 'RECOVERY'
+
+
+# Defines our supported message types
+SPLUNK_MESSAGE_TYPES = (
+    SplunkMessageType.CRITICAL,
+    SplunkMessageType.WARNING,
+    SplunkMessageType.ACKNOWLEDGEMENT,
+    SplunkMessageType.INFO,
+    SplunkMessageType.RECOVERY,
+)
+
+
+class NotifySplunk(NotifyBase):
+    """
+    A wrapper for Splunk Notifications
+    """
+
+    # The default descriptive name associated with the Notification
+    service_name = _('Splunk On-Call')
+
+    # The services URL
+    service_url = 'https://www.splunk.com/en_us/products/on-call.html'
+
+    # The default secure protocol
+    secure_protocol = ('splunk', 'victorops')
+
+    # A URL that takes you to the setup/help of the specific protocol
+    setup_url = 'https://github.com/caronc/apprise/wiki/Notify_splunk'
+
+    # Notification URL
+    notify_url = 'https://alert.victorops.com/integrations/generic/20131114/'\
+                 'alert/{apikey}/{routing_key}'
+
+    # Define object templates
+    templates = (
+        '{schema}://{routing_key}@{apikey}',
+        '{schema}://{routing_key}@{apikey}/{entity_id}',
+    )
+
+    # The title is not used
+    title_maxlen = 60
+
+    # body limit
+    body_maxlen = 400
+
+    # Defines our default message mapping
+    splunk_message_map = {
+        # Creates a timeline event but doesnot trigger an incident
+        NotifyType.INFO: SplunkMessageType.INFO,
+        # Resolves an incident
+        NotifyType.SUCCESS: SplunkMessageType.RECOVERY,
+        # May trigger an incident, depending on your settings
+        NotifyType.WARNING: SplunkMessageType.WARNING,
+        # Triggers an incident
+        NotifyType.FAILURE: SplunkMessageType.CRITICAL,
+    }
+
+    # Define our tokens; these are the minimum tokens required required to
+    # be passed into this function (as arguments). The syntax appends any
+    # previously defined in the base package and builds onto them
+    template_tokens = dict(NotifyBase.template_tokens, **{
+        'apikey': {
+            'name': _('API Key'),
+            'type': 'string',
+            'private': True,
+            'required': True,
+            'regex': (r'^[A-Z0-9_-]+$', 'i'),
+        },
+        'routing_key': {
+            'name': _('Target Routing Key'),
+            'type': 'string',
+            'required': True,
+            'regex': (r'^[A-Z0-9_-]+$', 'i'),
+        },
+        'entity_id': {
+            # Provide a value such as: "disk space/db01.mycompany.com"
+            'name': _('Entity ID'),
+            'type': 'string',
+        },
+    })
+
+    # Define our template arguments
+    template_args = dict(NotifyBase.template_args, **{
+        'apikey': {
+            'alias_of': 'apikey',
+        },
+        'routing_key': {
+            'alias_of': 'routing_key',
+        },
+        'route': {
+            'alias_of': 'routing_key',
+        },
+        'entity_id': {
+            'alias_of': 'entity_id',
+        },
+        'action': {
+            'name': _('Action'),
+            'type': 'choice:string',
+            'values': SPLUNK_ACTIONS,
+            'default': SPLUNK_ACTIONS[0],
+        }
+    })
+
+    # Define any kwargs we're using
+    template_kwargs = {
+        'mapping': {
+            'name': _('Action Mapping'),
+            'prefix': ':',
+        },
+    }
+
+    def __init__(self, apikey, routing_key, entity_id=None, action=None,
+                 mapping=None, **kwargs):
+        """
+        Initialize Splunk Object
+        """
+        super().__init__(**kwargs)
+
+        self.apikey = validate_regex(
+            apikey, *self.template_tokens['apikey']['regex'])
+        if not self.apikey:
+            msg = 'The Splunk API Key specified ({}) is invalid.'\
+                .format(apikey)
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        self.routing_key = validate_regex(
+            routing_key, *self.template_tokens['routing_key']['regex'])
+        if not self.routing_key:
+            msg = 'The Splunk Routing Key specified ({}) is invalid.'\
+                .format(routing_key)
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        if not (isinstance(entity_id, str)
+                and len(entity_id.strip(' \r\n\t\v/'))):
+            # Use routing key
+            self.entity_id = f"{self.app_id}/{self.routing_key}"
+
+        else:
+            # Assign what was defined:
+            self.entity_id = entity_id.strip(' \r\n\t\v/')
+
+        if isinstance(action, str) and action:
+            self.action = next(
+                (a for a in SPLUNK_ACTIONS if a.startswith(action)), None)
+            if self.action not in SPLUNK_ACTIONS:
+                msg = 'The Splunk action specified ({}) is invalid.'\
+                    .format(action)
+                self.logger.warning(msg)
+                raise TypeError(msg)
+        else:
+            self.action = self.template_args['action']['default'] \
+
+        # Store our mappings
+        self.mapping = self.splunk_message_map.copy()
+        if mapping and isinstance(mapping, dict):
+            for _k, _v in mapping.items():
+                # Get our mapping
+                k = next((t for t in NOTIFY_TYPES if t.startswith(_k)), None)
+                if not k:
+                    msg = 'The Splunk mapping key specified ({}) is invalid.'\
+                        .format(_k)
+                    self.logger.warning(msg)
+                    raise TypeError(msg)
+
+                _v_upper = _v.upper()
+                v = next((v for v in SPLUNK_MESSAGE_TYPES
+                          if v.startswith(_v_upper)), None)
+                if not v:
+                    msg = 'The Splunk mapping value (assigned to {}) ' \
+                          'specified ({}) is invalid.'.format(k, _v)
+                    self.logger.warning(msg)
+                    raise TypeError(msg)
+
+                # Update our mapping
+                self.mapping[k] = v
+
+        return
+
+    def send(self, body, title='', notify_type=NotifyType.INFO, **kwargs):
+        """
+        Send our notification
+        """
+
+        # prepare our headers
+        headers = {
+            'User-Agent': self.app_id,
+            'Content-Type': "application/json",
+        }
+
+        # Set up our message type
+        if self.action == SplunkAction.MAP:
+            # Use Mapping
+            message_type = self.mapping[notify_type]
+
+        elif self.action == SplunkAction.ACKNOWLEDGE:
+            # Always Acknowledge
+            message_type = SplunkMessageType.ACKNOWLEDGEMENT
+
+        elif self.action == SplunkAction.INFO:
+            # Creates a timeline event but does not trigger an incident
+            message_type = SplunkMessageType.INFO
+
+        elif self.action == SplunkAction.CRITICAL:
+            # Always create Incident
+            message_type = SplunkMessageType.CRITICAL
+
+        elif self.action == SplunkAction.WARNING:
+            # Always trigger warning (potentially creating incident)
+            message_type = SplunkMessageType.WARNING
+
+        else:  # self.action == SplunkAction.RECOVERY or SplunkAction.RESOLVE
+            # Always Recover
+            message_type = SplunkMessageType.RECOVERY
+
+        # Prepare our payload
+        payload = {
+            "entity_id": self.entity_id,
+            "message_type": message_type,
+            "entity_display_name": title if title else self.app_desc,
+            "state_message": body,
+            "monitoring_tool": self.app_id,
+        }
+
+        notify_url = self.notify_url.format(
+            apikey=self.apikey,
+            routing_key=self.routing_key)
+
+        self.logger.debug('Splunk GET URL: %s (cert_verify=%r)' % (
+            notify_url, self.verify_certificate))
+        self.logger.debug('Splunk Payload: %s' % str(payload))
+
+        # Always call throttle before any remote server i/o is made
+        self.throttle()
+
+        try:
+            r = requests.post(
+                notify_url,
+                data=dumps(payload).encode('utf-8'),
+                headers=headers,
+                verify=self.verify_certificate,
+                timeout=self.request_timeout,
+            )
+            # Sample Response
+            # {
+            #   "result" : "success",
+            #   "entity_id" : "disk space/db01.mycompany.com"
+            # }
+
+            if r.status_code != requests.codes.ok:
+                # We had a problem
+                status_str = \
+                    NotifySplunk.http_response_code_lookup(r.status_code)
+
+                self.logger.warning(
+                    'Failed to send Splunk notification: '
+                    '{}{}error={}.'.format(
+                        status_str,
+                        ', ' if status_str else '',
+                        r.status_code))
+
+                self.logger.debug('Response Details:\r\n{}'.format(r.content))
+
+                # Return; we're done
+                return False
+
+            else:
+                self.logger.info('Sent Splunk notification.')
+
+        except requests.RequestException as e:
+            self.logger.warning(
+                'A Connection error occurred sending Splunk '
+                'notification.')
+            self.logger.debug('Socket Exception: %s' % str(e))
+
+            # Return; we're done
+            return False
+
+        return True
+
+    def url(self, privacy=False, *args, **kwargs):
+        """
+        Returns the URL built dynamically based on specified arguments.
+        """
+
+        # Define any URL parameters
+        params = {
+            'action': self.action,
+        }
+
+        # Extend our parameters
+        params.update(self.url_parameters(privacy=privacy, *args, **kwargs))
+
+        # Append our assignment extra's into our parameters
+        params.update(
+            {':{}'.format(k): v for k, v in self.mapping.items()})
+
+        return '{schema}://{routing_key}@{apikey}/{entity_id}?{params}'.format(
+            schema=self.secure_protocol[0],
+            routing_key=self.routing_key,
+            entity_id='' if self.entity_id == self.routing_key
+            else self.entity_id,
+            apikey=self.pprint(self.apikey, privacy, safe=''),
+            params=NotifySplunk.urlencode(params),
+        )
+
+    @staticmethod
+    def parse_url(url):
+        """
+        Parses the URL and returns enough arguments that can allow
+        us to re-instantiate this object.
+
+        """
+
+        # parse_url already handles getting the `user` and `password` fields
+        # populated.
+        results = NotifyBase.parse_url(url, verify_host=False)
+        if not results:
+            # We're done early as we couldn't load the results
+            return results
+
+        # Entity ID
+        if 'entity_id' in results['qsd'] and len(results['qsd']['entity_id']):
+            results['entity_id'] = \
+                NotifySplunk.unquote(results['qsd']['entity_id'])
+        else:
+            results['entity_id'] = NotifySplunk.unquote(results['fullpath'])
+
+        # API Key
+        if 'apikey' in results['qsd'] and len(results['qsd']['apikey']):
+            results['apikey'] = NotifySplunk.unquote(results['qsd']['apikey'])
+
+        else:
+            results['apikey'] = NotifySplunk.unquote(results['host'])
+
+        # Routing Key
+        if 'routing_key' in results['qsd'] \
+                and len(results['qsd']['routing_key']):
+            results['routing_key'] = \
+                NotifySplunk.unquote(results['qsd']['routing_key'])
+
+        elif 'route' in results['qsd'] and len(results['qsd']['route']):
+            results['routing_key'] = \
+                NotifySplunk.unquote(results['qsd']['route'])
+
+        else:
+            results['routing_key'] = NotifySplunk.unquote(results['user'])
+
+        # Store our action (if defined)
+        if 'action' in results['qsd'] and len(results['qsd']['action']):
+            results['action'] = NotifySplunk.unquote(results['qsd']['action'])
+
+        # store any custom mapping defined
+        results['mapping'] = {NotifySplunk.unquote(x): NotifySplunk.unquote(y)
+                              for x, y in results['qsd:'].items()}
+
+        return results
+
+    @staticmethod
+    def parse_native_url(url):
+        """
+        Support https://alert.victorops.com/integrations/generic/20131114/ \
+                     alert/apikey/routing_key
+        """
+
+        result = re.match(
+            r'^https?://alert\.victorops\.com/integrations/generic/'
+            r'(?P<version>[0-9]+)/alert/(?P<apikey>[0-9a-z_-]+)'
+            r'(/(?P<routing_key>[^?/]+))'
+            r'(/(?P<entity_id>[^?]+))?/*'
+            r'(?P<params>\?.+)?$', url, re.I)
+
+        if result:
+            return NotifySplunk.parse_url(
+                '{schema}://{routing_key}@{apikey}/{entity_id}{params}'.format(
+                    schema=NotifySplunk.secure_protocol[0],
+                    apikey=result.group('apikey'),
+                    routing_key=result.group('routing_key'),
+                    entity_id='' if not result.group('entity_id')
+                    else result.group('entity_id'),
+                    params='' if not result.group('params')
+                    else result.group('params')))
+
+        return None
diff -pruN 1.8.0-3/apprise/plugins/streamlabs.py 1.8.1-1/apprise/plugins/streamlabs.py
--- 1.8.0-3/apprise/plugins/streamlabs.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/streamlabs.py	2024-07-26 00:19:02.000000000 +0000
@@ -323,7 +323,7 @@ class NotifyStreamlabs(NotifyBase):
 
             except requests.RequestException as e:
                 self.logger.warning(
-                    'A Connection error occured sending Streamlabs '
+                    'A Connection error occurred sending Streamlabs '
                     'alert.'
                 )
                 self.logger.debug('Socket Exception: %s' % str(e))
@@ -368,7 +368,7 @@ class NotifyStreamlabs(NotifyBase):
 
             except requests.RequestException as e:
                 self.logger.warning(
-                    'A Connection error occured sending Streamlabs '
+                    'A Connection error occurred sending Streamlabs '
                     'donation.'
                 )
                 self.logger.debug('Socket Exception: %s' % str(e))
diff -pruN 1.8.0-3/apprise/plugins/twilio.py 1.8.1-1/apprise/plugins/twilio.py
--- 1.8.0-3/apprise/plugins/twilio.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/plugins/twilio.py	2024-07-26 00:19:02.000000000 +0000
@@ -43,6 +43,7 @@
 # or consider purchasing a short-code from here:
 #    https://www.twilio.com/docs/glossary/what-is-a-short-code
 #
+import re
 import requests
 from json import loads
 
@@ -55,6 +56,22 @@ from ..utils import validate_regex
 from ..locale import gettext_lazy as _
 
 
+# Twilio Mode Detection
+MODE_DETECT_RE = re.compile(
+    r'\s*((?P<mode>[^:]+)\s*:\s*)?(?P<phoneno>.+)$', re.I)
+
+
+class TwilioMessageMode:
+    """
+    Twilio Message Mode
+    """
+    # SMS/MMS
+    TEXT = 'T'
+
+    # via WhatsApp
+    WHATSAPP = 'W'
+
+
 class NotifyTwilio(NotifyBase):
     """
     A wrapper for Twilio Notifications
@@ -117,14 +134,14 @@ class NotifyTwilio(NotifyBase):
             'name': _('From Phone No'),
             'type': 'string',
             'required': True,
-            'regex': (r'^\+?[0-9\s)(+-]+$', 'i'),
+            'regex': (r'^([a-z]+:)?\+?[0-9\s)(+-]+$', 'i'),
             'map_to': 'source',
         },
         'target_phone': {
             'name': _('Target Phone No'),
             'type': 'string',
             'prefix': '+',
-            'regex': (r'^[0-9\s)(+-]+$', 'i'),
+            'regex': (r'^([a-z]+:)?[0-9\s)(+-]+$', 'i'),
             'map_to': 'targets',
         },
         'short_code': {
@@ -190,7 +207,22 @@ class NotifyTwilio(NotifyBase):
         self.apikey = validate_regex(
             apikey, *self.template_args['apikey']['regex'])
 
-        result = is_phone_no(source, min_len=5)
+        # Detect mode
+        result = MODE_DETECT_RE.match(source)
+        if not result:
+            msg = 'The Account (From) Phone # or Short-code specified ' \
+                  '({}) is invalid.'.format(source)
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        # prepare our default mode to use for all numbers that follow in
+        # target definitions
+        self.default_mode = TwilioMessageMode.WHATSAPP \
+            if result.group('mode') and \
+            result.group('mode')[0].lower() == 'w' \
+            else TwilioMessageMode.TEXT
+
+        result = is_phone_no(result.group('phoneno'), min_len=5)
         if not result:
             msg = 'The Account (From) Phone # or Short-code specified ' \
                   '({}) is invalid.'.format(source)
@@ -220,18 +252,35 @@ class NotifyTwilio(NotifyBase):
         # Parse our targets
         self.targets = list()
 
-        for target in parse_phone_no(targets):
+        for entry in parse_phone_no(targets, prefix=True):
+            # Detect mode
+            # w: (or whatsapp:) will trigger whatsapp message otherwise
+            #   sms/mms as normal
+            result = MODE_DETECT_RE.match(entry)
+            mode = TwilioMessageMode.WHATSAPP if result.group('mode') and \
+                result.group('mode')[0].lower() == 'w' else self.default_mode
+
             # Validate targets and drop bad ones:
-            result = is_phone_no(target)
+            result = is_phone_no(result.group('phoneno'))
             if not result:
                 self.logger.warning(
                     'Dropped invalid phone # '
-                    '({}) specified.'.format(target),
+                    '({}) specified.'.format(entry),
+                )
+                continue
+
+            # We can't send twilio messages using short-codes as our source
+            if len(self.source) in (5, 6) and mode is \
+                    TwilioMessageMode.WHATSAPP:
+                self.logger.warning(
+                    'Dropped WhatsApp phone # '
+                    '({}) because source provided was a short-code.'.format(
+                        entry),
                 )
                 continue
 
             # store valid phone number
-            self.targets.append('+{}'.format(result['full']))
+            self.targets.append((mode, '+{}'.format(result['full'])))
 
         return
 
@@ -260,9 +309,8 @@ class NotifyTwilio(NotifyBase):
         # Prepare our payload
         payload = {
             'Body': body,
-            'From': self.source,
-
-            # The To gets populated in the loop below
+            # The From and To gets populated in the loop below
+            'From': None,
             'To': None,
         }
 
@@ -277,14 +325,20 @@ class NotifyTwilio(NotifyBase):
 
         if len(targets) == 0:
             # No sources specified, use our own phone no
-            targets.append(self.source)
+            targets.append((self.default_mode, self.source))
 
         while len(targets):
             # Get our target to notify
-            target = targets.pop(0)
+            (mode, target) = targets.pop(0)
 
             # Prepare our user
-            payload['To'] = target
+            if mode is TwilioMessageMode.TEXT:
+                payload['From'] = self.source
+                payload['To'] = target
+
+            else:  # WhatsApp support (via Twilio)
+                payload['From'] = f'whatsapp:{self.source}'
+                payload['To'] = f'whatsapp:{target}'
 
             # Some Debug Logging
             self.logger.debug('Twilio POST URL: {} (cert_verify={})'.format(
@@ -376,9 +430,13 @@ class NotifyTwilio(NotifyBase):
             sid=self.pprint(
                 self.account_sid, privacy, mode=PrivacyMode.Tail, safe=''),
             token=self.pprint(self.auth_token, privacy, safe=''),
-            source=NotifyTwilio.quote(self.source, safe=''),
+            source=NotifyTwilio.quote(
+                self.source if self.default_mode is TwilioMessageMode.TEXT
+                else 'w:{}'.format(self.source), safe=''),
             targets='/'.join(
-                [NotifyTwilio.quote(x, safe='') for x in self.targets]),
+                [NotifyTwilio.quote(
+                    x[1] if x[0] is TwilioMessageMode.TEXT
+                    else 'w:{}'.format(x[1]), safe='') for x in self.targets]),
             params=NotifyTwilio.urlencode(params))
 
     def __len__(self):
@@ -442,6 +500,6 @@ class NotifyTwilio(NotifyBase):
         # The 'to' makes it easier to use yaml configuration
         if 'to' in results['qsd'] and len(results['qsd']['to']):
             results['targets'] += \
-                NotifyTwilio.parse_phone_no(results['qsd']['to'])
+                NotifyTwilio.parse_phone_no(results['qsd']['to'], prefix=True)
 
         return results
diff -pruN 1.8.0-3/apprise/plugins/workflows.py 1.8.1-1/apprise/plugins/workflows.py
--- 1.8.0-3/apprise/plugins/workflows.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/apprise/plugins/workflows.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,565 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+# To use this plugin, you need to create a MS Teams Azure Webhook Workflow:
+#  https://support.microsoft.com/en-us/office/browse-and-add-workflows-\
+#       in-microsoft-teams-4998095c-8b72-4b0e-984c-f2ad39e6ba9a
+
+# Your webhook will look somthing like this:
+# https://prod-161.westeurope.logic.azure.com:443/\
+#       workflows/643e69f83c8944438d68119179a10a64/triggers/manual/\
+#       paths/invoke?api-version=2016-06-01&sp=%2Ftriggers%2Fmanual%2Frun&\
+#       sv=1.0&sig=KODuebWbDGYFr0z0eu-6Rj8aUKz7108W3wrNJZxFE5A
+#
+# Yes... The URL is that big... But it looks like this (greatly simplified):
+# https://HOST:PORT/workflows/ABCD/triggers/manual/path/...sig=DEFG
+#          ^    ^                ^                              ^
+#          |    |                |                              |
+#  These are important <---------^------------------------------^
+#
+#
+# Apprise can support this webhook as is (directly passed into it)
+# Alternatively it can be shortend to:
+
+# These 3 tokens need to be placed in the URL after the Team
+#   workflows://HOST:PORT/ABCD/DEFG/
+#
+
+import re
+import requests
+import json
+from json.decoder import JSONDecodeError
+
+from .base import NotifyBase
+from ..common import NotifyImageSize
+from ..common import NotifyType
+from ..common import NotifyFormat
+from ..utils import parse_bool
+from ..utils import validate_regex
+from ..utils import apply_template
+from ..utils import TemplateType
+from ..apprise_attachment import AppriseAttachment
+from ..locale import gettext_lazy as _
+
+
+class NotifyWorkflows(NotifyBase):
+    """
+    A wrapper for Microsoft Workflows (MS Teams) Notifications
+    """
+
+    # The default descriptive name associated with the Notification
+    service_name = 'Power Automate / Workflows (for MSTeams)'
+
+    # The services URL
+    service_url = 'https://www.microsoft.com/power-platform/' \
+        'products/power-automate'
+
+    # The default secure protocol
+    secure_protocol = ('workflow', 'workflows')
+
+    # A URL that takes you to the setup/help of the specific protocol
+    setup_url = 'https://github.com/caronc/apprise/wiki/Notify_workflows'
+
+    # Allows the user to specify the NotifyImageSize object
+    image_size = NotifyImageSize.XY_32
+
+    # The maximum allowable characters allowed in the body per message
+    body_maxlen = 1000
+
+    # Default Notification Format
+    notify_format = NotifyFormat.MARKDOWN
+
+    # There is no reason we should exceed 35KB when reading in a JSON file.
+    # If it is more than this, then it is not accepted
+    max_workflows_template_size = 35000
+
+    # Adaptive Card Version
+    adaptive_card_version = '1.4'
+
+    # Define object templates
+    templates = (
+        '{schema}://{host}/{workflow}/{signature}',
+        '{schema}://{host}:{port}/{workflow}/{signature}',
+    )
+
+    # Define our template tokens
+    template_tokens = dict(NotifyBase.template_tokens, **{
+        'host': {
+            'name': _('Hostname'),
+            'type': 'string',
+            'required': True,
+        },
+        'port': {
+            'name': _('Port'),
+            'type': 'int',
+            'min': 1,
+            'max': 65535,
+        },
+        # workflow identifier
+        'workflow': {
+            'name': _('Workflow ID'),
+            'type': 'string',
+            'private': True,
+            'required': True,
+            'regex': (r'^[A-Z0-9_-]+$', 'i'),
+        },
+        # Signature
+        'signature': {
+            'name': _('Signature'),
+            'type': 'string',
+            'private': True,
+            'required': True,
+            'regex': (r'^[a-z0-9_-]+$', 'i'),
+        },
+    })
+
+    # Define our template arguments
+    template_args = dict(NotifyBase.template_args, **{
+        'id': {
+            'alias_of': 'workflow',
+        },
+        'image': {
+            'name': _('Include Image'),
+            'type': 'bool',
+            'default': True,
+            'map_to': 'include_image',
+        },
+        'wrap': {
+            'name': _('Wrap Text'),
+            'type': 'bool',
+            'default': True,
+            'map_to': 'wrap',
+        },
+        'template': {
+            'name': _('Template Path'),
+            'type': 'string',
+            'private': True,
+        },
+        # Below variable shortforms are taken from the Workflows webhook
+        # for consistency
+        'sig': {
+            'alias_of': 'signature',
+        },
+        'ver': {
+            'name': _('API Version'),
+            'type': 'string',
+            'default': '2016-06-01',
+            'map_to': 'version',
+        },
+        'api-version': {
+            'alias_of': 'ver'
+        },
+    })
+
+    # Define our token control
+    template_kwargs = {
+        'tokens': {
+            'name': _('Template Tokens'),
+            'prefix': ':',
+        },
+    }
+
+    def __init__(self, workflow, signature, include_image=None,
+                 version=None, template=None, tokens=None, wrap=None,
+                 **kwargs):
+        """
+        Initialize Microsoft Workflows Object
+
+        """
+        super().__init__(**kwargs)
+
+        self.workflow = validate_regex(
+            workflow, *self.template_tokens['workflow']['regex'])
+        if not self.workflow:
+            msg = 'An invalid Workflows ID ' \
+                  '({}) was specified.'.format(workflow)
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        self.signature = validate_regex(
+            signature, *self.template_tokens['signature']['regex'])
+        if not self.signature:
+            msg = 'An invalid Signature ' \
+                  '({}) was specified.'.format(signature)
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        # Place a thumbnail image inline with the message body
+        self.include_image = True if (
+            include_image if include_image is not None else
+            self.template_args['image']['default']) else False
+
+        # Wrap Text
+        self.wrap = True if (
+            wrap if wrap is not None else
+            self.template_args['wrap']['default']) else False
+
+        # Our template object is just an AppriseAttachment object
+        self.template = AppriseAttachment(asset=self.asset)
+        if template:
+            # Add our definition to our template
+            self.template.add(template)
+            # Enforce maximum file size
+            self.template[0].max_file_size = self.max_workflows_template_size
+
+        # Prepare Version
+        self.api_version = version if version is not None \
+            else self.template_args['ver']['default']
+
+        # Template functionality
+        self.tokens = {}
+        if isinstance(tokens, dict):
+            self.tokens.update(tokens)
+
+        elif tokens:
+            msg = 'The specified Workflows Template Tokens ' \
+                  '({}) are not identified as a dictionary.'.format(tokens)
+            self.logger.warning(msg)
+            raise TypeError(msg)
+
+        # else:  NoneType - this is okay
+        return
+
+    def gen_payload(self, body, title='', notify_type=NotifyType.INFO,
+                    **kwargs):
+        """
+        This function generates our payload whether it be the generic one
+        Apprise generates by default, or one provided by a specified
+        external template.
+        """
+
+        # Acquire our to-be footer icon if configured to do so
+        image_url = None if not self.include_image \
+            else self.image_url(notify_type)
+
+        body_content = []
+        if image_url:
+            body_content.append({
+                "type": "Image",
+                "url": image_url,
+                "height": "32px",
+                "altText": notify_type,
+            })
+
+        if title:
+            body_content.append({
+                "type": "TextBlock",
+                "text": f'{title}',
+                "style": "heading",
+                "weight": "Bolder",
+                "size": "Large",
+                "id": "title",
+            })
+
+        body_content.append({
+            "type": "TextBlock",
+            "text": body,
+            "style": "default",
+            "wrap": self.wrap,
+            "id": "body",
+        })
+
+        if not self.template:
+            # By default we use a generic working payload if there was
+            # no template specified
+            schema = "http://adaptivecards.io/schemas/adaptive-card.json"
+            payload = {
+                "type": "message",
+                "attachments": [
+                    {
+                        "contentType":
+                        "application/vnd.microsoft.card.adaptive",
+                        "contentUrl": None,
+                        "content": {
+                            "$schema": schema,
+                            "type": "AdaptiveCard",
+                            "version": self.adaptive_card_version,
+                            "body": body_content,
+                            # Additionally
+                            "msteams": {"width": "full"},
+                        }
+                    }
+                ]
+            }
+
+            return payload
+
+        # If our code reaches here, then we generate ourselves the payload
+        template = self.template[0]
+        if not template:
+            # We could not access the attachment
+            self.logger.error(
+                'Could not access Workflow template {}.'.format(
+                    template.url(privacy=True)))
+            return False
+
+        # Take a copy of our token dictionary
+        tokens = self.tokens.copy()
+
+        # Apply some defaults template values
+        tokens['app_body'] = body
+        tokens['app_title'] = title
+        tokens['app_type'] = notify_type
+        tokens['app_id'] = self.app_id
+        tokens['app_desc'] = self.app_desc
+        tokens['app_color'] = self.color(notify_type)
+        tokens['app_image_url'] = image_url
+        tokens['app_url'] = self.app_url
+
+        # Enforce Application mode
+        tokens['app_mode'] = TemplateType.JSON
+
+        try:
+            with open(template.path, 'r') as fp:
+                content = json.loads(apply_template(fp.read(), **tokens))
+
+        except (OSError, IOError):
+            self.logger.error(
+                'MSTeam template {} could not be read.'.format(
+                    template.url(privacy=True)))
+            return None
+
+        except JSONDecodeError as e:
+            self.logger.error(
+                'MSTeam template {} contains invalid JSON.'.format(
+                    template.url(privacy=True)))
+            self.logger.debug('JSONDecodeError: {}'.format(e))
+            return None
+
+        return content
+
+    def send(self, body, title='', notify_type=NotifyType.INFO, **kwargs):
+        """
+        Perform Microsoft Teams Notification
+        """
+
+        headers = {
+            'User-Agent': self.app_id,
+            'Content-Type': 'application/json',
+        }
+
+        params = {
+            'api-version': self.api_version,
+            'sp': '/triggers/manual/run',
+            'sv': '1.0',
+            'sig': self.signature,
+        }
+
+        notify_url = 'https://{host}{port}/workflows/{workflow}/' \
+            'triggers/manual/paths/invoke'.format(
+                host=self.host,
+                port='' if not self.port else f':{self.port}',
+                workflow=self.workflow)
+
+        # Generate our payload if it's possible
+        payload = self.gen_payload(
+            body=body, title=title, notify_type=notify_type, **kwargs)
+        if not payload:
+            # No need to present a reason; that will come from the
+            # gen_payload() function itself
+            return False
+
+        self.logger.debug('Workflows POST URL: %s (cert_verify=%r)' % (
+            notify_url, self.verify_certificate,
+        ))
+        self.logger.debug('Workflows Payload: %s' % str(payload))
+
+        # Always call throttle before any remote server i/o is made
+        self.throttle()
+        try:
+            r = requests.post(
+                notify_url,
+                params=params,
+                data=json.dumps(payload),
+                headers=headers,
+                verify=self.verify_certificate,
+                timeout=self.request_timeout,
+            )
+            if r.status_code not in (
+                    requests.codes.ok, requests.codes.accepted):
+                # We had a problem
+                status_str = \
+                    NotifyWorkflows.http_response_code_lookup(r.status_code)
+
+                self.logger.warning(
+                    'Failed to send Workflows notification: '
+                    '{}{}error={}.'.format(
+                        status_str,
+                        ', ' if status_str else '',
+                        r.status_code))
+
+                self.logger.debug(
+                    'Response Details:\r\n{}'.format(r.content))
+
+                # We failed
+                return False
+
+            else:
+                self.logger.info('Sent Workflows notification.')
+
+        except requests.RequestException as e:
+            self.logger.warning(
+                'A Connection error occurred sending Workflows notification.')
+            self.logger.debug('Socket Exception: %s' % str(e))
+
+            # We failed
+            return False
+
+        return True
+
+    def url(self, privacy=False, *args, **kwargs):
+        """
+        Returns the URL built dynamically based on specified arguments.
+        """
+
+        # Define any URL parameters
+        params = {
+            'image': 'yes' if self.include_image else 'no',
+            'wrap': 'yes' if self.wrap else 'no',
+        }
+
+        if self.template:
+            params['template'] = NotifyWorkflows.quote(
+                self.template[0].url(), safe='')
+
+        # Store our version if it differs from default
+        if self.api_version != self.template_args['ver']['default']:
+            params['ver'] = self.api_version
+
+        # Extend our parameters
+        params.update(self.url_parameters(privacy=privacy, *args, **kwargs))
+        # Store any template entries if specified
+        params.update({':{}'.format(k): v for k, v in self.tokens.items()})
+
+        return '{schema}://{host}{port}/{workflow}/{signature}/' \
+            '?{params}'.format(
+                schema=self.secure_protocol[0],
+                host=self.host,
+                port='' if not self.port else f':{self.port}',
+                workflow=self.pprint(self.workflow, privacy, safe=''),
+                signature=self.pprint(self.signature, privacy, safe=''),
+                params=NotifyWorkflows.urlencode(params),
+            )
+
+    @staticmethod
+    def parse_url(url):
+        """
+        Parses the URL and returns enough arguments that can allow
+        us to re-instantiate this object.
+
+        """
+
+        results = NotifyBase.parse_url(url)
+        if not results:
+            # We're done early as we couldn't load the results
+            return results
+
+        # store values if provided
+        entries = NotifyWorkflows.split_path(results['fullpath'])
+
+        # Display image?
+        results['include_image'] = parse_bool(results['qsd'].get(
+            'image', NotifyWorkflows.template_args['image']['default']))
+
+        # Wrap Text?
+        results['wrap'] = parse_bool(results['qsd'].get(
+            'wrap', NotifyWorkflows.template_args['wrap']['default']))
+
+        # Template Handling
+        if 'template' in results['qsd'] and results['qsd']['template']:
+            results['template'] = \
+                NotifyWorkflows.unquote(results['qsd']['template'])
+
+        if 'workflow' in results['qsd'] and results['qsd']['workflow']:
+            results['workflow'] = \
+                NotifyWorkflows.unquote(results['qsd']['workflow'])
+
+        elif 'id' in results['qsd'] and results['qsd']['id']:
+            results['workflow'] = \
+                NotifyWorkflows.unquote(results['qsd']['id'])
+
+        else:
+            results['workflow'] = None if not entries \
+                else NotifyWorkflows.unquote(entries.pop(0))
+
+        # Signature
+        if 'signature' in results['qsd'] and results['qsd']['signature']:
+            results['signature'] = \
+                NotifyWorkflows.unquote(results['qsd']['signature'])
+
+        elif 'sig' in results['qsd'] and results['qsd']['sig']:
+            results['signature'] = \
+                NotifyWorkflows.unquote(results['qsd']['sig'])
+
+        else:
+            # Read information from path
+            results['signature'] = None if not entries \
+                else NotifyWorkflows.unquote(entries.pop(0))
+
+        # Version
+        if 'api-version' in results['qsd'] and results['qsd']['api-version']:
+            results['version'] = \
+                NotifyWorkflows.unquote(results['qsd']['api-version'])
+
+        elif 'ver' in results['qsd'] and results['qsd']['ver']:
+            results['version'] = \
+                NotifyWorkflows.unquote(results['qsd']['ver'])
+
+        # Store our tokens
+        results['tokens'] = results['qsd:']
+
+        return results
+
+    @staticmethod
+    def parse_native_url(url):
+        """
+        Support parsing the webhook straight out of workflows
+            https://HOST:443/workflows/WORKFLOWID/triggers/manual/paths/invoke
+        """
+
+        # Match our workflows webhook URL and re-assemble
+        result = re.match(
+            r'^https?://(?P<host>[A-Z0-9_.-]+)'
+            r'(?P<port>:[1-9][0-9]{0,5})?'
+            r'/workflows/'
+            r'(?P<workflow>[A-Z0-9_-]+)'
+            r'/triggers/manual/paths/invoke/?'
+            r'(?P<params>\?.+)$', url, re.I)
+
+        if result:
+            # Construct our URL
+            return NotifyWorkflows.parse_url(
+                '{schema}://{host}{port}/{workflow}'
+                '/{params}'.format(
+                    schema=NotifyWorkflows.secure_protocol[0],
+                    host=result.group('host'),
+                    port='' if not result.group('port')
+                    else result.group('port'),
+                    workflow=result.group('workflow'),
+                    params=result.group('params')))
+        return None
diff -pruN 1.8.0-3/apprise/url.py 1.8.1-1/apprise/url.py
--- 1.8.0-3/apprise/url.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/url.py	2024-07-26 00:19:02.000000000 +0000
@@ -577,7 +577,7 @@ class URLBase:
         return content
 
     @staticmethod
-    def parse_phone_no(content, unquote=True):
+    def parse_phone_no(content, unquote=True, prefix=False):
         """A wrapper to utils.parse_phone_no() with unquoting support
 
         Parses a specified set of data and breaks it into a list.
@@ -600,7 +600,7 @@ class URLBase:
                 # Nothing further to do
                 return []
 
-        content = parse_phone_no(content)
+        content = parse_phone_no(content, prefix=prefix)
 
         return content
 
diff -pruN 1.8.0-3/apprise/utils.py 1.8.1-1/apprise/utils.py
--- 1.8.0-3/apprise/utils.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/apprise/utils.py	2024-07-26 00:19:02.000000000 +0000
@@ -25,13 +25,15 @@
 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
-
+import copy
 import re
 import sys
 import json
 import contextlib
 import os
 import locale
+import typing
+import base64
 from itertools import chain
 from os.path import expanduser
 from functools import reduce
@@ -174,6 +176,11 @@ IS_PHONE_NO = re.compile(r'^\+?(?P<phone
 PHONE_NO_DETECTION_RE = re.compile(
     r'\s*([+(\s]*[0-9][0-9()\s-]+[0-9])(?=$|[\s,+(]+[0-9])', re.I)
 
+# Support for prefix: (string followed by colon) infront of phone no
+PHONE_NO_WPREFIX_DETECTION_RE = re.compile(
+    r'\s*((?:[a-z]+:)?[+(\s]*[0-9][0-9()\s-]+[0-9])'
+    r'(?=$|(?:[a-z]+:)?[\s,+(]+[0-9])', re.I)
+
 # A simple verification check to make sure the content specified
 # rougly conforms to a ham radio call sign before we parse it further
 IS_CALL_SIGN = re.compile(
@@ -939,7 +946,7 @@ def parse_bool(arg, default=False):
     return bool(arg)
 
 
-def parse_phone_no(*args, store_unparseable=True, **kwargs):
+def parse_phone_no(*args, store_unparseable=True, prefix=False, **kwargs):
     """
     Takes a string containing phone numbers separated by comma's and/or spaces
     and returns a list.
@@ -948,7 +955,8 @@ def parse_phone_no(*args, store_unparsea
     result = []
     for arg in args:
         if isinstance(arg, str) and arg:
-            _result = PHONE_NO_DETECTION_RE.findall(arg)
+            _result = (PHONE_NO_DETECTION_RE if not prefix
+                       else PHONE_NO_WPREFIX_DETECTION_RE).findall(arg)
             if _result:
                 result += _result
 
@@ -966,7 +974,7 @@ def parse_phone_no(*args, store_unparsea
         elif isinstance(arg, (set, list, tuple)):
             # Use recursion to handle the list of phone numbers
             result += parse_phone_no(
-                *arg, store_unparseable=store_unparseable)
+                *arg, store_unparseable=store_unparseable, prefix=prefix)
 
     return result
 
@@ -1523,7 +1531,7 @@ def environ(*remove, **update):
             locale.setlocale(locale.LC_ALL, loc_orig)
 
         except locale.Error:
-            # Thrown in py3.6
+            # Handle this case
             pass
 
 
@@ -1594,3 +1602,35 @@ def dict_full_update(dict1, dict2):
 
     _merge(dict1, dict2)
     return
+
+
+def decode_b64_dict(di: dict) -> dict:
+    di = copy.deepcopy(di)
+    for k, v in di.items():
+        if not isinstance(v, str) or not v.startswith("b64:"):
+            continue
+        try:
+            parsed_v = base64.b64decode(v[4:])
+            parsed_v = json.loads(parsed_v)
+        except Exception:
+            parsed_v = v
+        di[k] = parsed_v
+    return di
+
+
+def encode_b64_dict(
+        di: dict
+) -> typing.Tuple[dict, bool]:
+    di = copy.deepcopy(di)
+    needs_decoding = False
+    for k, v in di.items():
+        if isinstance(v, str):
+            continue
+        try:
+            encoded = base64.urlsafe_b64encode(json.dumps(v).encode())
+            encoded = "b64:{}".format(encoded.decode())
+            needs_decoding = True
+        except Exception:
+            encoded = str(v)
+        di[k] = encoded
+    return di, needs_decoding
diff -pruN 1.8.0-3/bin/README.md 1.8.1-1/bin/README.md
--- 1.8.0-3/bin/README.md	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/bin/README.md	2024-07-26 00:19:02.000000000 +0000
@@ -52,9 +52,6 @@ export PATH="$(pwd)/bin:$PATH"
 
 Apprise is also packaged for Redhat/Fedora as an RPM. To verify this processs works correctly an additional tool called `build-rpm.sh` is provided.  It's best tested using the Docker environments:
    ```bash
-   # To test with el8; do the following:
-   docker-compose run --rm rpmbuild.el8 build-rpm.sh
-
    # To test with el9; do the following:
    docker-compose run --rm rpmbuild.el9 build-rpm.sh
 
diff -pruN 1.8.0-3/debian/changelog 1.8.1-1/debian/changelog
--- 1.8.0-3/debian/changelog	2024-07-06 04:03:13.000000000 +0000
+++ 1.8.1-1/debian/changelog	2024-08-01 00:25:12.000000000 +0000
@@ -1,3 +1,10 @@
+apprise (1.8.1-1) unstable; urgency=medium
+
+  * New upstream version 1.8.1
+  * debian/patches/001.fix_manual.patch: Update to new version
+
+ -- Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>  Wed, 31 Jul 2024 21:25:12 -0300
+
 apprise (1.8.0-3) unstable; urgency=medium
 
   * Bug opened mistakenly (Closes: #1061783)
diff -pruN 1.8.0-3/debian/patches/001.fix_manual.patch 1.8.1-1/debian/patches/001.fix_manual.patch
--- 1.8.0-3/debian/patches/001.fix_manual.patch	2024-07-06 04:03:13.000000000 +0000
+++ 1.8.1-1/debian/patches/001.fix_manual.patch	2024-08-01 00:25:12.000000000 +0000
@@ -6,45 +6,39 @@ Index: apprise/packaging/man/apprise.1
 ===================================================================
 --- apprise.orig/packaging/man/apprise.1
 +++ apprise/packaging/man/apprise.1
-@@ -1,4 +1,4 @@
--.\" generated with Ronn/v0.7.3
-+Regardless.\" generated with Ronn/v0.7.3
- .\" http://github.com/rtomayko/ronn/tree/0.7.3
- .
- .TH "APPRISE" "1" "March 2024" "Chris Caron <lead2gold@gmail.com>" ""
-@@ -109,7 +109,7 @@ return characters prior to the delivery
+@@ -71,7 +71,7 @@ return characters prior to the delivery
+ \fB3\fR if there was one or more Apprise Service URLs successfully loaded but none could be notified due to user filtering (via tags)\.
  .IP "" 0
- .
  .SH "SERVICE URLS"
 -There are to many service URL and combinations to list here\. It\'s best to visit the Apprise GitHub page \fIhttps://github\.com/caronc/apprise/wiki#notification\-services\fR and see what\'s available\.
-+There are to many service URL and combinations to list here\. It(aqs best to visit the Apprise GitHub page \fIhttps://github\.com/caronc/apprise/wiki#notification\-services\fR and see what\(aqs available\.
- .
++There are to many service URL and combinations to list here\. It\ (aqs best to visit the Apprise GitHub page \fIhttps://github\.com/caronc/apprise/wiki#notification\-services\fR and see what\(aqs available\.
  .SH "EXAMPLES"
  Send a notification to as many servers as you want to specify as you can easily chain them together:
-@@ -127,7 +127,7 @@ $ apprise \-vv \-t "my title" \-b "my no
+ .IP "" 4
+@@ -82,7 +82,7 @@ $ apprise \-vv \-t "my title" \-b "my no
+ .fi
  .IP "" 0
- .
  .P
 -If you don\'t specify a \fB\-\-body\fR (\fB\-b\fR) then stdin is used allowing you to use the tool as part of your every day administration:
 +If you don\(aqt specify a \fB\-\-body\fR (\fB\-b\fR) then stdin is used allowing you to use the tool as part of your every day administration:
- .
  .IP "" 4
- .
-@@ -184,7 +184,7 @@ $ apprise \-vv \-t "School Assignment" \
+ .nf
+ $ cat /proc/cpuinfo | apprise \-vv \-t "cpu info" \e
+@@ -115,7 +115,7 @@ $ apprise \-vv \-t "School Assignment" \
+ .fi
  .IP "" 0
- .
  .SH "CUSTOM PLUGIN/NOTIFICATIONS"
 -Apprise can additionally allow you to define your own custom \fBschema://\fR entries that you can trigger on and call services you\'ve defined\.
-+Apprise can additionally allow you to define your own custom \fBschema://\fR entries that you can trigger on and call services you\(aqve defined\.
- .
++Apprise can additionally allow you to define your own custom \fBschema://\fR entries that you can trigger on and call services you\ (aqve defined\.
  .P
  By default \fBapprise\fR looks in the following local locations for custom plugin files and loads them:
-@@ -224,7 +224,7 @@ def my_wrapper(body, title, notify_type,
+ .IP "" 4
+@@ -142,7 +142,7 @@ def my_wrapper(body, title, notify_type,
+ .fi
  .IP "" 0
- .
  .SH "CONFIGURATION"
 -A configuration file can be in the format of either \fBTEXT\fR or \fBYAML\fR where [TEXT][textconfig] is the easiest and most ideal solution for most users\. However YAML \fIhttps://github\.com/caronc/apprise/wiki/config_yaml\fR configuration files grants the user a bit more leverage and access to some of the internal features of Apprise\. Reguardless of which format you choose, both provide the users the ability to leverage \fBtagging\fR which adds a more rich and powerful notification environment\.
 +A configuration file can be in the format of either \fBTEXT\fR or \fBYAML\fR where [TEXT][textconfig] is the easiest and most ideal solution for most users\. However YAML \fIhttps://github\.com/caronc/apprise/wiki/config_yaml\fR configuration files grants the user a bit more leverage and access to some of the internal features of Apprise\. Regardless of which format you choose, both provide the users the ability to leverage \fBtagging\fR which adds a more rich and powerful notification environment\.
- .
  .P
  Configuration files can be directly referenced via \fBapprise\fR when referencing the \fB\-\-config=\fR (\fB\-c\fR) CLI directive\. You can identify as many as you like on the command line and all of them will be loaded\. You can also point your configuration to a cloud location (by referencing \fBhttp://\fR or \fBhttps://\fR\. By default \fBapprise\fR looks in the following local locations for configuration files and loads them:
+ .IP "" 4
diff -pruN 1.8.0-3/docker-compose.yml 1.8.1-1/docker-compose.yml
--- 1.8.0-3/docker-compose.yml	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/docker-compose.yml	2024-07-26 00:19:02.000000000 +0000
@@ -1,12 +1,5 @@
 version: "3.3"
 services:
-  test.py36:
-    build:
-      context: .
-      dockerfile: Dockerfile.py36
-    volumes:
-      - ./:/apprise
-
   test.py310:
     build:
       context: .
@@ -75,20 +68,20 @@ services:
 # Other Testing
 #
 # Connect to web and create a new project using the manage script
-# -> docker-compose run --rm test.py36 bash
+# -> docker-compose run --rm test.py311 bash
 # bin/apprise -
 # bin/checkdone.sh
 #
 # Run a set of tests for just a certain section
-#  docker-compose run --rm test.py36 bin/test.sh fcm
+#  docker-compose run --rm test.py311 bin/test.sh fcm
 #
-# Or just run all the tests in python 3.6
-#  docker-compose run --rm test.py36 bin/test.sh
+# Or just run all the tests in python 3.11
+#  docker-compose run --rm test.py311 bin/test.sh
 #
 # Want to run the whole test suite:
 #
 # [ -f .coverage ] && rm -f .coverage
-# docker-compose run --rm test.py36 coverage run --append -m pytest -vv
+# docker-compose run --rm test.py311 coverage run --append -m pytest -vv
 # docker-compose run --rm test.py310 coverage run --append -m pytest -vv
 #
 # # Now produce a report
@@ -98,8 +91,6 @@ services:
 # RPM Building
 #
 
-# el8
-#  - docker-compose run --rm rpmbuild.el8 build-rpm.sh
 # el9
 #  - docker-compose run --rm rpmbuild.el9 build-rpm.sh
 # f39 (Fedora)
diff -pruN 1.8.0-3/packaging/README.md 1.8.1-1/packaging/README.md
--- 1.8.0-3/packaging/README.md	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/packaging/README.md	2024-07-26 00:19:02.000000000 +0000
@@ -2,12 +2,12 @@
 This directory contains any supporting files to grant usage of Apprise in various distributions.
 
 ### RPM Based Packages
-* [EPEL](https://fedoraproject.org/wiki/EPEL) based distributions are only supported if they are of v8 or higher. This includes:
-   * Red Hat 8.x (or higher)
-   * Scientific OS 8.x (or higher)
-   * Oracle Linux 8.x (or higher)
-   * Rocky Linux 8.x (or higher)
-   * Alma Linux 8.x (or higher)
+* [EPEL](https://fedoraproject.org/wiki/EPEL) based distributions are only supported if they are of v9 or higher. This includes:
+   * Red Hat 9.x (or higher)
+   * Scientific OS 9.x (or higher)
+   * Oracle Linux 9.x (or higher)
+   * Rocky Linux 9.x (or higher)
+   * Alma Linux 9.x (or higher)
    * Fedora 29 (or higher)
 
 Provided you are connected to the [EPEL repositories](https://fedoraproject.org/wiki/EPEL), the following will just work for you:
diff -pruN 1.8.0-3/packaging/man/apprise.1 1.8.1-1/packaging/man/apprise.1
--- 1.8.0-3/packaging/man/apprise.1	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/packaging/man/apprise.1	2024-07-26 00:19:02.000000000 +0000
@@ -1,213 +1,134 @@
-.\" generated with Ronn/v0.7.3
-.\" http://github.com/rtomayko/ronn/tree/0.7.3
-.
-.TH "APPRISE" "1" "March 2024" "Chris Caron <lead2gold@gmail.com>" ""
-.
+.\" generated with Ronn-NG/v0.9.1
+.\" http://github.com/apjanke/ronn-ng/tree/0.9.1
+.TH "APPRISE" "1" "July 2024" "Chris Caron <lead2gold@gmail.com>"
 .SH "NAME"
 \fBapprise\fR \- Push Notifications that work with just about every platform!
-.
 .SH "SYNOPSIS"
-\fBapprise\fR [\fIoptions\fR\.\.\.] \fIservice\-url\fR\.\.\.
-.
+\fBapprise\fR [\fIoptions\fR\|\.\|\.\|\.] \fIservice\-url\fR\|\.\|\.\|\.
 .br
-.
 .SH "DESCRIPTION"
 \fBApprise\fR allows you to send a notification to \fIalmost all\fR of the most popular notification services available to us today such as: Discord, Telegram, Pushbullet, Slack, Twitter, etc\.
-.
-.IP "\(bu" 4
+.IP "\[ci]" 4
 One notification library to rule them all\.
-.
-.IP "\(bu" 4
+.IP "\[ci]" 4
 A common and intuitive notification syntax\.
-.
-.IP "\(bu" 4
+.IP "\[ci]" 4
 Supports the handling of images (to the notification services that will accept them)\.
-.
 .IP "" 0
-.
 .SH "OPTIONS"
 The Apprise options are as follows:
-.
 .P
 \fB\-b\fR, \fB\-\-body=\fR\fITEXT\fR: Specify the message body\. If no body is specified then content is read from \fIstdin\fR\.
-.
 .P
 \fB\-t\fR, \fB\-\-title=\fR\fITEXT\fR: Specify the message title\. This field is complete optional\.
-.
 .P
 \fB\-c\fR, \fB\-\-config=\fR\fICONFIG\-URL\fR: Specify one or more configuration locations\.
-.
 .P
 \fB\-a\fR, \fB\-\-attach=\fR\fIATTACH\-URL\fR: Specify one or more file attachment locations\.
-.
 .P
 \fB\-P\fR, \fB\-\-plugin\-path=\fR\fIPLUGIN\-PATH\fR: Specify a path to scan for custom notification plugin support\. You can create your own notification by simply creating a Python file that contains the \fB@notify("schema")\fR decorator\.
-.
 .P
 You can optioanly chose to specify more then one \fB\-\-plugin\-path\fR (\fB\-P\fR) to increase the modules included\.
-.
 .P
 \fB\-n\fR, \fB\-\-notification\-type=\fR\fITYPE\fR: Specify the message type (default=info)\. Possible values are "info", "success", "failure", and "warning"\.
-.
 .P
 \fB\-i\fR, \fB\-\-input\-format=\fR\fIFORMAT\fR: Specify the input message format (default=text)\. Possible values are "text", "html", and "markdown"\.
-.
 .P
 \fB\-T\fR, \fB\-\-theme=\fRTHEME: Specify the default theme\.
-.
 .P
 \fB\-g\fR, \fB\-\-tag=\fRTAG: Specify one or more tags to filter which services to notify\. Use multiple \fB\-\-tag\fR (\fB\-g\fR) entries to \fBOR\fR the tags together and comma separated to \fBAND\fR them\. If no tags are specified then all services are notified\.
-.
 .P
 \fB\-Da\fR, \fB\-\-disable\-async\fR: Send notifications synchronously (one after the other) instead of all at once\.
-.
 .P
 \fB\-R\fR, \fB\-\-recursion\-depth\fR: he number of recursive import entries that can be loaded from within Apprise configuration\. By default this is set to 1\. If this is set to zero, then import statements found in any configuration is ignored\.
-.
 .P
 \fB\-e\fR, \fB\-\-interpret\-escapes\fR Enable interpretation of backslash escapes\. For example, this would convert sequences such as \en and \er to their respected ascii new\-line and carriage
-.
 .P
 \fB\-j\fR, \fB\-\-interpret\-emojis\fR Enable interpretation of emoji strings\. For example, this would convert sequences such as :smile: or :grin: to their respected unicode emoji character\.
-.
 .P
 \fB\-d\fR, \fB\-\-dry\-run\fR: Perform a trial run but only prints the notification services to\-be triggered to \fBstdout\fR\. Notifications are never sent using this mode\.
-.
 .P
 return characters prior to the delivery of the notification\.
-.
 .P
 \fB\-l\fR, \fB\-\-details\fR Prints details about the current services supported by Apprise\.
-.
 .P
 \fB\-v\fR, \fB\-\-verbose\fR: The more of these you specify, the more verbose the output is\. e\.g: \-vvvv
-.
 .P
 \fB\-D\fR, \fB\-\-debug\fR: A debug mode; useful for troubleshooting\.
-.
 .P
 \fB\-V\fR, \fB\-\-version\fR: Display the apprise version and exit\.
-.
 .P
 \fB\-h\fR, \fB\-\-help\fR: Show this message and exit\.
-.
 .SH "EXIT STATUS"
 \fBapprise\fR exits with a status of:
-.
-.IP "\(bu" 4
+.IP "\[ci]" 4
 \fB0\fR if all of the notifications were sent successfully\.
-.
-.IP "\(bu" 4
+.IP "\[ci]" 4
 \fB1\fR if one or more notifications could not be sent\.
-.
-.IP "\(bu" 4
+.IP "\[ci]" 4
 \fB2\fR if there was an error specified on the command line such as not providing an valid argument\.
-.
-.IP "\(bu" 4
+.IP "\[ci]" 4
 \fB3\fR if there was one or more Apprise Service URLs successfully loaded but none could be notified due to user filtering (via tags)\.
-.
 .IP "" 0
-.
 .SH "SERVICE URLS"
 There are to many service URL and combinations to list here\. It\'s best to visit the Apprise GitHub page \fIhttps://github\.com/caronc/apprise/wiki#notification\-services\fR and see what\'s available\.
-.
 .SH "EXAMPLES"
 Send a notification to as many servers as you want to specify as you can easily chain them together:
-.
 .IP "" 4
-.
 .nf
-
 $ apprise \-vv \-t "my title" \-b "my notification body" \e
    "mailto://myemail:mypass@gmail\.com" \e
    "pbul://o\.gn5kj6nfhv736I7jC3cj3QLRiyhgl98b"
-.
 .fi
-.
 .IP "" 0
-.
 .P
 If you don\'t specify a \fB\-\-body\fR (\fB\-b\fR) then stdin is used allowing you to use the tool as part of your every day administration:
-.
 .IP "" 4
-.
 .nf
-
 $ cat /proc/cpuinfo | apprise \-vv \-t "cpu info" \e
     "mailto://myemail:mypass@gmail\.com"
-.
 .fi
-.
 .IP "" 0
-.
 .P
 Load in a configuration file which identifies all of your notification service URLs and notify them all:
-.
 .IP "" 4
-.
 .nf
-
 $ apprise \-vv \-t "my title" \-b "my notification body" \e
    \-\-config=~/apprise\.yml
-.
 .fi
-.
 .IP "" 0
-.
 .P
 Load in a configuration file from a remote server that identifies all of your notification service URLs and only notify the ones tagged as \fIdevops\fR\.
-.
 .IP "" 4
-.
 .nf
-
 $ apprise \-vv \-t "my title" \-b "my notification body" \e
    \-\-config=https://localhost/my/apprise/config \e
    \-t devops
-.
 .fi
-.
 .IP "" 0
-.
 .P
 Include an attachment:
-.
 .IP "" 4
-.
 .nf
-
 $ apprise \-vv \-t "School Assignment" \-b "See attached" \e
    \-\-attach=Documents/FinalReport\.docx
-.
 .fi
-.
 .IP "" 0
-.
 .SH "CUSTOM PLUGIN/NOTIFICATIONS"
 Apprise can additionally allow you to define your own custom \fBschema://\fR entries that you can trigger on and call services you\'ve defined\.
-.
 .P
 By default \fBapprise\fR looks in the following local locations for custom plugin files and loads them:
-.
 .IP "" 4
-.
 .nf
-
 ~/\.apprise/plugins
 ~/\.config/apprise/plugins
 /var/lib/apprise/plugins
-.
 .fi
-.
 .IP "" 0
-.
 .P
 Simply create your own python file with the following bare minimum content in it: from apprise\.decorators import notify
-.
 .IP "" 4
-.
 .nf
-
 # This example assumes you want your function to trigger on foobar://
 # references:
 @notify(on="foobar", name="My Custom Notification")
@@ -215,24 +136,17 @@ def my_wrapper(body, title, notify_type,
 
      <define your custom code here>
 
-        # Returning True/False is a way to relay your status back to Apprise\.
-        # Returning nothing (None by default) is always interpreted as a Success
+		# Returning True/False is a way to relay your status back to Apprise\.
+		# Returning nothing (None by default) is always interpreted as a Success
      return True
-.
 .fi
-.
 .IP "" 0
-.
 .SH "CONFIGURATION"
 A configuration file can be in the format of either \fBTEXT\fR or \fBYAML\fR where [TEXT][textconfig] is the easiest and most ideal solution for most users\. However YAML \fIhttps://github\.com/caronc/apprise/wiki/config_yaml\fR configuration files grants the user a bit more leverage and access to some of the internal features of Apprise\. Reguardless of which format you choose, both provide the users the ability to leverage \fBtagging\fR which adds a more rich and powerful notification environment\.
-.
 .P
 Configuration files can be directly referenced via \fBapprise\fR when referencing the \fB\-\-config=\fR (\fB\-c\fR) CLI directive\. You can identify as many as you like on the command line and all of them will be loaded\. You can also point your configuration to a cloud location (by referencing \fBhttp://\fR or \fBhttps://\fR\. By default \fBapprise\fR looks in the following local locations for configuration files and loads them:
-.
 .IP "" 4
-.
 .nf
-
 ~/\.apprise\.conf
 ~/\.apprise\.yaml
 ~/\.config/apprise\.conf
@@ -247,43 +161,26 @@ Configuration files can be directly refe
 /etc/apprise\.yaml
 /etc/apprise/apprise\.conf
 /etc/apprise/apprise\.yaml
-.
 .fi
-.
 .IP "" 0
-.
 .P
 The \fBconfiguration files\fR specified above can also be identified with a \fB\.yml\fR extension or even just entirely removing the \fB\.conf\fR extension altogether\.
-.
 .P
 If a default configuration file is referenced in any way by the \fBapprise\fR tool, you no longer need to provide it a Service URL\. Usage of the \fBapprise\fR tool simplifies to:
-.
 .IP "" 4
-.
 .nf
-
 $ apprise \-vv \-t "my title" \-b "my notification body"
-.
 .fi
-.
 .IP "" 0
-.
 .P
 If you leveraged tagging \fIhttps://github\.com/caronc/apprise/wiki/CLI_Usage#label\-leverage\-tagging\fR, you can define all of Apprise Service URLs in your configuration that you want and only specifically notify a subset of them:
-.
 .IP "" 4
-.
 .nf
-
 $ apprise \-vv \-t "Will Be Late" \-b "Go ahead and make dinner without me" \e
           \-\-tag=family
-.
 .fi
-.
 .IP "" 0
-.
 .SH "BUGS"
 If you find any bugs, please make them known at: \fIhttps://github\.com/caronc/apprise/issues\fR
-.
 .SH "COPYRIGHT"
 Apprise is Copyright (C) 2024 Chris Caron \fIlead2gold@gmail\.com\fR
diff -pruN 1.8.0-3/packaging/man/apprise.1.html 1.8.1-1/packaging/man/apprise.1.html
--- 1.8.0-3/packaging/man/apprise.1.html	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/packaging/man/apprise.1.html	2024-07-26 00:19:02.000000000 +0000
@@ -1,8 +1,8 @@
 <!DOCTYPE html>
 <html>
 <head>
-  <meta http-equiv='content-type' value='text/html;charset=utf8'>
-  <meta name='generator' value='Ronn/v0.7.3 (http://github.com/rtomayko/ronn/tree/0.7.3)'>
+  <meta http-equiv='content-type' content='text/html;charset=utf8'>
+  <meta name='generator' content='Ronn-NG/v0.9.1 (http://github.com/apjanke/ronn-ng/tree/0.9.1)'>
   <title>apprise(1) - Push Notifications that work with just about every platform!</title>
   <style type='text/css' media='all'>
   /* style: man */
@@ -72,14 +72,15 @@
     <li class='tr'>apprise(1)</li>
   </ol>
 
-  <h2 id="NAME">NAME</h2>
+  
+
+<h2 id="NAME">NAME</h2>
 <p class="man-name">
   <code>apprise</code> - <span class="man-whatis">Push Notifications that work with just about every platform!</span>
 </p>
-
 <h2 id="SYNOPSIS">SYNOPSIS</h2>
 
-<p><code>apprise</code> [<var>options</var>...] <var>service-url</var>...<br /></p>
+<p><code>apprise</code> [<var>options</var>...] <var>service-url</var>...<br></p>
 
 <h2 id="DESCRIPTION">DESCRIPTION</h2>
 
@@ -88,91 +89,90 @@ popular notification services available
 Telegram, Pushbullet, Slack, Twitter, etc.</p>
 
 <ul>
-<li>One notification library to rule them all.</li>
-<li>A common and intuitive notification syntax.</li>
-<li>Supports the handling of images (to the notification services that will
+  <li>One notification library to rule them all.</li>
+  <li>A common and intuitive notification syntax.</li>
+  <li>Supports the handling of images (to the notification services that will
 accept them).</li>
 </ul>
 
-
 <h2 id="OPTIONS">OPTIONS</h2>
 
 <p>The Apprise options are as follows:</p>
 
-<p>  <code>-b</code>, <code>--body=</code><var>TEXT</var>:
+<p><code>-b</code>, <code>--body=</code><var>TEXT</var>:
   Specify the message body. If no body is specified then content is read from
   <var>stdin</var>.</p>
 
-<p>  <code>-t</code>, <code>--title=</code><var>TEXT</var>:
+<p><code>-t</code>, <code>--title=</code><var>TEXT</var>:
   Specify the message title. This field is complete optional.</p>
 
-<p>  <code>-c</code>, <code>--config=</code><var>CONFIG-URL</var>:
+<p><code>-c</code>, <code>--config=</code><var>CONFIG-URL</var>:
   Specify one or more configuration locations.</p>
 
-<p>  <code>-a</code>, <code>--attach=</code><var>ATTACH-URL</var>:
+<p><code>-a</code>, <code>--attach=</code><var>ATTACH-URL</var>:
   Specify one or more file attachment locations.</p>
 
-<p>  <code>-P</code>, <code>--plugin-path=</code><var>PLUGIN-PATH</var>:
+<p><code>-P</code>, <code>--plugin-path=</code><var>PLUGIN-PATH</var>:
   Specify a path to scan for custom notification plugin support.
   You can create your own notification by simply creating a Python file
   that contains the <code>@notify("schema")</code> decorator.</p>
 
-<p>  You can optioanly chose to specify more then one <strong>--plugin-path</strong> (<strong>-P</strong>)
+<p>You can optioanly chose to specify more then one <strong>--plugin-path</strong> (<strong>-P</strong>)
   to increase the modules included.</p>
 
-<p>  <code>-n</code>, <code>--notification-type=</code><var>TYPE</var>:
+<p><code>-n</code>, <code>--notification-type=</code><var>TYPE</var>:
   Specify the message type (default=info). Possible values are "info",
   "success", "failure", and "warning".</p>
 
-<p>  <code>-i</code>, <code>--input-format=</code><var>FORMAT</var>:
+<p><code>-i</code>, <code>--input-format=</code><var>FORMAT</var>:
   Specify the input message format (default=text). Possible values are "text",
   "html", and "markdown".</p>
 
-<p>  <code>-T</code>, <code>--theme=</code>THEME:
+<p><code>-T</code>, <code>--theme=</code>THEME:
   Specify the default theme.</p>
 
-<p>  <code>-g</code>, <code>--tag=</code>TAG:
+<p><code>-g</code>, <code>--tag=</code>TAG:
   Specify one or more tags to filter which services to notify. Use multiple
   <strong>--tag</strong> (<strong>-g</strong>) entries to <code>OR</code> the tags together and comma separated
   to <code>AND</code> them. If no tags are specified then all services are notified.</p>
 
-<p>  <code>-Da</code>, <code>--disable-async</code>:
+<p><code>-Da</code>, <code>--disable-async</code>:
   Send notifications synchronously (one after the other) instead of
   all at once.</p>
 
-<p>  <code>-R</code>, <code>--recursion-depth</code>:
+<p><code>-R</code>, <code>--recursion-depth</code>:
   he number of recursive import entries that can be loaded from within
   Apprise configuration. By default this is set to 1. If this is set to
   zero, then import statements found in any configuration is ignored.</p>
 
-<p>  <code>-e</code>, <code>--interpret-escapes</code>
+<p><code>-e</code>, <code>--interpret-escapes</code>
   Enable interpretation of backslash escapes. For example, this would convert
   sequences such as \n and \r to their respected ascii new-line and carriage</p>
 
-<p>  <code>-j</code>, <code>--interpret-emojis</code>
+<p><code>-j</code>, <code>--interpret-emojis</code>
   Enable interpretation of emoji strings. For example, this would convert
   sequences such as :smile: or :grin: to their respected unicode emoji
   character.</p>
 
-<p>  <code>-d</code>, <code>--dry-run</code>:
+<p><code>-d</code>, <code>--dry-run</code>:
   Perform a trial run but only prints the notification services to-be
   triggered to <strong>stdout</strong>. Notifications are never sent using this mode.</p>
 
-<p>  return characters prior to the delivery of the notification.</p>
+<p>return characters prior to the delivery of the notification.</p>
 
-<p>  <code>-l</code>, <code>--details</code>
+<p><code>-l</code>, <code>--details</code>
   Prints details about the current services supported by Apprise.</p>
 
-<p>  <code>-v</code>, <code>--verbose</code>:
+<p><code>-v</code>, <code>--verbose</code>:
   The more of these you specify, the more verbose the output is. e.g: -vvvv</p>
 
-<p>  <code>-D</code>, <code>--debug</code>:
+<p><code>-D</code>, <code>--debug</code>:
   A debug mode; useful for troubleshooting.</p>
 
-<p>  <code>-V</code>, <code>--version</code>:
+<p><code>-V</code>, <code>--version</code>:
   Display the apprise version and exit.</p>
 
-<p>  <code>-h</code>, <code>--help</code>:
+<p><code>-h</code>, <code>--help</code>:
   Show this message and exit.</p>
 
 <h2 id="EXIT-STATUS">EXIT STATUS</h2>
@@ -180,15 +180,18 @@ accept them).</li>
 <p><strong>apprise</strong> exits with a status of:</p>
 
 <ul>
-<li><strong>0</strong> if all of the notifications were sent successfully.</li>
-<li><strong>1</strong> if one or more notifications could not be sent.</li>
-<li><strong>2</strong> if there was an error specified on the command line such as not
+  <li>
+<strong>0</strong> if all of the notifications were sent successfully.</li>
+  <li>
+<strong>1</strong> if one or more notifications could not be sent.</li>
+  <li>
+<strong>2</strong> if there was an error specified on the command line such as not
 providing an valid argument.</li>
-<li><strong>3</strong> if there was one or more Apprise Service URLs successfully
+  <li>
+<strong>3</strong> if there was one or more Apprise Service URLs successfully
 loaded but none could be notified due to user filtering (via tags).</li>
 </ul>
 
-
 <h2 id="SERVICE-URLS">SERVICE URLS</h2>
 
 <p>There are to many service URL and combinations to list here. It's best to
@@ -233,7 +236,6 @@ notification service URLs and only notif
 </code></pre>
 
 <h2 id="CUSTOM-PLUGIN-NOTIFICATIONS">CUSTOM PLUGIN/NOTIFICATIONS</h2>
-
 <p>Apprise can additionally allow you to define your own custom <strong>schema://</strong>
 entries that you can trigger on and call services you've defined.</p>
 
@@ -254,10 +256,10 @@ it:
 @notify(on="foobar", name="My Custom Notification")
 def my_wrapper(body, title, notify_type, *args, **kwargs):
 
-     &lt;define your custom code here>
-
-        # Returning True/False is a way to relay your status back to Apprise.
-        # Returning nothing (None by default) is always interpreted as a Success
+     &lt;define your custom code here&gt;
+   
+		# Returning True/False is a way to relay your status back to Apprise.
+		# Returning nothing (None by default) is always interpreted as a Success
      return True
 </code></pre>
 
@@ -316,12 +318,11 @@ configuration that you want and only spe
 
 <h2 id="COPYRIGHT">COPYRIGHT</h2>
 
-<p>Apprise is Copyright (C) 2024 Chris Caron <a href="&#x6d;&#97;&#x69;&#108;&#x74;&#x6f;&#58;&#108;&#101;&#97;&#100;&#x32;&#x67;&#x6f;&#108;&#100;&#64;&#x67;&#109;&#x61;&#105;&#x6c;&#46;&#x63;&#x6f;&#x6d;" data-bare-link="true">&#108;&#x65;&#97;&#100;&#50;&#x67;&#111;&#x6c;&#x64;&#x40;&#103;&#x6d;&#x61;&#x69;&#x6c;&#46;&#99;&#111;&#x6d;</a></p>
-
+<p>Apprise is Copyright (C) 2024 Chris Caron <a href="mailto:lead2gold@gmail.com" data-bare-link="true">lead2gold@gmail.com</a></p>
 
   <ol class='man-decor man-foot man foot'>
     <li class='tl'>Chris Caron &lt;lead2gold@gmail.com&gt;</li>
-    <li class='tc'>March 2024</li>
+    <li class='tc'>July 2024</li>
     <li class='tr'>apprise(1)</li>
   </ol>
 
diff -pruN 1.8.0-3/packaging/redhat/apprise-click67-support.patch 1.8.1-1/packaging/redhat/apprise-click67-support.patch
--- 1.8.0-3/packaging/redhat/apprise-click67-support.patch	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/packaging/redhat/apprise-click67-support.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,39 +0,0 @@
-diff -Naur apprise-1.4.5/test/test_apprise_cli.py apprise-1.4.5-patched/test/test_apprise_cli.py
---- apprise-1.4.5/test/test_apprise_cli.py	2023-08-20 11:26:43.000000000 -0400
-+++ apprise-1.4.5-patched/test/test_apprise_cli.py	2023-08-20 16:37:42.922342103 -0400
-@@ -1027,9 +1027,6 @@
-     # Absolute path to __init__.py is okay
-     assert result.exit_code == 0
- 
--    # we can verify that it prepares our message
--    assert result.stdout.strip() == 'info:  - test body'
--
-     # Clear our working variables so they don't obstruct the next test
-     # This simulates an actual call from the CLI.  Unfortunately through
-     # testing were occupying the same memory space so our singleton's
-@@ -1049,9 +1046,6 @@
-     # an __init__.py is found on the inside of it
-     assert result.exit_code == 0
- 
--    # we can verify that it prepares our message
--    assert result.stdout.strip() == 'info:  - test body'
--
-     # Test double paths that are the same; this ensures we only
-     # load the plugin once
-     result = runner.invoke(cli.main, [
-@@ -1183,15 +1177,6 @@
-         # Print our custom details to the screen
-         '--details',
-     ])
--    assert 'willfail' in result.stdout
--    assert 'always failing...' in result.stdout
--
--    assert 'clihook1' in result.stdout
--    assert 'the original clihook entry' in result.stdout
--    assert 'a duplicate of the clihook entry' not in result.stdout
--
--    assert 'clihook2' in result.stdout
--    assert 'Custom - clihook2' in result.stdout
- 
-     # Note that the failure of the decorator carries all the way back
-     # to the CLI
diff -pruN 1.8.0-3/packaging/redhat/apprise-no-macosx-testing.patch 1.8.1-1/packaging/redhat/apprise-no-macosx-testing.patch
--- 1.8.0-3/packaging/redhat/apprise-no-macosx-testing.patch	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/packaging/redhat/apprise-no-macosx-testing.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-diff -Naur apprise-1.6.0/test/test_plugin_macosx.py apprise-1.6.0.patched/test/test_plugin_macosx.py
---- apprise-1.6.0/test/test_plugin_macosx.py	2023-12-22 16:51:24.000000000 -0500
-+++ apprise-1.6.0.patched/test/test_plugin_macosx.py	2023-12-22 17:38:35.720131819 -0500
-@@ -42,9 +42,8 @@
- logging.disable(logging.CRITICAL)
- 
- 
--if sys.platform not in ["darwin", "linux"]:
--    pytest.skip("Only makes sense on macOS, but testable in Linux",
--                allow_module_level=True)
-+if sys.platform != "darwin":
-+    pytest.skip("MacOS test only", allow_module_level=True)
- 
- 
- @pytest.fixture
diff -pruN 1.8.0-3/packaging/redhat/apprise-pytest-session_mocker-removal.patch 1.8.1-1/packaging/redhat/apprise-pytest-session_mocker-removal.patch
--- 1.8.0-3/packaging/redhat/apprise-pytest-session_mocker-removal.patch	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/packaging/redhat/apprise-pytest-session_mocker-removal.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,20 +0,0 @@
-diff -Naur apprise-1.6.0/test/conftest.py apprise-1.6.0-patched/test/conftest.py
---- apprise-1.6.0/test/conftest.py	2023-12-27 11:20:40.000000000 -0500
-+++ apprise-1.6.0-patched/test/conftest.py	2023-12-27 13:43:22.583100037 -0500
-@@ -45,8 +45,8 @@
- A_MGR = AttachmentManager()
- 
- 
--@pytest.fixture(scope="function", autouse=True)
--def no_throttling_everywhere(session_mocker):
-+@pytest.fixture(autouse=True)
-+def no_throttling_everywhere(mocker):
-     """
-     A pytest session fixture which disables throttling on all notifiers.
-     It is automatically enabled.
-@@ -57,4 +57,4 @@
-     A_MGR.unload_modules()
- 
-     for plugin in N_MGR.plugins():
--        session_mocker.patch.object(plugin, "request_rate_per_sec", 0)
-+        mocker.patch.object(plugin, "request_rate_per_sec", 0)
diff -pruN 1.8.0-3/packaging/redhat/python-apprise.spec 1.8.1-1/packaging/redhat/python-apprise.spec
--- 1.8.0-3/packaging/redhat/python-apprise.spec	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/packaging/redhat/python-apprise.spec	2024-07-26 00:19:02.000000000 +0000
@@ -39,46 +39,28 @@ Apprise is a Python package for simplify
 notification services that are out there. Apprise opens the door and makes
 it easy to access:
 
-Apprise API, APRS, AWS SES, AWS SNS, Bark, Boxcar, Burst SMS, BulkSMS, BulkVS,
-Chantify, ClickSend, DAPNET, DingTalk, Discord, E-Mail, Emby, FCM, Feishu,
-Flock, Free Mobile, Google Chat, Gotify, Growl, Guilded, Home Assistant,
-httpSMS, IFTTT, Join, Kavenegar, KODI, Kumulos, LaMetric, Line, LunaSea,
-MacOSX, Mailgun, Mastodon, Mattermost,Matrix, MessageBird, Microsoft Windows,
-Microsoft Teams, Misskey, MQTT, MSG91, MyAndroid, Nexmo, Nextcloud,
+Africas Talking, Apprise API, APRS, AWS SES, AWS SNS, Bark, Boxcar, Burst SMS,
+BulkSMS, BulkVS, Chantify, ClickSend, DAPNET, DingTalk, Discord, E-Mail, Emby,
+FCM, Feishu, Flock, Free Mobile, Google Chat, Gotify, Growl, Guilded, Home
+Assistant, httpSMS, IFTTT, Join, Kavenegar, KODI, Kumulos, LaMetric, Line,
+LunaSea, MacOSX, Mailgun, Mastodon, Mattermost,Matrix, MessageBird, Microsoft
+Windows, Microsoft Teams, Misskey, MQTT, MSG91, MyAndroid, Nexmo, Nextcloud,
 NextcloudTalk, Notica, Notifiarr, Notifico, ntfy, Office365, OneSignal,
 Opsgenie, PagerDuty, PagerTree, ParsePlatform, PopcornNotify, Prowl, Pushalot,
 PushBullet, Pushjet, PushMe, Pushover, PushSafer, Pushy, PushDeer, Revolt,
-Reddit, Rocket.Chat, RSyslog, SendGrid, ServerChan, Signal, SimplePush, Sinch,
-Slack, SMSEagle, SMS Manager, SMTP2Go, SparkPost, Super Toasty, Streamlabs,
-Stride, Synology Chat, Syslog, Techulus Push, Telegram, Threema Gateway, Twilio,
-Twitter, Twist, XBMC, Voipms, Vonage, WeCom Bot, WhatsApp, Webex Teams}
+Reddit, Rocket.Chat, RSyslog, SendGrid, ServerChan, SFR, Signal, SimplePush,
+Sinch, Slack, SMSEagle, SMS Manager, SMTP2Go, SparkPost, Splunk, Super Toasty,
+Streamlabs, Stride, Synology Chat, Syslog, Techulus Push, Telegram, Threema
+Gateway, Twilio, Twitter, Twist, VictorOps, Voipms, Vonage, WeCom Bot,
+WhatsApp, Webex Teams, Workflows, XBMC}
 
 Name:           python-%{pypi_name}
-Version:        1.8.0
+Version:        1.8.1
 Release:        1%{?dist}
 Summary:        A simple wrapper to many popular notification services used today
 License:        BSD
 URL:            https://github.com/caronc/%{pypi_name}
 Source0:        %{url}/archive/v%{version}/%{pypi_name}-%{version}.tar.gz
-
-# RHEL/Rocky 8 ship with Click v6.7 which does not support the .stdout
-# directive used in the unit testing.  This patch just makes it so our package
-# continues to be compatible with these linux distributions
-Patch0:         %{pypi_name}-click67-support.patch
-
-# RHEL/Rocky 8 ship with Pytest v3.4.2 which does not support the
-# session_mocker fixture.  This patch removes the session_mocker
-# Patch thanks to Andreas Motl and his PR:
-#   - https://github.com/caronc/apprise/pull/763
-Patch1:         %{pypi_name}-pytest-session_mocker-removal.patch
-
-# RHEL/Rocky 8 ship with Pytest v3.4.2 which does not support the
-# tmp_path fixture.  This patch removes the macos testing as it
-# leverages this unavailabe fixture.
-# At the end of the day, the macos testing it is not needed by a
-# RHEL/Fedora environment anyway for obvious reasons.
-Patch2:         %{pypi_name}-no-macosx-testing.patch
-
 BuildArch:      noarch
 
 %description %{common_description}
@@ -118,18 +100,7 @@ Requires: python%{python3_pkgversion}-ce
 Requires: python%{python3_pkgversion}-yaml
 Recommends: python%{python3_pkgversion}-paho-mqtt
 
-%if 0%{?rhel} && 0%{?rhel} <= 8
-BuildRequires: python%{python3_pkgversion}-dataclasses
-Requires: python%{python3_pkgversion}-dataclasses
-%endif
-
 %if %{with tests}
-%if 0%{?rhel} >= 9
-# Do not import python3-mock
-%else
-# python-mock switched to unittest.mock
-BuildRequires: python%{python3_pkgversion}-mock
-%endif
 BuildRequires: python%{python3_pkgversion}-pytest
 BuildRequires: python%{python3_pkgversion}-pytest-mock
 BuildRequires: python%{python3_pkgversion}-pytest-runner
@@ -141,14 +112,6 @@ BuildRequires: python%{python3_pkgversio
 
 %prep
 %setup -q -n %{pypi_name}-%{version}
-%if 0%{?rhel} && 0%{?rhel} <= 8
-# Rocky/RHEL 8 click v6.7 unit testing support
-%patch0 -p1
-# Rocky/RHEL 8 Drop session_mocker support
-%patch1 -p1
-# Rocky/RHEL 8 Lose MacOSX Testing
-%patch2 -p1
-%endif
 
 # 2023.08.27: This test fails for some uknown reason only during the test
 # section of this RPM, but works completley fine under all other circumstances.
@@ -160,14 +123,6 @@ BuildRequires: python%{python3_pkgversio
 # at this time; remove failing test until this is resolved
 %{__rm} test/test_apprise_translations.py
 
-%if 0%{?rhel} >= 9
-# Do nothing
-%else
-# CentOS 8.x requires python-mock (cororlates with import ab)ve
-find test -type f -name '*.py' -exec \
-   sed -i -e 's|^from unittest import mock|import mock|g' {} \;
-%endif
-
 %build
 %py3_build
 
@@ -195,6 +150,15 @@ LANG=C.UTF-8 PYTHONPATH=%{buildroot}%{py
 %{python3_sitelib}/%{pypi_name}/cli.*
 
 %changelog
+* Thu Jul 25 2024 Chris Caron <lead2gold@gmail.com> - 1.8.1
+- Updated to v1.8.1
+
+* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.8.0-3
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild
+
+* Fri Jun 07 2024 Python Maint <python-maint@redhat.com> - 1.8.0-2
+- Rebuilt for Python 3.13
+
 * Sat May 11 2024 Chris Caron <lead2gold@gmail.com> - 1.8.0
 - Updated to v1.8.0
 
diff -pruN 1.8.0-3/requirements.txt 1.8.1-1/requirements.txt
--- 1.8.0-3/requirements.txt	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/requirements.txt	2024-07-26 00:19:02.000000000 +0000
@@ -1,8 +1,7 @@
-# Root certificate authority bundle.
+# Root certificate authority bundle
 certifi
 
-# Application dependencies.
-dataclasses; python_version<"3.7"
+# Application dependencies
 requests
 requests-oauthlib
 click >= 5.0
diff -pruN 1.8.0-3/setup.py 1.8.1-1/setup.py
--- 1.8.0-3/setup.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/setup.py	2024-07-26 00:19:02.000000000 +0000
@@ -62,7 +62,7 @@ else:
 
 setup(
     name='apprise',
-    version='1.8.0',
+    version='1.8.1',
     description='Push Notifications that work with just about every platform!',
     license='BSD',
     long_description=open('README.md', encoding="utf-8").read(),
@@ -94,7 +94,6 @@ setup(
         'Natural Language :: English',
         'Programming Language :: Python',
         'Programming Language :: Python :: 3',
-        'Programming Language :: Python :: 3.6',
         'Programming Language :: Python :: 3.7',
         'Programming Language :: Python :: 3.8',
         'Programming Language :: Python :: 3.9',
diff -pruN 1.8.0-3/test/conftest.py 1.8.1-1/test/conftest.py
--- 1.8.0-3/test/conftest.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/conftest.py	2024-07-26 00:19:02.000000000 +0000
@@ -30,10 +30,11 @@ import sys
 import os
 
 import pytest
+import mimetypes
 
-from apprise.manager_plugins import NotificationManager
-from apprise.manager_config import ConfigurationManager
-from apprise.manager_attachment import AttachmentManager
+from apprise import NotificationManager
+from apprise import ConfigurationManager
+from apprise import AttachmentManager
 
 sys.path.append(os.path.join(os.path.dirname(__file__), 'helpers'))
 
@@ -46,6 +47,16 @@ A_MGR = AttachmentManager()
 
 
 @pytest.fixture(scope="function", autouse=True)
+def mimetypes_always_available():
+    """
+    A pytest session fixture which ensures mimetypes is set correctly
+    pointing to our temporary mime.types file
+    """
+    files = (os.path.join(os.path.dirname(__file__), 'var', 'mime.types'), )
+    mimetypes.init(files=files)
+
+
+@pytest.fixture(scope="function", autouse=True)
 def no_throttling_everywhere(session_mocker):
     """
     A pytest session fixture which disables throttling on all notifiers.
diff -pruN 1.8.0-3/test/helpers/module.py 1.8.1-1/test/helpers/module.py
--- 1.8.0-3/test/helpers/module.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/helpers/module.py	2024-07-26 00:19:02.000000000 +0000
@@ -28,8 +28,9 @@
 
 from itertools import chain
 from importlib import import_module, reload
-from apprise.manager_plugins import NotificationManager
-from apprise.manager_attachment import AttachmentManager
+from apprise import NotificationManager
+from apprise import AttachmentManager
+from apprise import ConfigurationManager
 import sys
 import re
 
@@ -39,6 +40,9 @@ N_MGR = NotificationManager()
 # Grant access to our Attachment Manager Singleton
 A_MGR = AttachmentManager()
 
+# Grant access to our Configuration Manager Singleton
+C_MGR = ConfigurationManager()
+
 # For filtering our result when scanning a module
 # Identify any items below we should match on that we can freely
 # directly copy around between our modules.  This should only
@@ -71,6 +75,21 @@ def reload_plugin(name):
         reload(sys.modules[module_pyname])
     new_notify_mod = import_module(module_pyname)
 
+    A_MGR.unload_modules()
+
+    reload(sys.modules['apprise.apprise_config'])
+    reload(sys.modules['apprise.config.base'])
+    new_apprise_configuration_mod = import_module('apprise.apprise_config')
+    new_apprise_config_base_mod = import_module('apprise.config.base')
+    reload(sys.modules['apprise.manager_config'])
+
+    C_MGR.unload_modules()
+
+    module_pyname = '{}.{}'.format(N_MGR.module_name_prefix, name)
+    if module_pyname in sys.modules:
+        reload(sys.modules[module_pyname])
+    new_notify_mod = import_module(module_pyname)
+
     # Detect our class object
     class_matches = {}
     for class_name in [obj for obj in dir(new_notify_mod)
@@ -117,15 +136,18 @@ def reload_plugin(name):
         for class_name, class_plugin in class_matches.items():
             if hasattr(test_mod, class_name):
                 setattr(test_mod, class_name, class_plugin)
-    #
-    # This section below reloads our attachment classes
-    #
 
+    #
     # Detect our Apprise Modules (include helpers)
+    #
     apprise_modules = \
         sorted([k for k in sys.modules.keys()
                 if re.match(r'^(apprise|helpers)(\.|.+)$', k)], reverse=True)
 
+    #
+    # This section below reloads our attachment classes
+    #
+
     for entry in A_MGR:
         reload(sys.modules[entry['path']])
         for module_pyname in chain(apprise_modules, tests):
@@ -172,4 +194,56 @@ def reload_plugin(name):
 
                     for class_name, class_plugin in class_matches.items():
                         if hasattr(apprise_mod, class_name):
+                            setattr(apprise_mod, class_name, class_plugin)
+
+    #
+    # This section below reloads our configuration classes
+    #
+
+    for entry in C_MGR:
+        reload(sys.modules[entry['path']])
+        for module_pyname in chain(apprise_modules, tests):
+            detect = re.compile(
+                r'^(?P<name>(AppriseConfig|ConfigBase|' +
+                entry['path'].split('.')[-1] + r'))$')
+
+            possible_matches = \
+                [m for m in dir(sys.modules[module_pyname]) if detect.match(m)]
+            if not possible_matches:
+                continue
+
+            apprise_mod = import_module(module_pyname)
+            # Fix reference to new plugin class in given module.
+            # Needed for updating the module-level import reference
+            # like `from apprise.<etc> import ConfigABCDE`.
+            #
+            # We reload NotifyABCDE and place it back in its spot
+            # new_attach = import_module(entry['path'])
+            for name in possible_matches:
+                if name == 'AppriseConfig':
+                    setattr(
+                        apprise_mod, name,
+                        getattr(new_apprise_configuration_mod, name))
+
+                elif name == 'ConfigBase':
+                    setattr(
+                        apprise_mod, name,
+                        getattr(new_apprise_config_base_mod, name))
+
+                else:
+                    module_pyname = '{}.{}'.format(
+                        A_MGR.module_name_prefix, name)
+                    new_config_mod = import_module(module_pyname)
+
+                    # Detect our class object
+                    class_matches = {}
+                    for class_name in [obj for obj in dir(new_config_mod)
+                                       if module_filter_re.match(obj)]:
+
+                        # Store our entry
+                        class_matches[class_name] = \
+                            getattr(new_config_mod, class_name)
+
+                    for class_name, class_plugin in class_matches.items():
+                        if hasattr(apprise_mod, class_name):
                             setattr(apprise_mod, class_name, class_plugin)
diff -pruN 1.8.0-3/test/helpers/rest.py 1.8.1-1/test/helpers/rest.py
--- 1.8.0-3/test/helpers/rest.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/helpers/rest.py	2024-07-26 00:19:02.000000000 +0000
@@ -115,7 +115,8 @@ class AppriseURLTester:
 
     @mock.patch('requests.get')
     @mock.patch('requests.post')
-    def run(self, url, meta, mock_post, mock_get):
+    @mock.patch('requests.request')
+    def run(self, url, meta, mock_request, mock_post, mock_get):
         """
         Run a specific test
         """
@@ -150,6 +151,7 @@ class AppriseURLTester:
         robj.content = u''
         mock_get.return_value = robj
         mock_post.return_value = robj
+        mock_request.return_value = robj
 
         try:
             # We can now instantiate our object:
@@ -276,8 +278,21 @@ class AppriseURLTester:
     @mock.patch('requests.put')
     @mock.patch('requests.delete')
     @mock.patch('requests.patch')
-    def __notify(self, url, obj, meta, asset, mock_patch, mock_del, mock_put,
-                 mock_head, mock_post, mock_get):
+    @mock.patch('requests.request')
+    def __notify(
+        self,
+        url,
+        obj,
+        meta,
+        asset,
+        mock_request,
+        mock_patch,
+        mock_del,
+        mock_put,
+        mock_head,
+        mock_post,
+        mock_get
+    ):
         """
         Perform notification testing against object specified
         """
@@ -342,6 +357,7 @@ class AppriseURLTester:
         mock_patch.return_value = robj
         mock_del.return_value = robj
         mock_put.return_value = robj
+        mock_request.return_value = robj
 
         if test_requests_exceptions is False:
             # Handle our default response
@@ -351,6 +367,7 @@ class AppriseURLTester:
             mock_post.return_value.status_code = requests_response_code
             mock_get.return_value.status_code = requests_response_code
             mock_patch.return_value.status_code = requests_response_code
+            mock_request.return_value.status_code = requests_response_code
 
             # Handle our default text response
             mock_get.return_value.content = requests_response_content
@@ -359,6 +376,7 @@ class AppriseURLTester:
             mock_put.return_value.content = requests_response_content
             mock_head.return_value.content = requests_response_content
             mock_patch.return_value.content = requests_response_content
+            mock_request.return_value.content = requests_response_content
 
             mock_get.return_value.text = requests_response_text
             mock_post.return_value.text = requests_response_text
@@ -366,6 +384,7 @@ class AppriseURLTester:
             mock_del.return_value.text = requests_response_text
             mock_head.return_value.text = requests_response_text
             mock_patch.return_value.text = requests_response_text
+            mock_request.return_value.text = requests_response_text
 
             # Ensure there is no side effect set
             mock_post.side_effect = None
@@ -374,6 +393,7 @@ class AppriseURLTester:
             mock_head.side_effect = None
             mock_get.side_effect = None
             mock_patch.side_effect = None
+            mock_request.side_effect = None
 
         else:
             # Handle exception testing; first we turn the boolean flag
@@ -532,6 +552,7 @@ class AppriseURLTester:
                     mock_put.side_effect = _exception
                     mock_get.side_effect = _exception
                     mock_patch.side_effect = _exception
+                    mock_request.side_effect = _exception
 
                     try:
                         assert obj.notify(
@@ -577,6 +598,7 @@ class AppriseURLTester:
                     mock_head.side_effect = _exception
                     mock_get.side_effect = _exception
                     mock_patch.side_effect = _exception
+                    mock_request.side_effect = _exception
 
                     try:
                         assert obj.notify(
diff -pruN 1.8.0-3/test/test_api.py 1.8.1-1/test/test_api.py
--- 1.8.0-3/test/test_api.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_api.py	2024-07-26 00:19:02.000000000 +0000
@@ -51,7 +51,7 @@ from apprise import PrivacyMode
 from apprise.locale import LazyTranslation
 from apprise.locale import gettext_lazy as _
 
-from apprise.manager_plugins import NotificationManager
+from apprise import NotificationManager
 from apprise.utils import parse_list
 from helpers import OuterEventLoop
 import inspect
@@ -959,6 +959,18 @@ def test_apprise_asset(tmpdir):
 
     # Invalid Type
     with pytest.raises(ValueError):
+        # The exception we expect since dict is not supported
+        a.color(NotifyType.INFO, dict)
+
+    # Test our ASCII mappings
+    assert a.ascii('invalid') == '[?]'
+    assert a.ascii(NotifyType.INFO) == '[i]'
+    assert a.ascii(NotifyType.SUCCESS) == '[+]'
+    assert a.ascii(NotifyType.WARNING) == '[~]'
+    assert a.ascii(NotifyType.FAILURE) == '[!]'
+
+    # Invalid Type
+    with pytest.raises(ValueError):
         # The exception we expect since dict is not supported
         a.color(NotifyType.INFO, dict)
 
diff -pruN 1.8.0-3/test/test_apprise_attachments.py 1.8.1-1/test/test_apprise_attachments.py
--- 1.8.0-3/test/test_apprise_attachments.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_apprise_attachments.py	2024-07-26 00:19:02.000000000 +0000
@@ -35,7 +35,7 @@ from os.path import join
 from os.path import dirname
 from inspect import cleandoc
 from apprise import Apprise, AppriseAsset
-from apprise.manager_attachment import AttachmentManager
+from apprise import AttachmentManager
 from apprise.apprise_attachment import AppriseAttachment
 from apprise.attachment import AttachBase
 from apprise.common import ContentLocation
@@ -284,9 +284,6 @@ def test_apprise_attachment_truncate(moc
     # Add ourselves an object set to truncate
     ap_obj.add('json://localhost/?method=GET&overflow=truncate')
 
-    # Add ourselves a second object without truncate
-    ap_obj.add('json://localhost/?method=GET&overflow=upstream')
-
     # Create ourselves an attachment object
     aa = AppriseAttachment()
 
@@ -304,15 +301,36 @@ def test_apprise_attachment_truncate(moc
     assert mock_get.call_count == 0
     assert ap_obj.notify(body='body', title='title', attach=aa)
 
-    assert mock_get.call_count == 2
+    assert mock_get.call_count == 1
 
     # Our first item was truncated, so only 1 attachment
     details = mock_get.call_args_list[0]
     dataset = json.loads(details[1]['data'])
     assert len(dataset['attachments']) == 1
 
-    # Our second item was not truncated, so all attachments
-    details = mock_get.call_args_list[1]
+    # Reset our object
+    mock_get.reset_mock()
+
+    # our Apprise Object
+    ap_obj = Apprise()
+
+    # Add ourselves an object set to upstream
+    ap_obj.add('json://localhost/?method=GET&overflow=upstream')
+
+    # Create ourselves an attachment object
+    aa = AppriseAttachment()
+
+    # Add 2 attachments
+    assert aa.add(join(TEST_VAR_DIR, 'apprise-test.gif'))
+    assert aa.add(join(TEST_VAR_DIR, 'apprise-test.png'))
+
+    assert mock_get.call_count == 0
+    assert ap_obj.notify(body='body', title='title', attach=aa)
+
+    assert mock_get.call_count == 1
+
+    # Our item was not truncated, so all attachments
+    details = mock_get.call_args_list[0]
     dataset = json.loads(details[1]['data'])
     assert len(dataset['attachments']) == 2
 
diff -pruN 1.8.0-3/test/test_apprise_cli.py 1.8.1-1/test/test_apprise_cli.py
--- 1.8.0-3/test/test_apprise_cli.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_apprise_cli.py	2024-07-26 00:19:02.000000000 +0000
@@ -36,7 +36,7 @@ from os.path import dirname
 from os.path import join
 from apprise import cli
 from apprise import NotifyBase
-from apprise.manager_plugins import NotificationManager
+from apprise import NotificationManager
 from click.testing import CliRunner
 from apprise.utils import environ
 from apprise.locale import gettext_lazy as _
diff -pruN 1.8.0-3/test/test_apprise_config.py 1.8.1-1/test/test_apprise_config.py
--- 1.8.0-3/test/test_apprise_config.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_apprise_config.py	2024-07-26 00:19:02.000000000 +0000
@@ -37,8 +37,8 @@ from apprise import AppriseConfig
 from apprise import AppriseAsset
 from apprise.config import ConfigBase
 from apprise.plugins import NotifyBase
-from apprise.manager_plugins import NotificationManager
-from apprise.manager_config import ConfigurationManager
+from apprise import NotificationManager
+from apprise import ConfigurationManager
 
 from apprise.config.file import ConfigFile
 
diff -pruN 1.8.0-3/test/test_apprise_utils.py 1.8.1-1/test/test_apprise_utils.py
--- 1.8.0-3/test/test_apprise_utils.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_apprise_utils.py	2024-07-26 00:19:02.000000000 +0000
@@ -33,7 +33,7 @@ from inspect import cleandoc
 from urllib.parse import unquote
 
 from apprise import utils
-from apprise.manager_plugins import NotificationManager
+from apprise import NotificationManager
 
 # Disable logging for a cleaner testing output
 import logging
diff -pruN 1.8.0-3/test/test_asyncio.py 1.8.1-1/test/test_asyncio.py
--- 1.8.0-3/test/test_asyncio.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_asyncio.py	2024-07-26 00:19:02.000000000 +0000
@@ -31,7 +31,7 @@ import pytest
 from apprise import Apprise
 from apprise import NotifyBase
 from apprise import NotifyFormat
-from apprise.manager_plugins import NotificationManager
+from apprise import NotificationManager
 
 # Disable logging for a cleaner testing output
 import logging
diff -pruN 1.8.0-3/test/test_attach_base.py 1.8.1-1/test/test_attach_base.py
--- 1.8.0-3/test/test_attach_base.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_attach_base.py	2024-07-26 00:19:02.000000000 +0000
@@ -73,15 +73,6 @@ def test_attach_base():
     with pytest.raises(NotImplementedError):
         obj.download()
 
-    with pytest.raises(NotImplementedError):
-        obj.name
-
-    with pytest.raises(NotImplementedError):
-        obj.path
-
-    with pytest.raises(NotImplementedError):
-        obj.mimetype
-
     # Unsupported URLs are not parsed
     assert AttachBase.parse_url(url='invalid://') is None
 
diff -pruN 1.8.0-3/test/test_attach_file.py 1.8.1-1/test/test_attach_file.py
--- 1.8.0-3/test/test_attach_file.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_attach_file.py	2024-07-26 00:19:02.000000000 +0000
@@ -204,8 +204,7 @@ def test_attach_file():
     assert response.path == path
     assert response.name == 'test.jpeg'
     assert response.mimetype == 'image/jpeg'
-    # We will match on mime type now  (%2F = /)
-    assert re.search(r'[?&]mime=image%2Fjpeg', response.url(), re.I)
+    assert re.search(r'[?&]mime=image/jpeg', response.url(), re.I)
     assert re.search(r'[?&]name=test\.jpeg', response.url(), re.I)
 
     # Test hosted configuration and that we can't add a valid file
diff -pruN 1.8.0-3/test/test_attach_http.py 1.8.1-1/test/test_attach_http.py
--- 1.8.0-3/test/test_attach_http.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_attach_http.py	2024-07-26 00:19:02.000000000 +0000
@@ -36,7 +36,7 @@ from os.path import dirname
 from os.path import getsize
 from apprise.attachment.http import AttachHTTP
 from apprise import Apprise, AppriseAttachment
-from apprise.manager_plugins import NotificationManager
+from apprise import NotificationManager
 from apprise.plugins import NotifyBase
 from apprise.common import ContentLocation
 
@@ -229,7 +229,7 @@ def test_attach_http(mock_get, mock_post
     attachment = AttachHTTP(**results)
     assert isinstance(attachment.url(), str) is True
     # both mime and name over-ridden
-    assert re.search(r'[?&]mime=image%2Fjpeg', attachment.url())
+    assert re.search(r'[?&]mime=image/jpeg', attachment.url())
     assert re.search(r'[?&]name=usethis.jpg', attachment.url())
     # No Content-Disposition; so we use filename from path
     assert attachment.name == 'usethis.jpg'
diff -pruN 1.8.0-3/test/test_attach_memory.py 1.8.1-1/test/test_attach_memory.py
--- 1.8.0-3/test/test_attach_memory.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/test/test_attach_memory.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,205 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+import re
+import urllib
+import pytest
+
+from apprise.attachment.base import AttachBase
+from apprise.attachment.memory import AttachMemory
+from apprise import AppriseAttachment
+from apprise.common import ContentLocation
+
+# Disable logging for a cleaner testing output
+import logging
+logging.disable(logging.CRITICAL)
+
+
+def test_attach_memory_parse_url():
+    """
+    API: AttachMemory().parse_url()
+
+    """
+
+    # Bad Entry
+    assert AttachMemory.parse_url(object) is None
+
+    # Our filename is detected automatically
+    assert AttachMemory.parse_url('memory://')
+
+    # pass our content in as a string
+    mem = AttachMemory(content='string')
+    # it loads a string type by default
+    mem.mimetype == 'text/plain'
+    # Our filename is automatically generated (with .txt)
+    assert re.match(r'^[a-z0-9-]+\.txt$', mem.name, re.I)
+
+    # open our file
+    with mem as fp:
+        assert fp.getbuffer().nbytes == len(mem)
+
+    # pass our content in as a string
+    mem = AttachMemory(
+        content='<html/>', name='test.html', mimetype='text/html')
+    # it loads a string type by default
+    mem.mimetype == 'text/html'
+    mem.name == 'test.html'
+
+    # Stub function
+    assert mem.download()
+
+    with pytest.raises(TypeError):
+        # garbage in, garbage out
+        AttachMemory(content=3)
+
+    # pointer to our data
+    pointer = mem.open()
+    assert pointer.read() == b'<html/>'
+
+    # pass our content in as a string
+    mem = AttachMemory(content=b'binary-data', name='raw.dat')
+    # it loads a string type by default
+    assert mem.mimetype == 'application/octet-stream'
+    mem.name == 'raw'
+
+    # pass our content in as a string
+    mem = AttachMemory(content=b'binary-data')
+    # it loads a string type by default
+    assert mem.mimetype == 'application/octet-stream'
+    # Our filename is automatically generated (with .dat)
+    assert re.match(r'^[a-z0-9-]+\.dat$', mem.name, re.I)
+
+
+def test_attach_memory():
+    """
+    API: AttachMemory()
+
+    """
+    # A url we can test with
+    fname = 'testfile'
+    url = 'memory:///ignored/path/{fname}'.format(fname=fname)
+
+    # Simple gif test
+    response = AppriseAttachment.instantiate(url)
+    assert isinstance(response, AttachMemory)
+
+    # There is no path yet as we haven't written anything to our memory object
+    # yet
+    assert response.path is None
+    assert bool(response) is False
+
+    with response as memobj:
+        memobj.write(b'content')
+
+    # Memory object defaults
+    assert response.name == fname
+    assert response.path == response.name
+    assert response.mimetype == 'application/octet-stream'
+    assert bool(response) is True
+
+    #
+    fname_in_url = urllib.parse.quote(response.name)
+    assert response.url().startswith('memory://{}'.format(fname_in_url))
+
+    # Mime is always part of url
+    assert re.search(r'[?&]mime=', response.url()) is not None
+
+    # Test case where location is simply set to INACCESSIBLE
+    # Below is a bad example, but it proves the section of code properly works.
+    # Ideally a server admin may wish to just disable all File based
+    # attachments entirely. In this case, they simply just need to change the
+    # global singleton at the start of their program like:
+    #
+    # import apprise
+    # apprise.attachment.AttachMemory.location = \
+    #       apprise.ContentLocation.INACCESSIBLE
+    #
+    response = AppriseAttachment.instantiate(url)
+    assert isinstance(response, AttachMemory)
+    with response as memobj:
+        memobj.write(b'content')
+
+    response.location = ContentLocation.INACCESSIBLE
+    assert response.path is None
+    # Downloads just don't work period
+    assert response.download() is False
+
+    # File handling (even if image is set to maxium allowable)
+    response = AppriseAttachment.instantiate(url)
+    assert isinstance(response, AttachMemory)
+    with response as memobj:
+        memobj.write(b'content')
+
+    # Memory handling when size is to large
+    response = AppriseAttachment.instantiate(url)
+    assert isinstance(response, AttachMemory)
+    with response as memobj:
+        memobj.write(b'content')
+
+    # Test case where we exceed our defined max_file_size in memory
+    prev_value = AttachBase.max_file_size
+    AttachBase.max_file_size = len(response) - 1
+    # We can't work in this case
+    assert response.path is None
+    assert response.download() is False
+
+    # Restore our file_size
+    AttachBase.max_file_size = prev_value
+
+    response = AppriseAttachment.instantiate(
+        'memory://apprise-file.gif?mime=image/gif')
+    assert isinstance(response, AttachMemory)
+    with response as memobj:
+        memobj.write(b'content')
+
+    assert response.name == 'apprise-file.gif'
+    assert response.path == response.name
+    assert response.mimetype == 'image/gif'
+    # No mime-type and/or filename over-ride was specified, so therefore it
+    # won't show up in the generated URL
+    assert re.search(r'[?&]mime=', response.url()) is not None
+    assert 'image/gif' in response.url()
+
+    # Force a mime-type and new name
+    response = AppriseAttachment.instantiate(
+        'memory://{}?mime={}&name={}'.format(
+            'ignored.gif', 'image/jpeg', 'test.jpeg'))
+    assert isinstance(response, AttachMemory)
+    with response as memobj:
+        memobj.write(b'content')
+
+    assert response.name == 'test.jpeg'
+    assert response.path == response.name
+    assert response.mimetype == 'image/jpeg'
+    # We will match on mime type now  (%2F = /)
+    assert re.search(r'[?&]mime=image/jpeg', response.url(), re.I)
+    assert response.url().startswith('memory://test.jpeg')
+
+    # Test hosted configuration and that we can't add a valid memory file
+    aa = AppriseAttachment(location=ContentLocation.HOSTED)
+    assert aa.add(response) is False
diff -pruN 1.8.0-3/test/test_config_http.py 1.8.1-1/test/test_config_http.py
--- 1.8.0-3/test/test_config_http.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_config_http.py	2024-07-26 00:19:02.000000000 +0000
@@ -34,7 +34,7 @@ import requests
 from apprise.common import ConfigFormat
 from apprise.config.http import ConfigHTTP
 from apprise.plugins import NotifyBase
-from apprise.manager_plugins import NotificationManager
+from apprise import NotificationManager
 
 # Disable logging for a cleaner testing output
 import logging
diff -pruN 1.8.0-3/test/test_conversion.py 1.8.1-1/test/test_conversion.py
--- 1.8.0-3/test/test_conversion.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_conversion.py	2024-07-26 00:19:02.000000000 +0000
@@ -127,6 +127,70 @@ def test_conversion_html_to_text():
     # If you give nothing, you get nothing in return
     assert to_html("") == ""
 
+    # Special case on HR tag
+    assert to_html("""
+        <html>
+            <head></head>
+            <body>
+                <p><b>FROM: </b>apprise-test@mydomain.yyy
+                <apprise-test@mydomain.yyy></p>
+                Hi!<br/>
+                How are you?<br/>
+<font color=3D"#FF0000">red font</font>
+<a href=3D"http://www.python.org">link</a> you wanted.<br/>
+            </body>
+        </html>
+        """) == "FROM: apprise-test@mydomain.yyy\nHi!\n How are you?\n \
+red font link you wanted."
+
+    assert to_html("""
+        <html>
+            <head></head>
+            <body>
+                <p><b>FROM: </b>apprise-test@mydomain.yyy
+                    <apprise-test@mydomain.yyy><hr></p>
+                Hi!<br/>
+                How are you?<br/>
+<font color=3D"#FF0000">red font</font>
+<a href=3D"http://www.python.org">link</a> you wanted.<br/>
+            </body>
+        </html>
+        """) == "FROM: apprise-test@mydomain.yyy\n---\nHi!\n \
+How are you?\n red font link you wanted."
+
+    # Special case on HR if text is sorrunded by HR tags
+    # its created a dict element
+    assert to_html("""
+        <html>
+            <head></head>
+            <body>
+                <p><hr><b>FROM: </b>apprise-test@mydomain.yyy
+                    <apprise-test@mydomain.yyy><hr></p>
+                Hi!<br/>
+                How are you?<br/>
+<font color=3D"#FF0000">red font</font>
+<a href=3D"http://www.python.org">link</a> you wanted.<br/>
+            </body>
+        </html>
+        """) == "---\nFROM: apprise-test@mydomain.yyy\n---\nHi!\n \
+How are you?\n red font link you wanted."
+
+    assert to_html("""
+        <html>
+            <head></head>
+            <body>
+                <p>
+                    <hr><b>TEST</b><hr>
+                </p>
+                Hi!<br/>
+                How are you?<br/>
+<font color=3D"#FF0000">red font</font>
+<a href=3D"http://www.python.org">link</a> you wanted.<br/>
+            </body>
+            </html>
+        """) == "---\nTEST\n---\nHi!\n How are you?\n red font link you \
+wanted."
+
     with pytest.raises(TypeError):
         # Invalid input
         assert to_html(None)
diff -pruN 1.8.0-3/test/test_decorator_notify.py 1.8.1-1/test/test_decorator_notify.py
--- 1.8.0-3/test/test_decorator_notify.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_decorator_notify.py	2024-07-26 00:19:02.000000000 +0000
@@ -35,7 +35,7 @@ from apprise import AppriseConfig
 from apprise import AppriseAsset
 from apprise import AppriseAttachment
 from apprise import common
-from apprise.manager_plugins import NotificationManager
+from apprise import NotificationManager
 
 # Disable logging for a cleaner testing output
 import logging
diff -pruN 1.8.0-3/test/test_notification_manager.py 1.8.1-1/test/test_notification_manager.py
--- 1.8.0-3/test/test_notification_manager.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_notification_manager.py	2024-07-26 00:19:02.000000000 +0000
@@ -33,7 +33,7 @@ import threading
 from inspect import cleandoc
 
 from apprise import Apprise
-from apprise.manager_plugins import NotificationManager
+from apprise import NotificationManager
 from apprise.plugins import NotifyBase
 
 # Disable logging for a cleaner testing output
diff -pruN 1.8.0-3/test/test_notify_base.py 1.8.1-1/test/test_notify_base.py
--- 1.8.0-3/test/test_notify_base.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_notify_base.py	2024-07-26 00:19:02.000000000 +0000
@@ -154,6 +154,13 @@ def test_notify_base():
     assert isinstance(
         nb.color(notify_type=NotifyType.INFO, color_type=tuple), tuple)
 
+    # Ascii Handling
+    assert nb.ascii(notify_type='invalid') is None
+    assert nb.ascii(NotifyType.INFO) == '[i]'
+    assert nb.ascii(NotifyType.SUCCESS) == '[+]'
+    assert nb.ascii(NotifyType.WARNING) == '[~]'
+    assert nb.ascii(NotifyType.FAILURE) == '[!]'
+
     # Create an object
     nb = NotifyBase()
     # Force an image size since the default doesn't have one
diff -pruN 1.8.0-3/test/test_plugin_africas_talking.py 1.8.1-1/test/test_plugin_africas_talking.py
--- 1.8.0-3/test/test_plugin_africas_talking.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/test/test_plugin_africas_talking.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,207 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+from unittest import mock
+
+import requests
+from apprise import Apprise
+from apprise.plugins.africas_talking import NotifyAfricasTalking
+from helpers import AppriseURLTester
+from apprise import NotifyType
+
+# Disable logging for a cleaner testing output
+import logging
+logging.disable(logging.CRITICAL)
+
+# Our Testing URLs
+apprise_url_tests = (
+    ('atalk://', {
+        # Instantiated but no auth, so no notification can happen
+        'instance': TypeError,
+    }),
+    ('atalk://:@/', {
+        # invalid auth
+        'instance': TypeError
+    }),
+    ('atalk://user@^/', {
+        # invalid apikey
+        'instance': TypeError
+    }),
+    ('atalk://user@apikey/{}'.format('3' * 5), {
+        # invalid nubmer provided
+        'instance': NotifyAfricasTalking,
+        # Expected notify() response because we have no one to notify
+        'notify_response': False,
+    }),
+    ('atalk://user@apikey/123/{}/abcd/+{}'.format(
+        '3' * 11, '4' * 11), {
+        # includes a few invalid bits of info
+        'instance': NotifyAfricasTalking,
+        'privacy_url': 'atalk://user@a...y/33333333333/+44444444444'
+    }),
+    ('atalk://user@apikey/+{}?batch=y'.format('4' * 11), {
+        'instance': NotifyAfricasTalking,
+
+        # Our expected url(privacy=True) startswith() response:
+        'privacy_url': 'atalk://user@a...y/+44444444444',
+    }),
+    ('atalk://user@apikey/+{}?mode=invalid'.format('4' * 11), {
+        'instance': TypeError
+    }),
+    ('atalk://user@apikey/+{}?mode=s'.format('4' * 11), {
+        # S will match the sandbox
+        'instance': NotifyAfricasTalking,
+    }),
+    ('atalk://user@apikey/+{}?mode=PREM'.format('4' * 11), {
+        # PREM will match premium (not case sensitive)
+        'instance': NotifyAfricasTalking,
+    }),
+    ('atalk://{}?apikey=key&user=user&from=FROMUSER'.format('1' * 11), {
+        # use get args to acomplish the same thing
+        'instance': NotifyAfricasTalking,
+    }),
+    ('atalk://_?user=user&to={},{}&key={}&from={}'.format(
+        '1' * 11, '2' * 11, 'b' * 10, '5' * 13), {
+        # use get args to acomplish the same thing
+        'instance': NotifyAfricasTalking,
+    }),
+    ('atalk://user@apikey/{}/'.format('1' * 11), {
+        'instance': NotifyAfricasTalking,
+        # throw a bizzare code forcing us to fail to look it up
+        'response': False,
+        'requests_response_code': 999,
+    }),
+    ('atalk://user@apikey/{}/'.format('1' * 11), {
+        'instance': NotifyAfricasTalking,
+        # Throws a series of connection and transfer exceptions when this flag
+        # is set and tests that we gracfully handle them
+        'test_requests_exceptions': True,
+    }),
+)
+
+
+def test_plugin_atalk_urls():
+    """
+    NotifyTemplate() Apprise URLs
+
+    """
+
+    # Run our general tests
+    AppriseURLTester(tests=apprise_url_tests).run_all()
+
+
+@mock.patch('requests.post')
+def test_plugin_atalk_edge_cases(mock_post):
+    """
+    NotifyAfricasTalking() Edge Cases
+
+    """
+
+    # Initialize some generic (but valid) tokens
+    apikey = 'my-api-key'
+    appuser = 'my-app-user'
+    targets = [
+        '+1(555) 123-1234',
+        '1555 5555555',
+        # A garbage entry
+        '12',
+    ]
+
+    # Prepare our response
+    response = requests.Request()
+    response.status_code = requests.codes.ok
+
+    # Prepare Mock
+    mock_post.return_value = response
+
+    # Instantiate our object
+    obj = Apprise.instantiate(
+        'atalk://{}@{}/{}?batch=n'.format(appuser, apikey, '/'.join(targets)))
+
+    assert obj.notify(
+        body='body', title='title', notify_type=NotifyType.INFO) is True
+
+    # We know there are 2 (valid) targets
+    assert len(obj) == 2
+
+    # Test our call count
+    assert mock_post.call_count == 2
+
+    # Test
+    details = mock_post.call_args_list[0]
+    headers = details[1]['headers']
+    assert headers['apiKey'] == apikey
+    payload = details[1]['data']
+    assert payload['username'] == appuser
+    assert payload['from'] == 'AFRICASTKNG'
+    assert payload['to'] == '+15551231234'
+    assert payload['message'] == 'title\r\nbody'
+
+    details = mock_post.call_args_list[1]
+    headers = details[1]['headers']
+    assert headers['apiKey'] == apikey
+    payload = details[1]['data']
+    assert payload['username'] == appuser
+    assert payload['from'] == 'AFRICASTKNG'
+    assert payload['to'] == '15555555555'
+    assert payload['message'] == 'title\r\nbody'
+
+    # Verify our URL looks good
+    assert obj.url().startswith(
+        'atalk://{}@{}/{}'.format(appuser, apikey, '/'.join(
+            ['+15551231234', '15555555555'])))
+
+    assert 'batch=no' in obj.url()
+
+    # Reset our mock object
+    mock_post.reset_mock()
+
+    # With our batch in place, our calculations are different
+    # Testing URL restructuring here as well where phone # is found
+    # in host
+    obj = Apprise.instantiate(
+        'atalk://{}?user={}&apikey={}&batch=y&from=TEST'.format(
+            '/'.join(targets), appuser, apikey))
+
+    # 2 phones were loaded but counted as 1 due to batch flag
+    assert len(obj) == 1
+
+    assert obj.notify(
+        body='body', title='title', notify_type=NotifyType.INFO) is True
+
+    # Test our call count (batched into 1)
+    assert mock_post.call_count == 1
+
+    details = mock_post.call_args_list[0]
+    headers = details[1]['headers']
+    assert headers['apiKey'] == apikey
+    payload = details[1]['data']
+    assert payload['username'] == appuser
+    assert payload['from'] == 'TEST'
+    assert payload['to'] == '+15551231234,15555555555'
+    assert payload['message'] == 'title\r\nbody'
diff -pruN 1.8.0-3/test/test_plugin_matrix.py 1.8.1-1/test/test_plugin_matrix.py
--- 1.8.0-3/test/test_plugin_matrix.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_matrix.py	2024-07-26 00:19:02.000000000 +0000
@@ -258,18 +258,21 @@ def test_plugin_matrix_general(mock_post
     assert isinstance(obj.url(), str)
     # Registration successful
     assert obj.send(body="test") is True
+    del obj
 
     obj = NotifyMatrix(host='host', user='user', targets='#abcd')
     assert isinstance(obj, NotifyMatrix)
     assert isinstance(obj.url(), str)
     # Registration successful
     assert obj.send(body="test") is True
+    del obj
 
     obj = NotifyMatrix(host='host', password='passwd', targets='#abcd')
     assert isinstance(obj, NotifyMatrix)
     assert isinstance(obj.url(), str)
     # A username gets automatically generated in these cases
     assert obj.send(body="test") is True
+    del obj
 
     obj = NotifyMatrix(
         host='host', user='user', password='passwd', targets='#abcd')
@@ -277,6 +280,7 @@ def test_plugin_matrix_general(mock_post
     assert isinstance(obj, NotifyMatrix)
     # Registration Successful
     assert obj.send(body="test") is True
+    del obj
 
     # Test sending other format types
     kwargs = NotifyMatrix.parse_url(
@@ -286,6 +290,7 @@ def test_plugin_matrix_general(mock_post
     assert isinstance(obj, NotifyMatrix)
     assert obj.send(body="test") is True
     assert obj.send(title="title", body="test") is True
+    del obj
 
     kwargs = NotifyMatrix.parse_url(
         'matrix://user:passwd@hostname/#abcd/#abcd:localhost?format=markdown')
@@ -294,6 +299,7 @@ def test_plugin_matrix_general(mock_post
     assert isinstance(obj, NotifyMatrix)
     assert obj.send(body="test") is True
     assert obj.send(title="title", body="test") is True
+    del obj
 
     kwargs = NotifyMatrix.parse_url(
         'matrix://user:passwd@hostname/#abcd/!abcd:localhost?format=text')
@@ -302,6 +308,7 @@ def test_plugin_matrix_general(mock_post
     assert isinstance(obj, NotifyMatrix) is True
     obj.send(body="test") is True
     obj.send(title="title", body="test") is True
+    del obj
 
     # Test notice type notifications
     kwargs = NotifyMatrix.parse_url(
@@ -316,7 +323,7 @@ def test_plugin_matrix_general(mock_post
         # invalid message type specified
         kwargs = NotifyMatrix.parse_url(
             'matrix://user:passwd@hostname/#abcd?msgtype=invalid')
-        obj = NotifyMatrix(**kwargs)
+        NotifyMatrix(**kwargs)
 
     # Force a failed login
     ro = response_obj.copy()
@@ -326,17 +333,20 @@ def test_plugin_matrix_general(mock_post
 
     # Fails because we couldn't register because of 404 errors
     assert obj.send(body="test") is False
+    del obj
 
     obj = NotifyMatrix(host='host', user='test', targets='#abcd')
     assert isinstance(obj, NotifyMatrix) is True
     # Fails because we still couldn't register
     assert obj.send(user='test', password='passwd', body="test") is False
+    del obj
 
     obj = NotifyMatrix(
         host='host', user='test', password='passwd', targets='#abcd')
     assert isinstance(obj, NotifyMatrix) is True
     # Fails because we still couldn't register
     assert obj.send(body="test") is False
+    del obj
 
     obj = NotifyMatrix(host='host', password='passwd', targets='#abcd')
     # Fails because we still couldn't register
@@ -365,6 +375,7 @@ def test_plugin_matrix_general(mock_post
     # Fall back to original template
     request.content = dumps(response_obj)
     request.status_code = requests.codes.ok
+    del obj
 
     obj = NotifyMatrix(host='host', targets=None)
     assert isinstance(obj, NotifyMatrix) is True
@@ -382,6 +393,7 @@ def test_plugin_matrix_general(mock_post
     # our room list is empty so we'll have retrieved the joined_list
     # as our backup
     assert obj.send(user='test', password='passwd', body="test") is True
+    del obj
 
 
 @mock.patch('requests.put')
@@ -430,6 +442,7 @@ def test_plugin_matrix_fetch(mock_post,
     assert isinstance(obj, NotifyMatrix) is True
     # We would hve failed to send our image notification
     assert obj.send(user='test', password='passwd', body="test") is False
+    del obj
 
     # Do the same query with no images to fetch
     asset = AppriseAsset(image_path_mask=False, image_url_mask=False)
@@ -438,6 +451,7 @@ def test_plugin_matrix_fetch(mock_post,
     assert isinstance(obj, NotifyMatrix) is True
     # We would hve failed to send our notification
     assert obj.send(user='test', password='passwd', body="test") is False
+    del obj
 
     response_obj = {
         # Registration
@@ -489,6 +503,7 @@ def test_plugin_matrix_fetch(mock_post,
     })
     code, response = obj._fetch('/retry/apprise/unit/test')
     assert code is False
+    del obj
 
 
 @mock.patch('requests.put')
@@ -550,6 +565,7 @@ def test_plugin_matrix_auth(mock_post, m
     # Our registration will fail now
     assert obj._register() is False
     assert obj.access_token is None
+    del obj
 
     # So will login
     obj = NotifyMatrix(host='host', user='user', password='password')
@@ -585,6 +601,7 @@ def test_plugin_matrix_auth(mock_post, m
     # code in the response, then we return a True
     assert obj._logout() is True
     assert obj.access_token is None
+    del obj
 
 
 @mock.patch('requests.put')
@@ -673,6 +690,7 @@ def test_plugin_matrix_rooms(mock_post,
     assert obj._room_join('abc123:localhost') is None
     obj._room_cache = {}
     assert obj._room_join('#abc123:localhost') is None
+    del obj
 
     # Room creation
     request.status_code = requests.codes.ok
@@ -717,6 +735,7 @@ def test_plugin_matrix_rooms(mock_post,
     obj._room_cache = {}
     # This causes us to look up a channel ID if we get a ROOM_IN_USE response
     assert obj._room_create('#abc123:localhost') is None
+    del obj
 
     # Room detection
     request.status_code = requests.codes.ok
@@ -744,6 +763,7 @@ def test_plugin_matrix_rooms(mock_post,
     response = obj._joined_rooms()
     assert isinstance(response, list) is True
     assert len(response) == 0
+    del obj
 
     # Room id lookup
     request.status_code = requests.codes.ok
@@ -842,6 +862,7 @@ def test_plugin_matrix_image_errors(mock
     # Notification was successful, however we could not post image and since
     # we had post errors (of any kind) we still report a failure.
     assert obj.notify('test', 'test') is False
+    del obj
 
     obj = NotifyMatrix(host='host', include_image=False, version='2')
     assert isinstance(obj, NotifyMatrix) is True
@@ -881,6 +902,7 @@ def test_plugin_matrix_image_errors(mock
     assert obj.access_token is None
 
     assert obj.notify('test', 'test') is True
+    del obj
 
     obj = NotifyMatrix(host='host', include_image=False)
     assert isinstance(obj, NotifyMatrix) is True
@@ -1137,3 +1159,79 @@ def test_plugin_matrix_attachments_api_v
 
     # Force __del__() call
     del obj
+
+
+@mock.patch('requests.put')
+@mock.patch('requests.get')
+@mock.patch('requests.post')
+def test_plugin_matrix_transaction_ids_api_v3(mock_post, mock_get, mock_put):
+    """
+    NotifyMatrix() Transaction ID Checks (v3)
+
+    """
+
+    # Prepare a good response
+    response = mock.Mock()
+    response.status_code = requests.codes.ok
+    response.content = MATRIX_GOOD_RESPONSE.encode('utf-8')
+
+    # Prepare a bad response
+    bad_response = mock.Mock()
+    bad_response.status_code = requests.codes.internal_server_error
+
+    # Prepare Mock return object
+    mock_post.return_value = response
+    mock_get.return_value = response
+    mock_put.return_value = response
+
+    batch = [10, 1, 5]
+
+    for notifications in batch:
+        # Instantiate our object
+        obj = Apprise.instantiate('matrix://user:pass@localhost/#general?v=3')
+
+        # Performs a login
+        assert obj.notify(
+            body='body', title='title', notify_type=NotifyType.INFO
+        ) is True
+        assert mock_get.call_count == 0
+        assert mock_post.call_count == 2
+        assert mock_post.call_args_list[0][0][0] == \
+            'http://localhost/_matrix/client/v3/login'
+        assert mock_post.call_args_list[1][0][0] == \
+            'http://localhost/_matrix/client/v3/join/%23general%3Alocalhost'
+        assert mock_put.call_count == 1
+        assert mock_put.call_args_list[0][0][0] == \
+            'http://localhost/_matrix/client/v3/rooms/' + \
+            '%21abc123%3Alocalhost/send/m.room.message/0'
+
+        for no, _ in enumerate(range(notifications), start=1):
+            # Clean our slate
+            mock_post.reset_mock()
+            mock_get.reset_mock()
+            mock_put.reset_mock()
+
+            assert obj.notify(
+                body='body', title='title', notify_type=NotifyType.INFO
+            ) is True
+
+            assert mock_get.call_count == 0
+            assert mock_post.call_count == 0
+            assert mock_put.call_count == 1
+            assert mock_put.call_args_list[0][0][0] == \
+                'http://localhost/_matrix/client/v3/rooms/' + \
+                f'%21abc123%3Alocalhost/send/m.room.message/{no}'
+
+        mock_post.reset_mock()
+        mock_get.reset_mock()
+        mock_put.reset_mock()
+
+        # Force a object removal (thus a logout call)
+        del obj
+
+        assert mock_get.call_count == 0
+        assert mock_post.call_count == 1
+        assert mock_post.call_args_list[0][0][0] == \
+            'http://localhost/_matrix/client/v3/logout'
+        mock_post.reset_mock()
+        assert mock_put.call_count == 0
diff -pruN 1.8.0-3/test/test_plugin_mattermost.py 1.8.1-1/test/test_plugin_mattermost.py
--- 1.8.0-3/test/test_plugin_mattermost.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_mattermost.py	2024-07-26 00:19:02.000000000 +0000
@@ -66,10 +66,10 @@ apprise_url_tests = (
     ('mmost://localhost/3ccdd113474722377935511fc85d3dd4'
      '?to=test&image=True', {
          'instance': NotifyMattermost}),
-    ('mmost://localhost/3ccdd113474722377935511fc85d3dd4' \
+    ('mmost://localhost/3ccdd113474722377935511fc85d3dd4'
      '?to=test&image=False', {
          'instance': NotifyMattermost}),
-    ('mmost://localhost/3ccdd113474722377935511fc85d3dd4' \
+    ('mmost://localhost/3ccdd113474722377935511fc85d3dd4'
      '?to=test&image=True', {
          'instance': NotifyMattermost,
          # don't include an image by default
diff -pruN 1.8.0-3/test/test_plugin_notifiarr.py 1.8.1-1/test/test_plugin_notifiarr.py
--- 1.8.0-3/test/test_plugin_notifiarr.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_notifiarr.py	2024-07-26 00:19:02.000000000 +0000
@@ -27,9 +27,11 @@
 # POSSIBILITY OF SUCH DAMAGE.
 
 import requests
-
+from unittest import mock
 from apprise.plugins.notifiarr import NotifyNotifiarr
 from helpers import AppriseURLTester
+from json import loads
+from inspect import cleandoc
 
 # Disable logging for a cleaner testing output
 import logging
@@ -52,12 +54,6 @@ apprise_url_tests = (
         # Our expected url(privacy=True) startswith() response:
         'privacy_url': 'notifiarr://a...y',
     }),
-    ('notifiarr://apikey/1234/?discord_user=invalid', {
-        'instance': TypeError,
-    }),
-    ('notifiarr://apikey/1234/?discord_role=invalid', {
-        'instance': TypeError,
-    }),
     ('notifiarr://apikey/1234/?event=invalid', {
         'instance': TypeError,
     }),
@@ -131,11 +127,6 @@ apprise_url_tests = (
         # Our expected url(privacy=True) startswith() response:
         'privacy_url': 'notifiarr://m...y/#123/#325',
     }),
-    ('notifiarr://12/?key=myapikey&discord_user=23'
-     '&discord_role=12&event=123', {
-         'instance': NotifyNotifiarr,
-         # Our expected url(privacy=True) startswith() response:
-         'privacy_url': 'notifiarr://m...y/#12'}),
     ('notifiarr://apikey/123/', {
         'instance': NotifyNotifiarr,
     }),
@@ -160,7 +151,7 @@ apprise_url_tests = (
 )
 
 
-def test_plugin_custom_notifiarr_urls():
+def test_plugin_notifiarr_urls():
     """
     NotifyNotifiarr() Apprise URLs
 
@@ -168,3 +159,64 @@ def test_plugin_custom_notifiarr_urls():
 
     # Run our general tests
     AppriseURLTester(tests=apprise_url_tests).run_all()
+
+
+@mock.patch('requests.post')
+def test_plugin_notifiarr_notifications(mock_post):
+    """
+    NotifyNotifiarr() Notifications/Ping Support
+
+    """
+
+    # Test our header parsing when not lead with a header
+    body = cleandoc("""
+    # Heading
+    @everyone and @admin, wake and meet our new user <@123> and <@987>;
+    Attention Roles: <@&456> and <@&765>
+     """)
+
+    # Prepare a good response
+    response = mock.Mock()
+    response.status_code = requests.codes.ok
+
+    # Prepare Mock return object
+    mock_post.return_value = response
+
+    results = NotifyNotifiarr.parse_url('notifiarr://apikey/12345')
+
+    instance = NotifyNotifiarr(**results)
+    assert isinstance(instance, NotifyNotifiarr)
+
+    response = instance.send(body=body)
+    assert response is True
+    assert mock_post.call_count == 1
+
+    details = mock_post.call_args_list[0]
+    assert details[0][0] == \
+        'https://notifiarr.com/api/v1/notification/apprise'
+
+    payload = loads(details[1]['data'])
+
+    # First role and first user stored
+    assert payload == {
+        'source': 'Apprise',
+        'type': 'info',
+        'notification': {'update': False, 'name': 'Apprise', 'event': ''},
+        'discord': {
+            'color': '#3AA3E3', 'ping': {
+                # Only supports 1 entry each; so first one is parsed
+                'pingUser': '123',
+                'pingRole': '456',
+            },
+            'text': {
+                'title': '',
+                'content': '👉 @everyone @admin <@123> <@987> <@&456> <@&765>',
+                'description':
+                    '# Heading\n@everyone and @admin, wake and meet our new '
+                    'user <@123> and <@987>;\nAttention Roles: <@&456> and '
+                    '<@&765>\n ',
+                    'footer': 'Apprise Notifications',
+            },
+            'ids': {'channel': 12345},
+        },
+    }
diff -pruN 1.8.0-3/test/test_plugin_ntfy.py 1.8.1-1/test/test_plugin_ntfy.py
--- 1.8.0-3/test/test_plugin_ntfy.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_ntfy.py	2024-07-26 00:19:02.000000000 +0000
@@ -26,6 +26,7 @@
 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
 
+import re
 import os
 import json
 from unittest import mock
@@ -571,3 +572,47 @@ def test_plugin_ntfy_config_files(mock_p
     assert len([x for x in aobj.find(tag='ntfy_invalid')]) == 1
     assert next(aobj.find(tag='ntfy_invalid')).priority == \
         NtfyPriority.NORMAL
+
+
+@mock.patch('requests.post')
+def test_plugin_ntfy_message_to_attach(mock_post):
+    """
+    NotifyNtfy() large messages converted into attachments
+
+    """
+
+    # Prepare Mock return object
+    response = mock.Mock()
+    response.content = GOOD_RESPONSE_TEXT
+    response.status_code = requests.codes.ok
+    mock_post.return_value = response
+
+    # Create a very, very big message
+    title = 'My Title'
+    body = 'b' * NotifyNtfy.ntfy_json_upstream_size_limit
+
+    for fmt in apprise.NOTIFY_FORMATS:
+
+        # Prepare our object
+        obj = apprise.Apprise.instantiate(
+            'ntfy://user:pass@localhost:8080/topic?format={}'.format(fmt))
+
+        # Our content will actually transfer as an attachment
+        assert obj.notify(title=title, body=body)
+        assert mock_post.call_count == 1
+
+        assert mock_post.call_args_list[0][0][0] == \
+            'http://localhost:8080/topic'
+
+        response = mock_post.call_args_list[0][1]
+        assert 'data' in response
+        assert response['data'].decode('utf-8').startswith(title)
+        assert response['data'].decode('utf-8').endswith(body)
+        assert 'params' in response
+        assert 'filename' in response['params']
+        # Our filename is automatically generated (with .txt)
+        assert re.match(
+            r'^[a-z0-9-]+\.txt$', response['params']['filename'], re.I)
+
+        # Reset our mock object
+        mock_post.reset_mock()
diff -pruN 1.8.0-3/test/test_plugin_office365.py 1.8.1-1/test/test_plugin_office365.py
--- 1.8.0-3/test/test_plugin_office365.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_office365.py	2024-07-26 00:19:02.000000000 +0000
@@ -96,7 +96,7 @@ apprise_url_tests = (
         },
 
         # Our expected url(privacy=True) startswith() response:
-        'privacy_url': 'o365://t...t:user@example.com/a...h/' \
+        'privacy_url': 'o365://t...t:user@example.com/a...h/'
                        '****/email1%40test.ca/'}),
     # test our arguments
     ('o365://_/?oauth_id={cid}&oauth_secret={secret}&tenant={tenant}'
@@ -117,7 +117,7 @@ apprise_url_tests = (
             },
 
             # Our expected url(privacy=True) startswith() response:
-            'privacy_url': 'o365://t...t:user@example.com/a...h/' \
+            'privacy_url': 'o365://t...t:user@example.com/a...h/'
                            '****/email1%40test.ca/'}),
     # Test invalid JSON (no tenant defaults to email domain)
     ('o365://{tenant}:{aid}/{cid}/{secret}/{targets}'.format(
diff -pruN 1.8.0-3/test/test_plugin_onesignal.py 1.8.1-1/test/test_plugin_onesignal.py
--- 1.8.0-3/test/test_plugin_onesignal.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_onesignal.py	2024-07-26 00:19:02.000000000 +0000
@@ -26,6 +26,10 @@
 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
 
+from json import loads
+from unittest import mock
+import pytest
+import requests
 from apprise.plugins.one_signal import NotifyOneSignal
 from helpers import AppriseURLTester
 from apprise import Apprise
@@ -105,6 +109,16 @@ apprise_url_tests = (
         # Test Kwargs
         'instance': NotifyOneSignal,
     }),
+    ('onesignal://?apikey=abc&template=tp&app=123&to=playerid&body=no'
+     '&:key1=val1&:key2=val2', {
+         # Test Kwargs
+         'instance': NotifyOneSignal,
+     }),
+    ('onesignal://?apikey=abc&template=tp&app=123&to=playerid&body=no'
+     '&+key1=val1&+key2=val2', {
+         # Test Kwargs
+         'instance': NotifyOneSignal,
+     }),
     ('onesignal://appid@apikey/#segment/playerid/', {
         'instance': NotifyOneSignal,
         # throw a bizzare code forcing us to fail to look it up
@@ -244,3 +258,159 @@ def test_plugin_onesignal_edge_cases():
 
     # Individual queries
     assert len(obj) == 16
+
+    # custom must be a dictionary
+    with pytest.raises(TypeError):
+        NotifyOneSignal(
+            app='appid', apikey='key', targets=['@user'], custom='not-a-dict')
+
+    # postback must be a dictionary
+    with pytest.raises(TypeError):
+        NotifyOneSignal(
+            app='appid', apikey='key', targets=['@user'],
+            custom=[], postback='not-a-dict')
+
+
+@mock.patch('requests.post')
+def test_plugin_onesignal_notifications(mock_post):
+    """
+    OneSignal() Notifications Support
+
+    """
+    # Prepare Mock
+    mock_post.return_value = requests.Request()
+    mock_post.return_value.status_code = requests.codes.ok
+
+    # Load URL with Template
+    instance = Apprise.instantiate(
+        'onesignal://templateid:appid@apikey/@user/?:key1=value1&+key3=value3')
+
+    # Validate that it loaded okay
+    assert isinstance(instance, NotifyOneSignal)
+
+    response = instance.notify("hello world")
+    assert response is True
+    assert mock_post.call_count == 1
+    assert mock_post.call_args_list[0][0][0] == \
+        'https://api.onesignal.com/notifications'
+
+    details = mock_post.call_args_list[0]
+    payload = loads(details[1]['data'])
+
+    assert payload == {
+        'app_id': 'appid',
+        'contents': {'en': 'hello world'},
+        'content_available': True,
+        'template_id': 'templateid',
+        'custom_data': {'key1': 'value1'},
+        'data': {'key3': 'value3'},
+        'large_icon': 'https://github.com/caronc/apprise'
+        '/raw/master/apprise/assets/themes/default/apprise-info-72x72.png',
+        'small_icon': 'https://github.com/caronc/apprise'
+        '/raw/master/apprise/assets/themes/default/apprise-info-32x32.png',
+        'include_external_user_ids': ['@user']}
+
+    mock_post.reset_mock()
+
+    # Load URL with Template and disable body
+    instance = Apprise.instantiate(
+        'onesignal://templateid:appid@apikey/@user/?contents=no')
+
+    # Validate that it loaded okay
+    assert isinstance(instance, NotifyOneSignal)
+
+    response = instance.notify("hello world")
+    assert response is True
+    assert mock_post.call_count == 1
+    assert mock_post.call_args_list[0][0][0] == \
+        'https://api.onesignal.com/notifications'
+
+    details = mock_post.call_args_list[0]
+    payload = loads(details[1]['data'])
+
+    assert payload == {
+        'app_id': 'appid',
+        'content_available': True,
+        'template_id': 'templateid',
+        'large_icon': 'https://github.com/caronc/apprise'
+        '/raw/master/apprise/assets/themes/default/apprise-info-72x72.png',
+        'small_icon': 'https://github.com/caronc/apprise'
+        '/raw/master/apprise/assets/themes/default/apprise-info-32x32.png',
+        'include_external_user_ids': ['@user']}
+
+    # Now set a title
+    mock_post.reset_mock()
+
+    response = instance.notify("hello world", title="mytitle")
+
+    assert response is True
+    assert mock_post.call_count == 1
+    assert mock_post.call_args_list[0][0][0] == \
+        'https://api.onesignal.com/notifications'
+
+    details = mock_post.call_args_list[0]
+    payload = loads(details[1]['data'])
+
+    assert payload == {
+        'app_id': 'appid',
+        'headings': {'en': 'mytitle'},
+        'content_available': True,
+        'template_id': 'templateid',
+        'large_icon': 'https://github.com/caronc/apprise'
+        '/raw/master/apprise/assets/themes/default/apprise-info-72x72.png',
+        'small_icon': 'https://github.com/caronc/apprise'
+        '/raw/master/apprise/assets/themes/default/apprise-info-32x32.png',
+        'include_external_user_ids': ['@user']}
+
+    # Test without decoding parameters
+    instance = Apprise.instantiate(
+        'onesignal://templateid:appid@apikey/@user/'
+        '?:par=b64:eyJhIjoxLCJiIjoyfQ==&decode=no')
+    assert isinstance(instance, NotifyOneSignal) and \
+        instance.custom_data == {"par": "b64:eyJhIjoxLCJiIjoyfQ=="}
+
+    # Now same with loading parameters
+    instance = Apprise.instantiate(
+        'onesignal://templateid:appid@apikey/@user/'
+        '?:par=b64:eyJhIjoxLCJiIjoyfQ==&decode=yes')
+    assert isinstance(instance, NotifyOneSignal) and \
+        instance.custom_data == {"par": {"a": 1, "b": 2}}
+
+    # Test bad data in general
+    instance = Apprise.instantiate(
+        'onesignal://templateid:appid@apikey/@user/'
+        '?:par=garbage1&decode=yes')
+    assert isinstance(instance, NotifyOneSignal) and \
+        instance.custom_data == {"par": 'garbage1'}
+
+    instance = Apprise.instantiate(
+        'onesignal://templateid:appid@apikey/@user/'
+        '?:par=b64:garbage2&decode=yes')
+    assert isinstance(instance, NotifyOneSignal) and \
+        instance.custom_data == {"par": 'b64:garbage2'}
+
+    instance = Apprise.instantiate(
+        'onesignal://templateid:appid@apikey/@user/'
+        '?:par=b64:garbage3==&decode=yes')
+    assert isinstance(instance, NotifyOneSignal) and \
+        instance.custom_data == {"par": 'b64:garbage3=='}
+
+    # Now same with not-base64 parameters
+    instance = Apprise.instantiate(
+        'onesignal://templateid:appid@apikey/@user/'
+        '?:par=eyJhIjoxLCJiIjoyfQ==&:par2=123&decode=yes')
+    assert isinstance(instance, NotifyOneSignal) and \
+        instance.custom_data == {
+        "par": "eyJhIjoxLCJiIjoyfQ==", "par2": "123"
+    }
+
+    # Test incorrect base64 parameters. Second one has incorrect padding
+    url = 'onesignal://templateid:appid@apikey/@user/' \
+        '?:par=b64:1234=&:par2=b64:eyJhIjoxLCJiIjoyfQ&' \
+        ':par3=b64:eyJhIjoxLCJiIjoyfQ==&decode=yes'
+    instance = Apprise.instantiate(url)
+    assert isinstance(instance, NotifyOneSignal) and instance.custom_data == {
+        "par": "b64:1234=",
+        "par2": "b64:eyJhIjoxLCJiIjoyfQ",
+        "par3": {"a": 1, "b": 2}
+    }
diff -pruN 1.8.0-3/test/test_plugin_sfr.py 1.8.1-1/test/test_plugin_sfr.py
--- 1.8.0-3/test/test_plugin_sfr.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/test/test_plugin_sfr.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,569 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+from unittest import mock
+import pytest
+import requests
+import json
+from apprise.plugins.sfr import NotifySFR
+from helpers import AppriseURLTester
+
+# Disable logging for a cleaner testing output
+import logging
+logging.disable(logging.CRITICAL)
+
+SFR_GOOD_RESPONSE = json.dumps({
+    "success": True,
+    "reponse": 8888888,
+})
+
+SFR_BAD_RESPONSE = json.dumps({
+    'success': False,
+    'errorCode': 'THIS_IS_AN_ERROR',
+    'errorDetail': 'Appel api en erreur',
+    'fatal': True,
+    'invalidParams': True,
+})
+
+# Our Testing URLs
+apprise_url_tests = (
+    ('sfr://', {
+        # No host specified
+        'instance': TypeError,
+    }),
+    ('sfr://:@/', {
+        # Invalid host
+        'instance': TypeError,
+    }),
+    ('sfr://:service_password', {
+        # No user specified
+        'instance': TypeError,
+    }),
+    ('sfr://testing:serv@ice_password', {
+        # Invalid Password
+        'instance': TypeError,
+    }),
+    ('sfr://testing:service_password@/5555555555', {
+        # No spaceId provided
+        'instance': TypeError,
+    }),
+    ('sfr://testing:service_password@12345/', {
+        # No target provided
+        'instance': TypeError,
+    }),
+    ('sfr://:service_password@12345/{}'.format(3 * 13), {
+        # No host but everything else provided
+        'instance': TypeError,
+    }),
+    ('sfr://:service_password@space_id/targets?media=TEST', {
+        'instance': TypeError,
+    }),
+    ('sfr://service_id:', {
+        'instance': TypeError,
+    }),
+    ('sfr://service_id:@', {
+        'instance': TypeError,
+    }),
+    ('sfr://service_id:@{}'.format(
+        '0' * 3), {
+        'instance': TypeError,
+    }),
+    ('sfr://service_id:@{}/'.format(
+        '0' * 3), {
+        'instance': TypeError,
+    }),
+    ('sfr://service_id:@{}/targets'.format(
+        '0' * 3), {
+        'instance': TypeError,
+    }),
+    ('sfr://service_id:@{}/targets?media=TEST'.format(
+        '0' * 3), {
+        'instance': TypeError,
+    }),
+    ('sfr://service_id:service_password@{}/{}?from=MyApp&timeout=30'.format(
+        '0' * 3, '0' * 10), {
+        # a valid group
+        'instance': NotifySFR,
+        # Our expected url(privacy=True) startswith() response:
+        'privacy_url': (
+            'sfr://service_id:****@0...0/0000000000?'
+            'from=MyApp&timeout=30&voice=claire08s&'
+            'lang=fr_FR&media=SMSUnicode&format=text'
+            '&overflow=upstream&rto=4.0&cto=4.0&verify=yes'),
+        # Our response expected server response
+        'requests_response_text': SFR_GOOD_RESPONSE,
+    }),
+    ('sfr://service_id:service_password@{}/{}?voice=laura8k&lang=en_US'.format(
+        '0' * 3, '0' * 10), {
+        # a valid group
+        'instance': NotifySFR,
+        # Our expected url(privacy=True) startswith() response:
+        'privacy_url': (
+            'sfr://service_id:****@0...0/0000000000?'
+            'from=&timeout=2880&voice=laura8k&'
+            'lang=en_US&media=SMSUnicode&format=text'
+            '&overflow=upstream&rto=4.0&cto=4.0&verify=yes'),
+        # Our response expected server response
+        'requests_response_text': SFR_GOOD_RESPONSE,
+    }),
+    ('sfr://service_id:service_password@{}/{}?media=SMS'.format(
+        '0' * 3, '0' * 10), {
+        # a valid group
+        'instance': NotifySFR,
+        # Our expected url(privacy=True) startswith() response:
+        'privacy_url': (
+            'sfr://service_id:****@0...0/0000000000?'
+            'from=&timeout=2880&voice=claire08s&'
+            'lang=fr_FR&media=SMS&format=text'
+            '&overflow=upstream&rto=4.0&cto=4.0&verify=yes'),
+        # Our response expected server response
+        'requests_response_text': SFR_GOOD_RESPONSE,
+    }),
+    ('sfr://service_id:service_password@{}/{}'.format(
+        '0' * 3, '0' * 10), {
+        # Test case where we get a bad response
+        'instance': NotifySFR,
+        # Our expected url(privacy=True) startswith() response:
+        'privacy_url': (
+            'sfr://service_id:****@0...0/0000000000?'
+            'from=&timeout=2880&voice=claire08s&'
+            'lang=fr_FR&media=SMSUnicode&format=text'
+            '&overflow=upstream&rto=4.0&cto=4.0&verify=yes'),
+        # Our failed notification expected server response
+        'requests_response_text': SFR_BAD_RESPONSE,
+        'requests_response_code': requests.codes.ok,
+        # as a result, we expect a failed notification
+        'response': False,
+    }),
+)
+
+
+def test_plugin_sfr_urls():
+    """
+    NotifySFR() Apprise URLs
+    """
+    # Run our general tests
+    AppriseURLTester(tests=apprise_url_tests).run_all()
+
+
+@mock.patch('requests.post')
+def test_plugin_sfr_notification_ok(mock_post):
+    """
+    NotifySFR() Notifications Ok response
+    """
+    # Prepare Mock
+    # Create a mock response object
+    response = mock.Mock()
+    response.status_code = requests.codes.ok
+    response.content = SFR_GOOD_RESPONSE
+    mock_post.return_value = response
+
+    # Test our URL parsing
+    results = NotifySFR.parse_url(
+        'sfr://srv:pwd@{}/{}?media=SMSLong'.format('1' * 8, '0' * 10))
+
+    assert isinstance(results, dict)
+    assert results['user'] == 'srv'
+    assert results['password'] == 'pwd'
+    assert results['space_id'] == '11111111'
+    assert results['targets'] == ['0000000000']
+    assert results['media'] == 'SMSLong'
+    assert results['timeout'] == ''
+    assert results['voice'] == ''
+    assert results['lang'] == ''
+    assert results['sender'] == ''
+
+    instance = NotifySFR(**results)
+    assert isinstance(instance, NotifySFR)
+    assert len(instance) == 1
+    assert instance.lang == 'fr_FR'
+    assert instance.lang == 'fr_FR'
+    assert instance.sender == ''
+    assert isinstance(instance.targets, list)
+    assert isinstance(instance.timeout, int)
+    assert isinstance(instance.voice, str)
+    assert isinstance(instance.space_id, str)
+
+    response = instance.send(body="test")
+    assert response is True
+    assert mock_post.call_count == 1
+
+
+@mock.patch('requests.post')
+def test_plugin_sfr_notification_multiple_targets_ok(mock_post):
+    """
+    NotifySFR() Notifications ko response
+    """
+    # Reset our object
+    mock_post.reset_mock()
+    # Prepare Mock
+    # Create a mock response object
+    response = mock.Mock()
+    response.status_code = requests.codes.ok
+    response.content = SFR_GOOD_RESPONSE
+    mock_post.return_value = response
+
+    # Test "real" parameters
+    results = NotifySFR.parse_url(
+        'sfr://{}:other_fjv&8password@{}/?to={},{}&from=MyCustomUser'.format(
+            '4' * 6, '1' * 8, '6' * 10, '8' * 10))
+
+    assert isinstance(results, dict)
+    assert results['user'] == '444444'
+    assert results['password'] == 'other_fjv&8password'
+    assert results['space_id'] == '11111111'
+    assert results['targets'] == ['6666666666', '8888888888']
+    assert results['media'] == ''
+    assert results['timeout'] == ''
+    assert results['voice'] == ''
+    assert results['lang'] == ''
+    assert results['sender'] == 'MyCustomUser'
+
+    instance = NotifySFR(**results)
+    assert isinstance(instance, NotifySFR)
+    assert len(instance) == 2
+    assert instance.lang == 'fr_FR'
+    assert instance.sender == 'MyCustomUser'
+    assert instance.media == 'SMSUnicode'
+    assert isinstance(instance.targets, list)
+    assert instance.timeout == 2880
+    assert instance.voice == 'claire08s'
+    assert isinstance(instance.space_id, str)
+
+    response = instance.send(body="test")
+    assert response is True
+    assert mock_post.call_count == 2
+
+
+@mock.patch('requests.post')
+def test_plugin_sfr_notification_ko(mock_post):
+    """
+    NotifySFR() Notifications ko response
+    """
+    # Reset our object
+    mock_post.reset_mock()
+    # Prepare Mock
+    # Create a mock response object
+    response = mock.Mock()
+    response.status_code = requests.codes.ok
+    response.content = SFR_BAD_RESPONSE
+    mock_post.return_value = response
+
+    # Test "real" parameters
+    results = NotifySFR.parse_url(
+        'sfr://{}:other_fjv&8password@{}/{}?timeout=30&media=SMS'.format(
+            '4' * 6, '1' * 8, '2' * 10))
+
+    assert isinstance(results, dict)
+    assert results['user'] == '444444'
+    assert results['password'] == 'other_fjv&8password'
+    assert results['space_id'] == '11111111'
+    assert results['media'] == 'SMS'
+    assert results['targets'] == ['2222222222']
+    assert results['timeout'] == '30'
+    assert results['voice'] == ''
+    assert results['lang'] == ''
+    assert results['sender'] == ''
+
+    instance = NotifySFR(**results)
+    assert isinstance(instance, NotifySFR)
+    assert len(instance) == 1
+    assert instance.lang == 'fr_FR'
+    assert instance.sender == ''
+    assert instance.media == 'SMS'
+    assert isinstance(instance.targets, list)
+    assert instance.timeout == 30
+    assert instance.voice == 'claire08s'
+    assert isinstance(instance.space_id, str)
+
+    response = instance.send(body="test")
+    assert response is False
+    assert mock_post.call_count == 1
+
+
+@mock.patch('requests.post')
+def test_plugin_sfr_notification_multiple_targets_all_ko(mock_post):
+    """
+    NotifySFR() Notifications ko response
+    """
+    # Reset our object
+    mock_post.reset_mock()
+    # Prepare Mock
+    # Create a mock response object
+    response = mock.Mock()
+    response.status_code = requests.codes.ok
+    response.content = SFR_BAD_RESPONSE
+    mock_post.return_value = response
+
+    # Test "real" parameters
+    results = NotifySFR.parse_url(
+        'sfr://{}:other_fjv&8password@{}/?to={},{}&voice=laura8k'.format(
+            '4' * 6, '1' * 8, '6' * 4, '8' * 4))
+
+    assert isinstance(results, dict)
+    assert results['user'] == '444444'
+    assert results['password'] == 'other_fjv&8password'
+    assert results['space_id'] == '11111111'
+    assert results['targets'] == ['6666', '8888']
+    assert results['voice'] == 'laura8k'
+    assert results['media'] == ''
+    assert results['timeout'] == ''
+    assert results['lang'] == ''
+    assert results['sender'] == ''
+
+    # No valid phone number provided
+    with pytest.raises(TypeError):
+        NotifySFR(**results)
+
+
+@mock.patch('requests.post')
+def test_plugin_sfr_notification_multiple_targets_one_ko(mock_post):
+    """
+    NotifySFR() Notifications ko response
+    """
+    # Reset our object
+    mock_post.reset_mock()
+    # Prepare Mock
+    # Create a mock response object
+    response = mock.Mock()
+    response.status_code = requests.codes.ok
+    response.content = SFR_BAD_RESPONSE
+    mock_post.return_value = response
+
+    # Test "real" parameters
+    results = NotifySFR.parse_url(
+        'sfr://{}:&pass@{}/?to={},{}&media=SMSUnicodeLong&lang=en_US'.format(
+            '4' * 6, '1' * 8, '6' * 10, '8' * 4))
+
+    assert isinstance(results, dict)
+    assert results['user'] == '444444'
+    assert results['password'] == '&pass'
+    assert results['space_id'] == '11111111'
+    assert results['targets'] == ['6666666666', '8888']
+    assert results['voice'] == ''
+    assert results['media'] == 'SMSUnicodeLong'
+    assert results['timeout'] == ''
+    assert results['lang'] == 'en_US'
+    assert results['sender'] == ''
+
+    instance = NotifySFR(**results)
+    assert isinstance(instance, NotifySFR)
+    assert len(instance) == 1
+    assert instance.lang == 'en_US'
+    assert instance.sender == ''
+    assert instance.media == 'SMSUnicodeLong'
+    assert isinstance(instance.targets, list)
+    assert instance.timeout == 2880
+    assert instance.voice == 'claire08s'
+    assert isinstance(instance.space_id, str)
+
+    # One phone number failed to be parsed, therefore notify fails
+    response = instance.send(body="test")
+    assert response is False
+    assert mock_post.call_count == 1
+
+
+@mock.patch('requests.post')
+def test_plugin_sfr_notification_exceptions(mock_post):
+    """
+    NotifySFR() Notifications exceptions
+    """
+    mock_post.reset_mock()
+    # Prepare Mock
+    # Create a mock response object
+    response = mock.Mock()
+    response.status_code = requests.codes.internal_server_error
+    response.content = SFR_GOOD_RESPONSE
+    mock_post.return_value = response
+
+    # Test "real" parameters
+    results = NotifySFR.parse_url(
+        'sfr://{}:str0*fn_ppw0rd@{}/{}'.format(
+            "404ghwo89144", '9993384', '0959290404'))
+
+    assert isinstance(results, dict)
+    assert results['user'] == '404ghwo89144'
+    assert results['password'] == 'str0*fn_ppw0rd'
+    assert results['space_id'] == '9993384'
+    assert results['targets'] == ['0959290404']
+    assert results['media'] == ''
+    assert results['timeout'] == ''
+    assert results['lang'] == ''
+    assert results['sender'] == ''
+
+    instance = NotifySFR(**results)
+    assert isinstance(instance, NotifySFR)
+    assert len(instance) == 1
+    assert instance.lang == 'fr_FR'
+    assert instance.sender == ''
+    assert instance.media == 'SMSUnicode'
+    assert isinstance(instance.targets, list)
+    assert instance.timeout == 2880
+    assert instance.voice == 'claire08s'
+    assert isinstance(instance.space_id, str)
+
+    response = instance.send(body="test")
+    # Must return False
+    assert response is False
+    assert mock_post.call_count == 1
+
+    # Test invalid content returned by requests
+    mock_post.reset_mock()
+    response = mock.Mock()
+    response.status_code = requests.codes.ok
+    response.content = b'Invalid JSON Content'
+    mock_post.return_value = response
+
+    # Test "real" parameters
+    results = NotifySFR.parse_url(
+        'sfr://{}:str0*fn_ppw0rd@{}/{}'.format(
+            "404ghwo89144", '9993384', '0959290404'))
+
+    assert isinstance(results, dict)
+    assert results['user'] == '404ghwo89144'
+    assert results['password'] == 'str0*fn_ppw0rd'
+    assert results['space_id'] == '9993384'
+    assert results['targets'] == ['0959290404']
+    assert results['media'] == ''
+    assert results['timeout'] == ''
+    assert results['lang'] == ''
+    assert results['sender'] == ''
+
+    instance = NotifySFR(**results)
+    assert isinstance(instance, NotifySFR)
+    assert len(instance) == 1
+    assert instance.lang == 'fr_FR'
+    assert instance.sender == ''
+    assert instance.media == 'SMSUnicode'
+    assert isinstance(instance.targets, list)
+    assert instance.timeout == 2880
+    assert instance.voice == 'claire08s'
+    assert isinstance(instance.space_id, str)
+
+    response = instance.send(body="test")
+    # Must return False
+    assert response is False
+    assert mock_post.call_count == 1
+
+
+@mock.patch(
+    'requests.post',
+    side_effect=requests.RequestException("Connection error"),
+)
+def test_plugin_sfr_notification_exceptions_requests(mock_post):
+    """
+    NotifySFR() Notifications requests exceptions
+    """
+    # Test requests socket error return
+    mock_post.reset_mock()
+    # Prepare Mock
+    # Create a mock response object
+    response = mock.Mock()
+    response.status_code = requests.codes.internal_server_error
+    response.content = b'Invalid content'
+    mock_post.return_value = response
+
+    # Test "real" parameters
+    results = NotifySFR.parse_url(
+        'sfr://{}:str0*fn_ppw0rd@{}/{}'.format(
+            "404ghwo89144", '9993384', '0959290404'))
+
+    assert isinstance(results, dict)
+    assert results['user'] == '404ghwo89144'
+    assert results['password'] == 'str0*fn_ppw0rd'
+    assert results['space_id'] == '9993384'
+    assert results['targets'] == ['0959290404']
+    assert results['media'] == ''
+    assert results['timeout'] == ''
+    assert results['lang'] == ''
+    assert results['sender'] == ''
+
+    instance = NotifySFR(**results)
+    assert isinstance(instance, NotifySFR)
+    assert len(instance) == 1
+    assert instance.lang == 'fr_FR'
+    assert instance.sender == ''
+    assert instance.media == 'SMSUnicode'
+    assert isinstance(instance.targets, list)
+    assert instance.timeout == 2880
+    assert instance.voice == 'claire08s'
+    assert isinstance(instance.space_id, str)
+
+    response = instance.send(body="test")
+    # Must return False do to requests error
+    assert response is False
+    assert mock_post.call_count == 1
+
+
+@mock.patch('requests.post')
+def test_plugin_sfr_failure(mock_post):
+    """
+    NotifySFR() Failure Cases
+    """
+    mock_post.reset_mock()
+    # Prepare Mock
+    # Create a mock response object
+    response = mock.Mock()
+    response.status_code = requests.codes.no_content
+    mock_post.return_value = response
+
+    # Invalid service_id
+    with pytest.raises(TypeError):
+        NotifySFR(
+            user=None,
+            password="service_password",
+            space_id=int('8' * 10),
+            targets=int('8' * 10),
+        )
+
+    # Invalid service_password
+    with pytest.raises(TypeError):
+        NotifySFR(
+            user="service_id",
+            password=None,
+            space_id=int('8' * 10),
+            targets=int('8' * 10),
+        )
+
+    # Invalid space_id
+    with pytest.raises(TypeError):
+        NotifySFR(
+            user="service_id",
+            password="service_password",
+            space_id=None,
+            targets=int('8' * 10),
+        )
+
+    # Invalid targets
+    with pytest.raises(TypeError):
+        NotifySFR(
+            user="service_id",
+            password="service_password",
+            space_id=int('8' * 10),
+            targets=None,
+        )
diff -pruN 1.8.0-3/test/test_plugin_slack.py 1.8.1-1/test/test_plugin_slack.py
--- 1.8.0-3/test/test_plugin_slack.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_slack.py	2024-07-26 00:19:02.000000000 +0000
@@ -131,10 +131,6 @@ apprise_url_tests = (
         'requests_response_text': {
             'ok': True,
             'message': '',
-            # support attachments
-            'file': {
-                'url_private': 'http://localhost/',
-            },
         },
     }),
     # Test blocks mode
@@ -170,10 +166,6 @@ apprise_url_tests = (
         'requests_response_text': {
             'ok': True,
             'message': '',
-            # support attachments
-            'file': {
-                'url_private': 'http://localhost/',
-            },
         },
         # Our expected url(privacy=True) startswith() response:
         'privacy_url': 'slack://test@x...4/nuxref/',
@@ -184,10 +176,6 @@ apprise_url_tests = (
         'requests_response_text': {
             'ok': True,
             'message': '',
-            # support attachments
-            'file': {
-                'url_private': 'http://localhost/',
-            },
         },
         # We fail because of the empty channel #$ and #-
         'notify_response': False,
@@ -289,8 +277,8 @@ def test_plugin_slack_urls():
     AppriseURLTester(tests=apprise_url_tests).run_all()
 
 
-@mock.patch('requests.post')
-def test_plugin_slack_oauth_access_token(mock_post):
+@mock.patch('requests.request')
+def test_plugin_slack_oauth_access_token(mock_request):
     """
     NotifySlack() OAuth Access Token Tests
 
@@ -303,11 +291,7 @@ def test_plugin_slack_oauth_access_token
     request.content = dumps({
         'ok': True,
         'message': '',
-
-        # Attachment support
-        'file': {
-            'url_private': 'http://localhost',
-        }
+        'channel': 'C123456',
     })
     request.status_code = requests.codes.ok
 
@@ -319,8 +303,7 @@ def test_plugin_slack_oauth_access_token
     token = 'xoxb-1234-1234-abc124'
 
     # Prepare Mock
-    mock_post.return_value = request
-
+    mock_request.return_value = request
     # Variation Initializations
     obj = NotifySlack(access_token=token, targets='#apprise')
     assert isinstance(obj, NotifySlack) is True
@@ -330,7 +313,34 @@ def test_plugin_slack_oauth_access_token
     assert obj.send(body="test") is True
 
     # Test Valid Attachment
-    mock_post.reset_mock()
+    mock_request.reset_mock()
+    mock_request.side_effect = [
+        request,
+        mock.Mock(**{
+            'content': dumps({
+                "ok": True,
+                "upload_url": "https://files.slack.com/upload/v1/ABC123",
+                "file_id": "F123ABC456"
+            }),
+            'status_code': requests.codes.ok
+        }),
+        mock.Mock(**{
+            'content': b'OK - 123',
+            'status_code': requests.codes.ok
+        }),
+        mock.Mock(**{
+            'content': dumps({
+                "ok": True,
+                "files": [
+                    {
+                        "id": "F123ABC456",
+                        "title": "slack-test"
+                    }
+                ]
+            }),
+            'status_code': requests.codes.ok
+        }),
+    ]
 
     path = os.path.join(TEST_VAR_DIR, 'apprise-test.gif')
     attach = AppriseAttachment(path)
@@ -338,30 +348,42 @@ def test_plugin_slack_oauth_access_token
         body='body', title='title', notify_type=NotifyType.INFO,
         attach=attach) is True
 
-    assert mock_post.call_count == 2
-    assert mock_post.call_args_list[0][0][0] == \
+    assert mock_request.call_count == 4
+    assert mock_request.call_args_list[0][0][0] == \
+        'post'
+    assert mock_request.call_args_list[0][0][1] == \
         'https://slack.com/api/chat.postMessage'
-    assert mock_post.call_args_list[1][0][0] == \
-        'https://slack.com/api/files.upload'
+    assert mock_request.call_args_list[1][0][0] == \
+        'get'
+    assert mock_request.call_args_list[1][0][1] == \
+        'https://slack.com/api/files.getUploadURLExternal'
+    assert mock_request.call_args_list[2][0][0] == \
+        'post'
+    assert mock_request.call_args_list[2][0][1] == \
+        'https://files.slack.com/upload/v1/ABC123'
+    assert mock_request.call_args_list[3][0][0] == \
+        'post'
+    assert mock_request.call_args_list[3][0][1] == \
+        'https://slack.com/api/files.completeUploadExternal'
 
     # Test a valid attachment that throws an Connection Error
-    mock_post.return_value = None
-    mock_post.side_effect = (request, requests.ConnectionError(
+    mock_request.return_value = None
+    mock_request.side_effect = (request, requests.ConnectionError(
         0, 'requests.ConnectionError() not handled'))
     assert obj.notify(
         body='body', title='title', notify_type=NotifyType.INFO,
         attach=attach) is False
 
     # Test a valid attachment that throws an OSError
-    mock_post.return_value = None
-    mock_post.side_effect = (request, OSError(0, 'OSError'))
+    mock_request.return_value = None
+    mock_request.side_effect = (request, OSError(0, 'OSError'))
     assert obj.notify(
         body='body', title='title', notify_type=NotifyType.INFO,
         attach=attach) is False
 
     # Reset our mock object back to how it was
-    mock_post.return_value = request
-    mock_post.side_effect = None
+    mock_request.return_value = request
+    mock_request.side_effect = None
 
     # Test invalid attachment
     path = os.path.join(TEST_VAR_DIR, '/invalid/path/to/an/invalid/file.jpg')
@@ -370,13 +392,16 @@ def test_plugin_slack_oauth_access_token
         attach=path) is False
 
     # Test case where expected return attachment payload is invalid
-    request.content = dumps({
-        'ok': True,
-        'message': '',
-
-        # Attachment support
-        'file': None
-    })
+    mock_request.reset_mock()
+    mock_request.side_effect = [
+        request,
+        mock.Mock(**{
+            'content': dumps({
+                "ok": False,
+            }),
+            'status_code': requests.codes.internal_server_error
+        }),
+    ]
     path = os.path.join(TEST_VAR_DIR, 'apprise-test.gif')
     attach = AppriseAttachment(path)
     # We'll fail because of the bad 'file' response
@@ -387,6 +412,9 @@ def test_plugin_slack_oauth_access_token
     # Slack requests pay close attention to the response to determine
     # if things go well... this is not a good JSON response:
     request.content = '{'
+    mock_request.reset_mock()
+    mock_request.return_value = request
+    mock_request.side_effect = None
 
     # As a result, we'll fail to send our notification
     assert obj.send(body="test", attach=attach) is False
@@ -401,8 +429,8 @@ def test_plugin_slack_oauth_access_token
     assert obj.send(body="test", attach=attach) is False
 
     # Handle exceptions reading our attachment from disk (should it happen)
-    mock_post.side_effect = OSError("Attachment Error")
-    mock_post.return_value = None
+    mock_request.side_effect = OSError("Attachment Error")
+    mock_request.return_value = None
 
     # We'll fail now because of an internal exception
     assert obj.send(body="test") is False
@@ -410,18 +438,18 @@ def test_plugin_slack_oauth_access_token
     # Test Email Lookup
 
 
-@mock.patch('requests.post')
-def test_plugin_slack_webhook_mode(mock_post):
+@mock.patch('requests.request')
+def test_plugin_slack_webhook_mode(mock_request):
     """
     NotifySlack() Webhook Mode Tests
 
     """
 
     # Prepare Mock
-    mock_post.return_value = requests.Request()
-    mock_post.return_value.status_code = requests.codes.ok
-    mock_post.return_value.content = b'ok'
-    mock_post.return_value.text = 'ok'
+    mock_request.return_value = requests.Request()
+    mock_request.return_value.status_code = requests.codes.ok
+    mock_request.return_value.content = b'ok'
+    mock_request.return_value.text = 'ok'
 
     # Initialize some generic (but valid) tokens
     token_a = 'A' * 9
@@ -455,9 +483,9 @@ def test_plugin_slack_webhook_mode(mock_
         body='body', title='title', notify_type=NotifyType.INFO) is True
 
 
-@mock.patch('requests.post')
+@mock.patch('requests.request')
 @mock.patch('requests.get')
-def test_plugin_slack_send_by_email(mock_get, mock_post):
+def test_plugin_slack_send_by_email(mock_get, mock_request):
     """
     NotifySlack() Send by Email Tests
 
@@ -477,7 +505,7 @@ def test_plugin_slack_send_by_email(mock
     request.status_code = requests.codes.ok
 
     # Prepare Mock
-    mock_post.return_value = request
+    mock_request.return_value = request
     mock_get.return_value = request
 
     # Variation Initializations
@@ -486,7 +514,7 @@ def test_plugin_slack_send_by_email(mock
     assert isinstance(obj.url(), str) is True
 
     # No calls made yet
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
     assert mock_get.call_count == 0
 
     # Send our notification
@@ -496,18 +524,18 @@ def test_plugin_slack_send_by_email(mock
     # 2 calls were made, one to perform an email lookup, the second
     # was the notification itself
     assert mock_get.call_count == 1
-    assert mock_post.call_count == 1
+    assert mock_request.call_count == 1
     assert mock_get.call_args_list[0][0][0] == \
         'https://slack.com/api/users.lookupByEmail'
-    assert mock_post.call_args_list[0][0][0] == \
+    assert mock_request.call_args_list[0][0][1] == \
         'https://slack.com/api/chat.postMessage'
 
     # Reset our mock object
-    mock_post.reset_mock()
+    mock_request.reset_mock()
     mock_get.reset_mock()
 
     # Prepare Mock
-    mock_post.return_value = request
+    mock_request.return_value = request
     mock_get.return_value = request
 
     # Send our notification again (cached copy of user id associated with
@@ -516,8 +544,8 @@ def test_plugin_slack_send_by_email(mock
         body='body', title='title', notify_type=NotifyType.INFO) is True
 
     assert mock_get.call_count == 0
-    assert mock_post.call_count == 1
-    assert mock_post.call_args_list[0][0][0] == \
+    assert mock_request.call_count == 1
+    assert mock_request.call_args_list[0][0][1] == \
         'https://slack.com/api/chat.postMessage'
 
     #
@@ -529,11 +557,11 @@ def test_plugin_slack_send_by_email(mock
     })
 
     # Reset our mock object
-    mock_post.reset_mock()
+    mock_request.reset_mock()
     mock_get.reset_mock()
 
     # Prepare Mock
-    mock_post.return_value = request
+    mock_request.return_value = request
     mock_get.return_value = request
 
     # Variation Initializations
@@ -542,7 +570,7 @@ def test_plugin_slack_send_by_email(mock
     assert isinstance(obj.url(), str) is True
 
     # No calls made yet
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
     assert mock_get.call_count == 0
 
     # Send our notification; it will fail because we failed to look up
@@ -553,7 +581,7 @@ def test_plugin_slack_send_by_email(mock
     # We would have failed to look up the email, therefore we wouldn't have
     # even bothered to attempt to send the notification
     assert mock_get.call_count == 1
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
     assert mock_get.call_args_list[0][0][0] == \
         'https://slack.com/api/users.lookupByEmail'
 
@@ -563,11 +591,11 @@ def test_plugin_slack_send_by_email(mock
     request.content = '}'
 
     # Reset our mock object
-    mock_post.reset_mock()
+    mock_request.reset_mock()
     mock_get.reset_mock()
 
     # Prepare Mock
-    mock_post.return_value = request
+    mock_request.return_value = request
     mock_get.return_value = request
 
     # Variation Initializations
@@ -576,7 +604,7 @@ def test_plugin_slack_send_by_email(mock
     assert isinstance(obj.url(), str) is True
 
     # No calls made yet
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
     assert mock_get.call_count == 0
 
     # Send our notification; it will fail because we failed to look up
@@ -587,7 +615,7 @@ def test_plugin_slack_send_by_email(mock
     # We would have failed to look up the email, therefore we wouldn't have
     # even bothered to attempt to send the notification
     assert mock_get.call_count == 1
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
     assert mock_get.call_args_list[0][0][0] == \
         'https://slack.com/api/users.lookupByEmail'
 
@@ -597,11 +625,11 @@ def test_plugin_slack_send_by_email(mock
     request.content = '}'
 
     # Reset our mock object
-    mock_post.reset_mock()
+    mock_request.reset_mock()
     mock_get.reset_mock()
 
     # Prepare Mock
-    mock_post.return_value = request
+    mock_request.return_value = request
     mock_get.return_value = request
 
     # Variation Initializations
@@ -610,7 +638,7 @@ def test_plugin_slack_send_by_email(mock
     assert isinstance(obj.url(), str) is True
 
     # No calls made yet
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
     assert mock_get.call_count == 0
 
     # Send our notification; it will fail because we failed to look up
@@ -621,7 +649,7 @@ def test_plugin_slack_send_by_email(mock
     # We would have failed to look up the email, therefore we wouldn't have
     # even bothered to attempt to send the notification
     assert mock_get.call_count == 1
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
     assert mock_get.call_args_list[0][0][0] == \
         'https://slack.com/api/users.lookupByEmail'
 
@@ -640,11 +668,11 @@ def test_plugin_slack_send_by_email(mock
     request.status_code = requests.codes.ok
 
     # Reset our mock object
-    mock_post.reset_mock()
+    mock_request.reset_mock()
     mock_get.reset_mock()
 
     # Prepare Mock
-    mock_post.return_value = request
+    mock_request.return_value = request
     mock_get.side_effect = requests.ConnectionError(
         0, 'requests.ConnectionError() not handled')
 
@@ -654,7 +682,7 @@ def test_plugin_slack_send_by_email(mock
     assert isinstance(obj.url(), str) is True
 
     # No calls made yet
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
     assert mock_get.call_count == 0
 
     # Send our notification; it will fail because we failed to look up
@@ -665,14 +693,14 @@ def test_plugin_slack_send_by_email(mock
     # We would have failed to look up the email, therefore we wouldn't have
     # even bothered to attempt to send the notification
     assert mock_get.call_count == 1
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
     assert mock_get.call_args_list[0][0][0] == \
         'https://slack.com/api/users.lookupByEmail'
 
 
-@mock.patch('requests.post')
+@mock.patch('requests.request')
 @mock.patch('requests.get')
-def test_plugin_slack_markdown(mock_get, mock_post):
+def test_plugin_slack_markdown(mock_get, mock_request):
     """
     NotifySlack() Markdown tests
 
@@ -683,7 +711,7 @@ def test_plugin_slack_markdown(mock_get,
     request.status_code = requests.codes.ok
 
     # Prepare Mock
-    mock_post.return_value = request
+    mock_request.return_value = request
     mock_get.return_value = request
 
     # Variation Initializations
@@ -703,6 +731,10 @@ def test_plugin_slack_markdown(mock_get,
     Channel Testing
     <!channelA>
     <!channelA|Description>
+
+    User ID Testing
+    <@U1ZQL9N3Y>
+    <@U1ZQL9N3Y|heheh>
     """)
 
     # Send our notification
@@ -712,23 +744,24 @@ def test_plugin_slack_markdown(mock_get,
     # We would have failed to look up the email, therefore we wouldn't have
     # even bothered to attempt to send the notification
     assert mock_get.call_count == 0
-    assert mock_post.call_count == 1
-    assert mock_post.call_args_list[0][0][0] == \
+    assert mock_request.call_count == 1
+    assert mock_request.call_args_list[0][0][1] == \
         'https://hooks.slack.com/services/T1JJ3T3L2/A1BRTD4JD/' \
         'TIiajkdnlazkcOXrIdevi7FQ'
 
-    data = loads(mock_post.call_args_list[0][1]['data'])
+    data = loads(mock_request.call_args_list[0][1]['data'])
     assert data['attachments'][0]['text'] == \
         "Here is a <https://slack.com|Slack Link> we want to support as part "\
         "of it's\nmarkdown.\n\nThis one has arguments we want to preserve:"\
         "\n   <https://slack.com?arg=val&arg2=val2|Slack Link>.\n"\
         "We also want to be able to support <https://slack.com> "\
         "links without the\ndescription."\
-        "\n\nChannel Testing\n<!channelA>\n<!channelA|Description>"
+        "\n\nChannel Testing\n<!channelA>\n<!channelA|Description>\n\n"\
+        "User ID Testing\n<@U1ZQL9N3Y>\n<@U1ZQL9N3Y|heheh>"
 
 
-@mock.patch('requests.post')
-def test_plugin_slack_single_thread_reply(mock_post):
+@mock.patch('requests.request')
+def test_plugin_slack_single_thread_reply(mock_request):
     """
     NotifySlack() Send Notification as a Reply
 
@@ -748,7 +781,7 @@ def test_plugin_slack_single_thread_repl
     request.status_code = requests.codes.ok
 
     # Prepare Mock
-    mock_post.return_value = request
+    mock_request.return_value = request
 
     # Variation Initializations
     obj = NotifySlack(access_token=token, targets=[f'#general:{thread_id}'])
@@ -756,22 +789,22 @@ def test_plugin_slack_single_thread_repl
     assert isinstance(obj.url(), str) is True
 
     # No calls made yet
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
 
     # Send our notification
     assert obj.notify(
         body='body', title='title', notify_type=NotifyType.INFO) is True
 
     # Post was made
-    assert mock_post.call_count == 1
-    assert mock_post.call_args_list[0][0][0] == \
+    assert mock_request.call_count == 1
+    assert mock_request.call_args_list[0][0][1] == \
         'https://slack.com/api/chat.postMessage'
-    assert loads(mock_post.call_args_list[0][1]['data']).get("thread_ts") \
+    assert loads(mock_request.call_args_list[0][1]['data']).get("thread_ts") \
         == str(thread_id)
 
 
-@mock.patch('requests.post')
-def test_plugin_slack_multiple_thread_reply(mock_post):
+@mock.patch('requests.request')
+def test_plugin_slack_multiple_thread_reply(mock_request):
     """
     NotifySlack() Send Notification to multiple channels as Reply
 
@@ -791,7 +824,7 @@ def test_plugin_slack_multiple_thread_re
     request.status_code = requests.codes.ok
 
     # Prepare Mock
-    mock_post.return_value = request
+    mock_request.return_value = request
 
     # Variation Initializations
     obj = NotifySlack(access_token=token,
@@ -802,17 +835,17 @@ def test_plugin_slack_multiple_thread_re
     assert isinstance(obj.url(), str) is True
 
     # No calls made yet
-    assert mock_post.call_count == 0
+    assert mock_request.call_count == 0
 
     # Send our notification
     assert obj.notify(
         body='body', title='title', notify_type=NotifyType.INFO) is True
 
     # Post was made
-    assert mock_post.call_count == 2
-    assert mock_post.call_args_list[0][0][0] == \
+    assert mock_request.call_count == 2
+    assert mock_request.call_args_list[0][0][1] == \
         'https://slack.com/api/chat.postMessage'
-    assert loads(mock_post.call_args_list[0][1]['data']).get("thread_ts") \
+    assert loads(mock_request.call_args_list[0][1]['data']).get("thread_ts") \
         == str(thread_id_1)
-    assert loads(mock_post.call_args_list[1][1]['data']).get("thread_ts") \
+    assert loads(mock_request.call_args_list[1][1]['data']).get("thread_ts") \
         == str(thread_id_2)
diff -pruN 1.8.0-3/test/test_plugin_sns.py 1.8.1-1/test/test_plugin_sns.py
--- 1.8.0-3/test/test_plugin_sns.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_sns.py	2024-07-26 00:19:02.000000000 +0000
@@ -376,7 +376,7 @@ def test_plugin_sns_aws_topic_handling(m
         # Multi-Topic
         'sns://T1JJ3T3L2/A1BRTD4JD/TIiajkdnl/us-east-1/TopicA/TopicB/'
         # Topic-Mix
-        'sns://T1JJ3T3L2/A1BRTD4JD/TIiajkdnlazkce/us-west-2/' \
+        'sns://T1JJ3T3L2/A1BRTD4JD/TIiajkdnlazkce/us-west-2/'
         '12223334444/TopicA'])
 
     # CreateTopic fails
diff -pruN 1.8.0-3/test/test_plugin_splunk.py 1.8.1-1/test/test_plugin_splunk.py
--- 1.8.0-3/test/test_plugin_splunk.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/test/test_plugin_splunk.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,177 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+import requests
+
+from apprise.plugins.splunk import NotifySplunk
+from helpers import AppriseURLTester
+
+# Disable logging for a cleaner testing output
+import logging
+logging.disable(logging.CRITICAL)
+
+# Our Testing URLs
+apprise_url_tests = (
+    ('splunk://', {
+        'instance': TypeError,
+    }),
+    ('splunk://:@/', {
+        'instance': TypeError,
+    }),
+    ('splunk://routekey@%badapi%', {
+        'instance': TypeError,
+    }),
+    ('splunk://abc123', {
+        # No route key provided
+        'instance': TypeError,
+    }),
+    ('splunk://%badroute%@apikey', {
+        'instance': TypeError,
+    }),
+    ('splunk://?apikey=abc123&routing_key=db', {
+        # We're good
+        'instance': NotifySplunk,
+    }),
+    ('splunk://route@abc123/entity_id', {
+        # We're good
+        'instance': NotifySplunk,
+    }),
+    ('splunk://route@abc123/?entity_id=my_entity', {
+        # We're good
+        'instance': NotifySplunk,
+    }),
+    # Support legacy URL
+    ('https://alert.victorops.com/integrations/generic/20131114/'
+     'alert/apikey/routing_key', {
+         # We're good
+         'instance': NotifySplunk,
+     }),
+    # Support legacy URL (with entity id provided)
+    ('https://alert.victorops.com/integrations/generic/20131114/'
+     'alert/apikey/routing_key/entity_id', {
+         # We're good
+         'instance': NotifySplunk,
+     }),
+    # support victorops:// too!
+    ('victorops://?apikey=abc123&route=db', {
+        # We're good
+        'instance': NotifySplunk,
+    }),
+    ('splunk://?apikey=abc123&route=db', {
+        # We're good
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=recovery', {
+        # Always Recovery Alias
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=resolve', {
+        # Always Recovery Alias
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=r', {
+        # Always Recovery (short form)
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=acknowledgement', {
+        # Always Acknowledgement
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=ack', {
+        # Always Acknowledgement (short form)
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=critical', {
+        # Always Critical
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=crit', {
+        # Always Critical (short form)
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=warning', {
+        # Always Warning
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=warn', {
+        # Always Warning (short form)
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=info', {
+        # Always INFO
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=i', {
+        # Always INFO (short form)
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?action=invalid', {
+        # Invalid Action
+        'instance': TypeError,
+    }),
+    ('splunk://db@apikey?:warning=critical', {
+        # Map warnings to CRITICAL
+        'instance': NotifySplunk,
+    }),
+    ('splunk://db@apikey?:invalid=critical', {
+        # A bad Apprise Notification Type was provided
+        'instance': TypeError,
+    }),
+    ('splunk://db@apikey?:warning=invalid', {
+        # A bad Splunk Notification Type was provided
+        'instance': TypeError,
+    }),
+    ('splunk://db@apikey', {
+        'instance': NotifySplunk,
+        # force a failure
+        'response': False,
+        'requests_response_code': requests.codes.internal_server_error,
+    }),
+    ('splunk://db@apikey', {
+        'instance': NotifySplunk,
+        # throw a bizzare code forcing us to fail to look it up
+        'response': False,
+        'requests_response_code': 999,
+    }),
+    ('splunk://db@token', {
+        'instance': NotifySplunk,
+        # Throws a series of connection and transfer exceptions when this flag
+        # is set and tests that we gracfully handle them
+        'test_requests_exceptions': True,
+    }),
+)
+
+
+def test_plugin_splunk_urls():
+    """
+    NotifySplunk() Apprise URLs
+
+    """
+
+    # Run our general tests
+    AppriseURLTester(tests=apprise_url_tests).run_all()
diff -pruN 1.8.0-3/test/test_plugin_threema.py 1.8.1-1/test/test_plugin_threema.py
--- 1.8.0-3/test/test_plugin_threema.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_threema.py	2024-07-26 00:19:02.000000000 +0000
@@ -116,7 +116,7 @@ def test_plugin_threema():
     AppriseURLTester(tests=apprise_url_tests).run_all()
 
 
-@ mock.patch('requests.post')
+@mock.patch('requests.post')
 def test_plugin_threema_edge_cases(mock_post):
     """
     NotifyThreema() Edge Cases
diff -pruN 1.8.0-3/test/test_plugin_twilio.py 1.8.1-1/test/test_plugin_twilio.py
--- 1.8.0-3/test/test_plugin_twilio.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_twilio.py	2024-07-26 00:19:02.000000000 +0000
@@ -69,8 +69,8 @@ apprise_url_tests = (
         # sid and token provided and from but invalid from no
         'instance': TypeError,
     }),
-    ('twilio://AC{}:{}@{}/123/{}/abcd/'.format(
-        'a' * 32, 'b' * 32, '3' * 11, '9' * 15), {
+    ('twilio://AC{}:{}@{}/123/{}/abcd/w:{}'.format(
+        'a' * 32, 'b' * 32, '3' * 11, '9' * 15, 8 * 11), {
         # valid everything but target numbers
         'instance': NotifyTwilio,
     }),
@@ -81,6 +81,20 @@ apprise_url_tests = (
         # Our expected url(privacy=True) startswith() response:
         'privacy_url': 'twilio://...aaaa:b...b@12345',
     }),
+    ('twilio://AC{}:{}@98765/{}/w:{}/'.format(
+        'a' * 32, 'b' * 32, '4' * 11, '5' * 11), {
+            # using short-code (5 characters) and 1 twillio address ignored
+            # because source phone number can not be a short code
+            'instance': NotifyTwilio,
+
+            # Our expected url(privacy=True) startswith() response:
+            'privacy_url': 'twilio://...aaaa:b...b@98765',
+    }),
+    ('twilio://AC{}:{}@w:12345/{}/{}'.format(
+        'a' * 32, 'b' * 32, '4' * 11, '5' * 11), {
+            # Invalid short-code
+            'instance': TypeError,
+    }),
     ('twilio://AC{}:{}@123456/{}'.format('a' * 32, 'b' * 32, '4' * 11), {
         # using short-code (6 characters)
         'instance': NotifyTwilio,
@@ -95,6 +109,11 @@ apprise_url_tests = (
         # use get args to acomplish the same thing
         'instance': NotifyTwilio,
     }),
+    ('twilio://_?sid=AC{}&token={}&from={}&to=w:{}'.format(
+        'a' * 32, 'b' * 32, '5' * 11, '6' * 11), {
+        # Support whatsapp (w: before number)
+        'instance': NotifyTwilio,
+    }),
     ('twilio://_?sid=AC{}&token={}&source={}'.format(
         'a' * 32, 'b' * 32, '5' * 11), {
         # use get args to acomplish the same thing (use source instead of from)
@@ -228,6 +247,11 @@ def test_plugin_twilio_edge_cases(mock_p
         NotifyTwilio(
             account_sid=account_sid, auth_token=None, source=source)
 
+    # Source is bad
+    with pytest.raises(TypeError):
+        NotifyTwilio(
+            account_sid=account_sid, auth_token=auth_token, source='')
+
     # a error response
     response.status_code = 400
     response.content = dumps({
diff -pruN 1.8.0-3/test/test_plugin_voipms.py 1.8.1-1/test/test_plugin_voipms.py
--- 1.8.0-3/test/test_plugin_voipms.py	2024-05-11 20:25:58.000000000 +0000
+++ 1.8.1-1/test/test_plugin_voipms.py	2024-07-26 00:19:02.000000000 +0000
@@ -170,7 +170,7 @@ def test_plugin_voipms():
     AppriseURLTester(tests=apprise_url_tests).run_all()
 
 
-@ mock.patch('requests.get')
+@mock.patch('requests.get')
 def test_plugin_voipms_edge_cases(mock_get):
     """
     NotifyVoipms() Edge Cases
diff -pruN 1.8.0-3/test/test_plugin_workflows.py 1.8.1-1/test/test_plugin_workflows.py
--- 1.8.0-3/test/test_plugin_workflows.py	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/test/test_plugin_workflows.py	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,434 @@
+# -*- coding: utf-8 -*-
+# BSD 2-Clause License
+#
+# Apprise - Push Notification Library.
+# Copyright (c) 2024, Chris Caron <lead2gold@gmail.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+from unittest import mock
+
+import json
+import requests
+import pytest
+from apprise import Apprise
+from apprise import AppriseConfig
+from apprise import NotifyType
+from apprise.plugins.workflows import NotifyWorkflows
+from helpers import AppriseURLTester
+from inspect import cleandoc
+
+# Disable logging for a cleaner testing output
+import logging
+logging.disable(logging.CRITICAL)
+
+# Our Testing URLs
+apprise_url_tests = (
+    ##################################
+    # NotifyWorkflows
+    ##################################
+    ('workflow://', {
+        # invalid host details (parsing fails very early)
+        'instance': None,
+    }),
+    ('workflow://:@/', {
+        # invalid host details (parsing fails very early)
+        'instance': None,
+    }),
+    ('workflow://host/workflow', {
+        # workflow provided only, no signature
+        'instance': TypeError,
+    }),
+    ('workflow://host:443/^(/signature', {
+        # invalid workflow provided
+        'instance': TypeError,
+    }),
+    ('workflow://host:443/workflow1a/signature/?image=no', {
+        # All tokens provided - we're good
+        # Tests case without image defined
+        'instance': NotifyWorkflows,
+    }),
+    ('workflows://host:443/workflow1b/signature/', {
+        # support workflows (s added to end)
+        'instance': NotifyWorkflows,
+    }),
+    ('workflows://host:443/signature/?id=workflow1c', {
+        # id= to store workflow id
+        'instance': NotifyWorkflows,
+    }),
+    ('workflows://host:443/signature/?workflow=workflow1d&wrap=yes', {
+        # workflow= to store workflow id
+        'instance': NotifyWorkflows,
+    }),
+    ('workflows://host:443/signature/?workflow=workflow1d&wrap=no', {
+        # workflow= to store workflow id
+        'instance': NotifyWorkflows,
+    }),
+    ('workflows://host:443/workflow1e/signature/?api-version=2024-01-01', {
+        # support api-version which is extracted from webhook
+        'instance': NotifyWorkflows,
+        # Our expected url(privacy=True) startswith() response
+        'privacy_url': 'workflow://host:443/w...e/s...e/',
+    }),
+    ('workflows://host:443/workflow1b/signature/?ver=2016-06-01', {
+        # Support ver= (api-version alias)
+        'instance': NotifyWorkflows,
+    }),
+    ('workflows://host:443/?id=workflow1b&signature=signature', {
+        # Support signature= (sig= alias)
+        'instance': NotifyWorkflows,
+        # Our expected url(privacy=True) startswith() response
+        'privacy_url': 'workflow://host:443/w...b/s...e/',
+    }),
+    # Support native URLs
+    ('https://server.azure.com:443/workflows/643e69f83c8944/'
+     'triggers/manual/paths/invoke?'
+     'api-version=2016-06-01&sp=%2Ftriggers%2Fmanual%2Frun&'
+     'sv=1.0&sig=KODuebWbDGYFr0z0eu', {
+         # All tokens provided - we're good
+         'instance': NotifyWorkflows,
+
+         # Our expected url(privacy=True) startswith() response
+         'privacy_url': 'workflow://server.azure.com:443/6...4/K...u/'}),
+
+    ('workflow://host:443/workflow2/signature/', {
+        'instance': NotifyWorkflows,
+        # force a failure
+        'response': False,
+        'requests_response_code': requests.codes.internal_server_error,
+    }),
+    ('workflow://host:443/workflow3/signature/', {
+        'instance': NotifyWorkflows,
+        # throw a bizzare code forcing us to fail to look it up
+        'response': False,
+        'requests_response_code': 999,
+    }),
+    ('workflow://host:443/workflow4/signature/', {
+        'instance': NotifyWorkflows,
+        # Throws a series of connection and transfer exceptions when this flag
+        # is set and tests that we gracfully handle them
+        'test_requests_exceptions': True,
+    }),
+)
+
+
+def test_plugin_workflows_urls():
+    """
+    NotifyWorkflows() Apprise URLs
+
+    """
+
+    # Run our general tests
+    AppriseURLTester(tests=apprise_url_tests).run_all()
+
+
+@pytest.fixture
+def workflows_url():
+    return 'workflow://host:443/workflow/signature'
+
+
+@pytest.fixture
+def request_mock(mocker):
+    """
+    Prepare requests mock.
+    """
+    mock_post = mocker.patch("requests.post")
+    mock_post.return_value = requests.Request()
+    mock_post.return_value.status_code = requests.codes.ok
+    return mock_post
+
+
+@pytest.fixture
+def simple_template(tmpdir):
+    template = tmpdir.join("simple.json")
+    template.write(cleandoc("""
+    {
+        "type": "message",
+        "attachments": [{
+            "contentType": "application/vnd.microsoft.card.adaptive",
+            "contentUrl": None,
+            "content": {
+                "$schema":"http://adaptivecards.io/schemas/adaptive-card.json",
+                "type": "AdaptiveCard",
+                "version": "1.4",
+                "msteams": { "width": "full" },
+                "body": [
+                    {
+                        "type": "TextBlock",
+                        "text": "**Test**",
+                        "style": "heading"
+                    },
+                ]
+            }
+        ]
+    }
+    """))
+    return template
+
+
+def test_plugin_workflows_templating_basic_success(
+        request_mock, workflows_url, tmpdir):
+    """
+    NotifyWorkflows() Templating - success.
+    Test cases where URL and JSON is valid.
+    """
+
+    template = tmpdir.join("simple.json")
+    template.write(cleandoc("""
+    {
+      "@type": "MessageCard",
+      "@context": "https://schema.org/extensions",
+      "summary": "{{app_id}}",
+      "themeColor": "{{app_color}}",
+      "sections": [
+        {
+          "activityImage": null,
+          "activityTitle": "{{app_title}}",
+          "text": "{{app_body}}"
+        }
+      ]
+    }
+    """))
+
+    # Instantiate our URL
+    obj = Apprise.instantiate('{url}/?template={template}&{kwargs}'.format(
+        url=workflows_url,
+        template=str(template),
+        kwargs=':key1=token&:key2=token',
+    ))
+
+    assert isinstance(obj, NotifyWorkflows)
+    assert obj.notify(
+        body="body", title='title',
+        notify_type=NotifyType.INFO) is True
+
+    assert request_mock.called is True
+    assert request_mock.call_args_list[0][0][0].startswith(
+        'https://host:443/workflows/workflow/triggers/manual/paths/invoke')
+
+    # Our Posted JSON Object
+    posted_json = json.loads(request_mock.call_args_list[0][1]['data'])
+    assert 'summary' in posted_json
+    assert posted_json['summary'] == 'Apprise'
+    assert posted_json['themeColor'] == '#3AA3E3'
+    assert posted_json['sections'][0]['activityTitle'] == 'title'
+    assert posted_json['sections'][0]['text'] == 'body'
+
+
+def test_plugin_workflows_templating_invalid_json(
+        request_mock, workflows_url, tmpdir):
+    """
+    NotifyWorkflows() Templating - invalid JSON.
+    """
+
+    template = tmpdir.join("invalid.json")
+    template.write("}")
+
+    # Instantiate our URL
+    obj = Apprise.instantiate('{url}/?template={template}&{kwargs}'.format(
+        url=workflows_url,
+        template=str(template),
+        kwargs=':key1=token&:key2=token',
+    ))
+
+    assert isinstance(obj, NotifyWorkflows)
+    # We will fail to preform our notifcation because the JSON is bad
+    assert obj.notify(
+        body="body", title='title',
+        notify_type=NotifyType.INFO) is False
+
+
+def test_plugin_workflows_templating_load_json_failure(
+        request_mock, workflows_url, tmpdir):
+    """
+    NotifyWorkflows() Templating - template loading failure.
+    Test a case where we can not access the file.
+    """
+
+    template = tmpdir.join("empty.json")
+    template.write("")
+
+    obj = Apprise.instantiate('{url}/?template={template}'.format(
+        url=workflows_url,
+        template=str(template),
+    ))
+
+    with mock.patch('json.loads', side_effect=OSError):
+        # we fail, but this time it's because we couldn't
+        # access the cached file contents for reading
+        assert obj.notify(
+            body="body", title='title',
+            notify_type=NotifyType.INFO) is False
+
+
+def test_plugin_workflows_templating_target_success(
+        request_mock, workflows_url, tmpdir):
+    """
+    NotifyWorkflows() Templating - success with target.
+    A more complicated example; uses a target.
+    """
+
+    template = tmpdir.join("more_complicated_example.json")
+    template.write(cleandoc("""
+    {
+      "@type": "MessageCard",
+      "@context": "https://schema.org/extensions",
+      "summary": "{{app_desc}}",
+      "themeColor": "{{app_color}}",
+      "sections": [
+        {
+          "activityImage": null,
+          "activityTitle": "{{app_title}}",
+          "text": "{{app_body}}"
+        }
+      ],
+     "potentialAction": [{
+        "@type": "ActionCard",
+        "name": "Add a comment",
+        "inputs": [{
+            "@type": "TextInput",
+            "id": "comment",
+            "isMultiline": false,
+            "title": "Add a comment here for this task."
+        }],
+        "actions": [{
+            "@type": "HttpPOST",
+            "name": "Add Comment",
+            "target": "{{ target }}"
+        }]
+     }]
+    }
+    """))
+
+    # Instantiate our URL
+    obj = Apprise.instantiate('{url}/?template={template}&{kwargs}'.format(
+        url=workflows_url,
+        template=str(template),
+        kwargs=':key1=token&:key2=token&:target=http://localhost',
+    ))
+
+    assert isinstance(obj, NotifyWorkflows)
+    assert obj.notify(
+        body="body", title='title',
+        notify_type=NotifyType.INFO) is True
+
+    assert request_mock.called is True
+    assert request_mock.call_args_list[0][0][0].startswith(
+        'https://host:443/workflows/workflow/triggers/manual/paths/invoke')
+
+    # Our Posted JSON Object
+    posted_json = json.loads(request_mock.call_args_list[0][1]['data'])
+    assert 'summary' in posted_json
+    assert posted_json['summary'] == 'Apprise Notifications'
+    assert posted_json['themeColor'] == '#3AA3E3'
+    assert posted_json['sections'][0]['activityTitle'] == 'title'
+    assert posted_json['sections'][0]['text'] == 'body'
+
+    # We even parsed our entry out of the URL
+    assert posted_json['potentialAction'][0]['actions'][0]['target'] \
+        == 'http://localhost'
+
+
+def test_workflows_yaml_config_missing_template_filename(
+        request_mock, workflows_url, simple_template, tmpdir):
+    """
+    NotifyWorkflows() YAML Configuration Entries - Missing template reference.
+    """
+
+    config = tmpdir.join("workflow01.yml")
+    config.write(cleandoc("""
+    urls:
+      - {url}:
+        - tag: 'workflow'
+          template: {template}.missing
+          :name: 'Template.Missing'
+          :body: 'test body'
+          :title: 'test title'
+    """.format(url=workflows_url, template=str(simple_template))))
+
+    # Config still loads okay
+    cfg = AppriseConfig()
+    cfg.add(str(config))
+    assert len(cfg) == 1
+    assert len(cfg[0]) == 1
+
+    obj = cfg[0][0]
+    assert isinstance(obj, NotifyWorkflows)
+
+    # However we can't send notification since the template couldn't be loaded
+    assert obj.notify(
+        body="body", title='title',
+        notify_type=NotifyType.INFO) is False
+    assert request_mock.called is False
+
+
+def test_plugin_workflows_edge_cases():
+    """
+    NotifyWorkflows() Edge Cases
+
+    """
+    # Initializes the plugin with an invalid token
+    with pytest.raises(TypeError):
+        NotifyWorkflows(workflow='@', signature='@')
+    with pytest.raises(TypeError):
+        NotifyWorkflows(workflow='', signature='abcd')
+
+    with pytest.raises(TypeError):
+        NotifyWorkflows(workflow=None, signature='abcd')
+    # Whitespace also acts as an invalid token value
+    with pytest.raises(TypeError):
+        NotifyWorkflows(workflow='  ', signature='abcd')
+
+    with pytest.raises(TypeError):
+        NotifyWorkflows(workflow='abcd', signature=None)
+    # Whitespace also acts as an invalid token value
+    with pytest.raises(TypeError):
+        NotifyWorkflows(workflow='abcd', signature='  ')
+
+    # test case where invalid tokens are specified
+    with pytest.raises(TypeError):
+        NotifyWorkflows(
+            workflow='workflow', signature='signature', tokens='not-a-dict')
+
+    # test case where no tokens are specified
+    obj = NotifyWorkflows(workflow='workflow', signature='signature')
+    assert isinstance(obj, NotifyWorkflows)
+
+
+def test_plugin_workflows_azure_webhooks(request_mock):
+    """
+    NotifyWorkflows() Azure Webhooks
+    """
+    url = 'https://prod-15.uksouth.logic.azure.com:443' \
+        '/workflows/3XXX5/triggers/manual/paths/invoke' \
+        '?api-version=2016-06-01&' \
+        'sp=%2Ftriggers%2Fmanual%2Frun&sv=1.0&sig=iXXXU'
+
+    #
+    # Initialize
+    #
+    obj = Apprise.instantiate(url)
+    assert isinstance(obj, NotifyWorkflows)
+    assert obj.workflow == "3XXX5"
+    assert obj.signature == "iXXXU"
+    assert obj.api_version == "2016-06-01"
diff -pruN 1.8.0-3/test/var/mime.types 1.8.1-1/test/var/mime.types
--- 1.8.0-3/test/var/mime.types	1970-01-01 00:00:00.000000000 +0000
+++ 1.8.1-1/test/var/mime.types	2024-07-26 00:19:02.000000000 +0000
@@ -0,0 +1,2264 @@
+# This is a comment. I love comments.		    -*- indent-tabs-mode: t -*-
+
+# This file controls what Internet media types are sent to the client for
+# given file extension(s).  Sending the correct media type to the client
+# is important so they know how to handle the content of the file.
+# Extra types can either be added here or by using an AddType directive
+# in your config files. For more information about Internet media types,
+# please read RFC 2045, 2046, 2047, 2048, and 2077.  The Internet media type
+# registry is at <http://www.iana.org/assignments/media-types/>.
+
+# Even types without defined extensions are listed here for completeness.
+# Compound extensions like cwl.json are allowed.
+
+# IANA types
+
+# MIME type					Extensions
+application/1d-interleaved-parityfec
+application/3gpdash-qoe-report+xml
+application/3gppHal+json
+application/3gppHalForms+json
+application/3gpp-ims+xml
+application/A2L					a2l
+application/ace+cbor
+application/ace+json
+application/activemessage
+application/activity+json
+application/aif+cbor
+application/aif+json
+application/alto-cdni+json
+application/alto-cdnifilter+json
+application/alto-costmap+json
+application/alto-costmapfilter+json
+application/alto-directory+json
+application/alto-endpointcost+json
+application/alto-endpointcostparams+json
+application/alto-endpointprop+json
+application/alto-endpointpropparams+json
+application/alto-error+json
+application/alto-networkmap+json
+application/alto-propmap+json
+application/alto-propmapparams+json
+application/alto-updatestreamcontrol+json
+application/alto-updatestreamparams+json
+application/alto-networkmapfilter+json
+application/AML					aml
+application/andrew-inset			ez
+application/applefile
+application/at+jwt
+application/ATF					atf
+application/ATFX				atfx
+application/ATXML				atxml
+application/atom+xml				atom
+application/atomcat+xml				atomcat
+application/atomdeleted+xml			atomdeleted
+application/atomicmail
+application/atomsvc+xml				atomsvc
+application/atsc-dwd+xml			dwd
+application/atsc-dynamic-event-message
+application/atsc-held+xml			held
+application/atsc-rdt+json
+application/atsc-rsat+xml			rsat
+application/auth-policy+xml			apxml
+application/automationml-aml+xml
+application/automationml-amlx+zip   amlx
+application/bacnet-xdd+zip			xdd
+application/batch-SMTP
+application/beep+xml
+application/calendar+json
+application/calendar+xml			xcs
+application/call-completion
+application/CALS-1840
+application/captive+json
+application/cap+xml
+application/cbor				cbor
+application/cbor-seq
+application/cccex				c3ex
+application/ccmp+xml				ccmp
+application/ccxml+xml				ccxml
+application/cda+xml
+application/CDFX+XML				cdfx
+application/cdmi-capability			cdmia
+application/cdmi-container			cdmic
+application/cdmi-domain				cdmid
+application/cdmi-object				cdmio
+application/cdmi-queue				cdmiq
+application/cdni
+application/CEA					cea
+application/cea-2018+xml
+application/cellml+xml				cellml cml
+application/cfw
+application/city+json
+application/clr                     1clr
+application/clue_info+xml			clue
+application/clue+xml
+application/cms					cmsc
+application/cnrp+xml
+application/coap-group+json
+application/coap-payload
+application/commonground
+application/concise-problem-details+cbor
+application/conference-info+xml
+application/cpl+xml				cpl
+application/cose
+application/cose-key
+application/cose-key-set
+application/cose-x509
+application/csrattrs				csrattrs
+application/csta+xml
+application/CSTAdata+xml
+application/csvm+json
+application/cwl                     cwl
+application/cwl+json                cwl.json
+application/cwt
+application/cybercash
+application/dash+xml				mpd
+application/dash-patch+xml
+application/dashdelta				mpdd
+application/davmount+xml			davmount
+application/dca-rft
+application/DCD					dcd
+application/dec-dx
+application/dialog-info+xml
+application/dicom				dcm
+application/dicom+json
+application/dicom+xml
+application/DII					dii
+application/DIT					dit
+application/dns
+application/dns+json
+application/dns-message
+application/dots+cbor
+application/dpop+jwt
+application/dskpp+xml				xmls
+application/dssc+der				dssc
+application/dssc+xml				xdssc
+application/dvcs				dvc
+application/ecmascript				es
+application/EDI-consent
+application/EDI-X12
+application/EDIFACT
+application/efi					efi
+application/elm+json
+application/elm+xml
+application/EmergencyCallData.cap+xml
+application/EmergencyCallData.Comment+xml
+application/EmergencyCallData.Control+xml
+application/EmergencyCallData.DeviceInfo+xml
+application/EmergencyCallData.eCall.MSD
+application/EmergencyCallData.LegacyESN+json
+application/EmergencyCallData.ProviderInfo+xml
+application/EmergencyCallData.ServiceInfo+xml
+application/EmergencyCallData.SubscriberInfo+xml
+application/EmergencyCallData.VEDS+xml
+application/emma+xml				emma
+application/emotionml+xml			emotionml
+application/encaprtp
+application/epp+xml
+application/epub+zip				epub
+application/eshop
+application/exi					exi
+application/expect-ct-report+json
+application/express             exp
+application/fastinfoset				finf
+application/fastsoap
+application/fdf
+application/fdt+xml				fdt
+application/fhir+json
+application/fhir+xml
+# fits, fit, fts: image/fits
+application/fits
+application/flexfec
+# application/font-sfnt deprecated in favor of font/sfnt
+application/font-tdpfr				pfr
+# application/font-woff deprecated in favor of font/woff
+application/framework-attributes+xml
+application/geo+json				geojson
+application/geo+json-seq
+application/geopackage+sqlite3			gpkg
+application/geoxacml+xml
+application/gltf-buffer				glbin glbuf
+application/gml+xml				gml
+application/gzip				gz tgz
+application/H224
+application/held+xml
+application/hl7v2+xml
+application/http
+application/hyperstudio				stk
+application/ibe-key-request+xml
+application/ibe-pkg-reply+xml
+application/ibe-pp-data
+application/iges
+application/im-iscomposing+xml
+application/index
+application/index.cmd
+application/index.obj
+application/index.response
+application/index.vnd
+application/inkml+xml				ink inkml
+application/IOTP
+application/ipfix				ipfix
+application/ipp
+application/ISUP
+application/its+xml				its
+application/java-archive        jar
+# application/javascript obsoleted by text/javascript
+application/jf2feed+json
+application/jose
+application/jose+json
+application/jrd+json				jrd
+application/jscalendar+json
+application/json				json
+application/json-patch+json			json-patch
+application/json-seq
+application/jwk+json
+application/jwk-set+json
+application/jwt
+application/kpml-request+xml
+application/kpml-response+xml
+application/ld+json				jsonld
+application/lgr+xml				lgr
+application/link-format				wlnk
+application/linkset
+application/linkset+json
+application/load-control+xml
+application/logout+jwt
+application/lost+xml				lostxml
+application/lostsync+xml			lostsyncxml
+application/lpf+zip				lpf
+application/LXF					lxf
+application/mac-binhex40			hqx
+application/macwriteii
+application/mads+xml				mads
+application/manifest+json       webmanifest
+application/marc				mrc
+application/marcxml+xml				mrcx
+application/mathematica				nb ma mb
+application/mathml-content+xml
+application/mathml-presentation+xml
+application/mathml+xml				mml
+application/mbms-associated-procedure-description+xml
+application/mbms-deregister+xml
+application/mbms-envelope+xml
+application/mbms-msk-response+xml
+application/mbms-msk+xml
+application/mbms-protection-description+xml
+application/mbms-reception-report+xml
+application/mbms-register-response+xml
+application/mbms-register+xml
+application/mbms-schedule+xml
+application/mbms-user-service-description+xml
+application/mbox				mbox
+application/media_control+xml
+# mpf: text/vnd.ms-mediapackage
+application/media-policy-dataset+xml
+application/mediaservercontrol+xml
+application/merge-patch+json
+application/metalink4+xml			meta4
+application/mets+xml				mets
+application/MF4					mf4
+application/mikey
+application/mipc                h5
+application/missing-blocks+cbor-seq
+application/mmt-aei+xml				maei
+application/mmt-usd+xml				musd
+application/mods+xml				mods
+application/moss-keys
+application/moss-signature
+application/mosskey-data
+application/mosskey-request
+application/mp21				m21 mp21
+# mp4, mpg4: video/mp4, see RFC 4337
+application/mp4
+application/mpeg4-generic
+application/mpeg4-iod
+application/mpeg4-iod-xmt
+# xdf: application/xcap-diff+xml
+application/mrb-consumer+xml
+application/mrb-publish+xml
+application/msc-ivr+xml
+application/msc-mixer+xml
+application/msword				doc
+application/mud+json
+application/multipart-core
+application/mxf					mxf
+application/n-quads				nq
+application/n-triples				nt
+application/nasdata
+application/news-checkgroups
+application/news-groupinfo
+application/news-transmission
+application/nlsml+xml
+application/node
+application/nss
+application/oauth-authz-req+jwt
+application/oblivious-dns-message
+application/ocsp-request			orq
+application/ocsp-response			ors
+application/octet-stream		bin lha lzh exe class so dll img iso
+application/ODA					oda
+application/odm+xml
+application/ODX					odx
+application/oebps-package+xml			opf
+application/ogg					ogx
+application/ohttp-keys
+application/opc-nodeset+xml     
+application/oscore
+application/oxps				oxps
+application/p21                 p21 stp step stpnc 210 ifc
+application/p21+zip             stpz
+application/p2p-overlay+xml			relo
+application/parityfec
+application/passport
+# xer: application/xcap-error+xml
+application/patch-ops-error+xml
+application/pdf					pdf
+application/PDX					pdx
+application/pem-certificate-chain		pem
+application/pgp-encrypted			pgp
+application/pgp-keys
+application/pgp-signature			sig
+application/pidf-diff+xml
+application/pidf+xml
+application/pkcs10				p10
+application/pkcs12				p12 pfx
+application/pkcs7-mime				p7m p7c
+application/pkcs7-signature			p7s
+application/pkcs8				p8
+application/pkcs8-encrypted			p8e
+# ac: application/vnd.nokia.n-gage.ac+xml
+application/pkix-attr-cert
+application/pkix-cert				cer
+application/pkix-crl				crl
+application/pkix-pkipath			pkipath
+application/pkixcmp				pki
+application/pls+xml				pls
+application/poc-settings+xml
+application/postscript				ps eps ai
+application/ppsp-tracker+json
+application/problem+json
+application/problem+xml
+application/provenance+xml			provx
+application/prs.alvestrand.titrax-sheet
+application/prs.cww				cw cww
+application/prs.cyn
+application/prs.hpub+zip			hpub
+application/prs.implied-document+xml
+application/prs.implied-executable
+application/prs.implied-structure
+application/prs.nprend				rnd rct
+application/prs.plucker
+application/prs.rdf-xml-crypt			rdf-crypt
+application/prs.xsf+xml				xsf
+application/pskc+xml				pskcxml
+application/pvd+json
+application/QSIG
+application/raptorfec
+application/rdap+json
+application/rdf+xml				rdf
+application/route-apd+xml			rapd
+application/route-s-tsid+xml			sls
+application/route-usd+xml			rusd
+application/reginfo+xml				rif
+application/relax-ng-compact-syntax		rnc
+application/remote-printing
+application/reputon+json
+application/resource-lists-diff+xml		rld
+application/resource-lists+xml			rl
+application/rfc+xml				rfcxml
+application/riscos
+application/rlmi+xml
+application/rls-services+xml			rs
+application/rpki-checklist
+application/rpki-ghostbusters			gbr
+application/rpki-manifest			mft
+application/rpki-publication
+application/rpki-roa				roa
+application/rpki-updown
+application/rtf					rtf
+application/rtploopback
+application/rtx
+application/samlassertion+xml
+application/samlmetadata+xml
+application/sarif-external-properties+json sarif-external-properties sarif-external-properties.json
+application/sarif+json          sarif sarif.json
+application/sbe
+application/sbml+xml
+application/scaip+xml
+# scm: application/vnd.lotus-screencam
+application/scim+json				scim
+application/scvp-cv-request			scq
+application/scvp-cv-response			scs
+application/scvp-vp-request			spq
+application/scvp-vp-response			spp
+application/sdp					sdp
+application/secevent+jwt
+application/senml-etch+cbor			senml-etchc
+application/senml-etch+json			senml-etchj
+application/senml+cbor				senmlc
+application/senml+json				senml
+application/senml+xml				senmlx
+application/senml-exi				senmle
+application/sensml+cbor				sensmlc
+application/sensml+json				sensml
+application/sensml+xml				sensmlx
+application/sensml-exi				sensmle
+application/sep+xml
+application/sep-exi
+application/session-info
+application/set-payment
+application/set-payment-initiation
+application/set-registration
+application/set-registration-initiation
+application/SGML
+application/sgml-open-catalog			soc
+application/shf+xml				shf
+application/sieve				siv sieve
+application/simple-filter+xml			cl
+application/simple-message-summary
+application/simpleSymbolContainer
+# h5: application/mipc
+application/sipc
+application/slate
+# application/smil obsoleted by application/smil+xml
+application/smil+xml				smil smi sml
+application/smpte336m
+application/soap+fastinfoset
+application/soap+xml
+application/sparql-query			rq
+application/spdx+json                   spdx.json
+application/sparql-results+xml			srx
+application/spirits-event+xml
+application/sql					sql
+application/srgs				gram
+application/srgs+xml				grxml
+application/sru+xml				sru
+application/ssml+xml				ssml
+application/stix+json				stix
+application/swid+cbor               coswid
+application/swid+xml				swidtag
+application/tamp-apex-update			tau
+application/tamp-apex-update-confirm		auc
+application/tamp-community-update		tcu
+application/tamp-community-update-confirm	cuc
+application/taxii+json
+application/td+json				jsontd
+application/tamp-error				ter
+application/tamp-sequence-adjust		tsa
+application/tamp-sequence-adjust-confirm	sac
+# tsq: application/timestamp-query
+application/tamp-status-query
+# tsr: application/timestamp-reply
+application/tamp-status-response
+application/tamp-update				tur
+application/tamp-update-confirm			tuc
+application/tei+xml				tei teiCorpus odd
+application/TETRA_ISI
+application/thraud+xml				tfi
+application/timestamp-query			tsq
+application/timestamp-reply			tsr
+application/timestamped-data			tsd
+application/tlsrpt+gzip
+application/tlsrpt+json
+application/tm+json                 jsontm tm.json tm.jsonld
+application/tnauthlist
+application/token-introspection+jwt
+application/trickle-ice-sdpfrag
+application/trig				trig
+application/ttml+xml				ttml
+application/tve-trigger
+application/tzif
+application/tzif-leap
+application/ulpfec
+application/urc-grpsheet+xml			gsheet
+application/urc-ressheet+xml			rsheet
+application/urc-targetdesc+xml			td
+application/urc-uisocketdesc+xml		uis
+application/vcard+json
+application/vcard+xml
+application/vemmi
+application/vnd.1000minds.decision-model+xml	1km
+application/vnd.1ob                                 ob
+application/vnd.3gpp.5gnas              
+application/vnd.3gpp.access-transfer-events+xml
+application/vnd.3gpp.bsf+xml
+application/vnd.3gpp.crs+xml
+application/vnd.3gpp.current-location-discovery+xml
+application/vnd.3gpp.GMOP+xml
+application/vnd.3gpp.gtpc
+application/vnd.3gpp.interworking-data
+application/vnd.3gpp.lpp
+application/vnd.3gpp.mc-signalling-ear
+application/vnd.3gpp.mcdata-affiliation-command+xml
+application/vnd.3gpp.mcdata-info+xml
+application/vnd.3gpp.mcdata-msgstore-ctrl-request+xml
+application/vnd.3gpp.mcdata-payload
+application/vnd.3gpp.mcdata-regroup+xml
+application/vnd.3gpp.mcdata-service-config+xml
+application/vnd.3gpp.mcdata-signalling
+application/vnd.3gpp.mcdata-ue-config+xml
+application/vnd.3gpp.mcdata-user-profile+xml
+application/vnd.3gpp.mcptt-affiliation-command+xml
+application/vnd.3gpp.mcptt-floor-request+xml
+application/vnd.3gpp.mcptt-info+xml
+application/vnd.3gpp.mcptt-location-info+xml
+application/vnd.3gpp.mcptt-mbms-usage-info+xml
+application/vnd.3gpp.mcptt-regroup+xml
+application/vnd.3gpp.mcptt-service-config+xml
+application/vnd.3gpp.mcptt-signed+xml
+application/vnd.3gpp.mcptt-ue-config+xml
+application/vnd.3gpp.mcptt-ue-init-config+xml
+application/vnd.3gpp.mcptt-user-profile+xml
+application/vnd.3gpp.mcvideo-affiliation-command+xml
+application/vnd.3gpp.mcvideo-info+xml
+application/vnd.3gpp.mcvideo-location-info+xml
+application/vnd.3gpp.mcvideo-mbms-usage-info+xml
+application/vnd.3gpp.mcvideo-regroup+xml
+application/vnd.3gpp.mcvideo-service-config+xml
+application/vnd.3gpp.mcvideo-transmission-request+xml
+application/vnd.3gpp.mcvideo-ue-config+xml
+application/vnd.3gpp.mcvideo-user-profile+xml
+application/vnd.3gpp.mid-call+xml
+application/vnd.3gpp.ngap
+application/vnd.3gpp.pfcp
+application/vnd.3gpp.pic-bw-large		plb
+application/vnd.3gpp.pic-bw-small		psb
+application/vnd.3gpp.pic-bw-var			pvb
+application/vnd.3gpp-prose-pc3a+xml
+application/vnd.3gpp-prose-pc3ach+xml
+application/vnd.3gpp-prose+xml
+application/vnd.3gpp.s1ap
+application/vnd.3gpp.seal-group-doc+xml
+application/vnd.3gpp.seal-info+xml
+application/vnd.3gpp.seal-location-info+xml
+application/vnd.3gpp.seal-mbms-usage-info+xml
+application/vnd.3gpp.seal-network-QoS-management-info+xml
+application/vnd.3gpp.seal-ue-config-info+xml
+application/vnd.3gpp.seal-unicast-info+xml
+application/vnd.3gpp.seal-user-profile-info+xml
+application/vnd.3gpp-prose-pc3ch+xml
+application/vnd.3gpp-prose-pc8+xml
+# sms: application/vnd.3gpp2.sms
+application/vnd.3gpp.sms
+application/vnd.3gpp.sms+xml
+application/vnd.3gpp.srvcc-ext+xml
+application/vnd.3gpp.SRVCC-info+xml
+application/vnd.3gpp.state-and-event-info+xml
+application/vnd.3gpp.ussd+xml
+application/vnd.3gpp.vae-info+xml
+application/vnd.3gpp-v2x-local-service-information
+application/vnd.3gpp2.bcmcsinfo+xml
+application/vnd.3gpp2.sms			sms
+application/vnd.3gpp2.tcap			tcap
+application/vnd.3gpp.v2x
+application/vnd.3lightssoftware.imagescal	imgcal
+application/vnd.3M.Post-it-Notes		pwn
+application/vnd.accpac.simply.aso		aso
+application/vnd.accpac.simply.imp		imp
+application/vnd.acm.addressxfer+json
+application/vnd.acucobol			acu
+application/vnd.acucorp				atc acutc
+application/vnd.adobe.flash.movie		swf
+application/vnd.adobe.formscentral.fcdt		fcdt
+application/vnd.adobe.fxp			fxp fxpl
+application/vnd.adobe.partial-upload
+application/vnd.adobe.xdp+xml			xdp
+application/vnd.aether.imp
+application/vnd.afpc.afplinedata
+application/vnd.afpc.afplinedata-pagedef
+application/vnd.afpc.cmoca-cmresource
+application/vnd.afpc.foca-charset
+application/vnd.afpc.foca-codedfont
+application/vnd.afpc.foca-codepage
+application/vnd.afpc.modca			list3820 listafp afp pseg3820
+application/vnd.afpc.modca-cmtable
+application/vnd.afpc.modca-formdef
+application/vnd.afpc.modca-mediummap
+application/vnd.afpc.modca-objectcontainer
+application/vnd.afpc.modca-overlay		ovl
+application/vnd.afpc.modca-pagesegment		psg
+application/vnd.age                 age
+application/vnd.ah-barcode
+application/vnd.ahead.space			ahead
+application/vnd.airzip.filesecure.azf		azf
+application/vnd.airzip.filesecure.azs		azs
+application/vnd.amadeus+json
+application/vnd.amazon.mobi8-ebook		azw3
+application/vnd.americandynamics.acc		acc
+application/vnd.amiga.ami			ami
+application/vnd.amundsen.maze+xml
+application/vnd.android.ota			ota
+application/vnd.anki				apkg
+application/vnd.anser-web-certificate-issue-initiation	cii
+# Not in IANA listing, but is on FTP site?
+application/vnd.anser-web-funds-transfer-initiation	fti
+# atx: audio/ATRAC-X
+application/vnd.antix.game-component
+application/vnd.apache.arrow.file   arrow
+application/vnd.apache.arrow.stream     arrows
+application/vnd.apache.thrift.binary
+application/vnd.apache.thrift.compact
+application/vnd.apache.thrift.json
+application/vnd.apexlang        apexland apex axdl
+application/vnd.api+json
+application/vnd.aplextor.warrp+json
+application/vnd.apothekende.reservation+json
+application/vnd.apple.installer+xml		dist distz pkg mpkg
+application/vnd.apple.keynote			keynote
+# m3u: audio/x-mpegurl for now
+application/vnd.apple.mpegurl			m3u8
+application/vnd.apple.numbers			numbers
+application/vnd.apple.pages			pages
+# application/vnd.arastra.swi obsoleted by application/vnd.aristanetworks.swi
+application/vnd.aristanetworks.swi		swi
+application/vnd.artisan+json			artisan
+application/vnd.artsquare
+application/vnd.astraea-software.iota		iota
+application/vnd.audiograph			aep
+application/vnd.autopackage			package
+application/vnd.avalon+json
+application/vnd.avistar+xml
+application/vnd.balsamiq.bmml+xml		bmml
+application/vnd.banana-accounting		ac2
+application/vnd.bbf.usp.error
+application/vnd.balsamiq.bmpr			bmpr
+application/vnd.bbf.usp.msg
+application/vnd.bbf.usp.msg+json
+application/vnd.bekitzur-stech+json
+application/vnd.belightsoft.lhzd+zip    lhzd
+application/vnd.belightsoft.lhzl+zip    lhzl
+application/vnd.bint.med-content
+application/vnd.biopax.rdf+xml
+application/vnd.blink-idb-value-wrapper
+application/vnd.blueice.multipass		mpm
+application/vnd.bluetooth.ep.oob		ep
+application/vnd.bluetooth.le.oob		le
+application/vnd.bmi				bmi
+application/vnd.bpf
+application/vnd.bpf3
+application/vnd.businessobjects			rep
+application/vnd.byu.uapi+json
+application/vnd.cab-jscript
+application/vnd.canon-cpdl
+application/vnd.canon-lips
+application/vnd.capasystems-pg+json
+application/vnd.cendio.thinlinc.clientconf	tlclient
+application/vnd.century-systems.tcp_stream
+application/vnd.chemdraw+xml			cdxml
+application/vnd.chess-pgn			pgn
+application/vnd.chipnuts.karaoke-mmd		mmd
+application/vnd.ciedi
+application/vnd.cinderella			cdy
+application/vnd.cirpack.isdn-ext
+application/vnd.citationstyles.style+xml	csl
+application/vnd.claymore			cla
+application/vnd.cloanto.rp9			rp9
+application/vnd.clonk.c4group			c4g c4d c4f c4p c4u
+application/vnd.cluetrust.cartomobile-config	c11amc
+application/vnd.cluetrust.cartomobile-config-pkg	c11amz
+application/vnd.cncf.helm.chart.content.v1.tar+gzip
+application/vnd.cncf.helm.chart.provenance.v1.prov
+application/vnd.cncf.helm.config.v1+json
+application/vnd.coffeescript			coffee
+application/vnd.collabio.xodocuments.document	xodt
+application/vnd.collabio.xodocuments.document-template	xott
+application/vnd.collabio.xodocuments.presentation	xodp
+application/vnd.collabio.xodocuments.presentation-template	xotp
+application/vnd.collabio.xodocuments.spreadsheet	xods
+application/vnd.collabio.xodocuments.spreadsheet-template	xots
+application/vnd.collection+json
+application/vnd.collection.doc+json
+application/vnd.collection.next+json
+application/vnd.comicbook-rar			cbr
+application/vnd.comicbook+zip			cbz
+# icc: application/vnd.iccprofile
+application/vnd.commerce-battelle	ica icf icd ic0 ic1 ic2 ic3 ic4 ic5 ic6 ic7 ic8
+application/vnd.commonspace			csp cst
+application/vnd.contact.cmsg			cdbcmsg
+application/vnd.coreos.ignition+json		ign ignition
+application/vnd.cosmocaller			cmc
+application/vnd.crick.clicker			clkx
+application/vnd.crick.clicker.keyboard		clkk
+application/vnd.crick.clicker.palette		clkp
+application/vnd.crick.clicker.template		clkt
+application/vnd.crick.clicker.wordbank		clkw
+application/vnd.criticaltools.wbs+xml		wbs
+application/vnd.cryptii.pipe+json
+application/vnd.crypto-shade-file		ssvc
+application/vnd.cryptomator.encrypted   c9r c9s
+application/vnd.cryptomator.vault       cryptomator
+application/vnd.ctc-posml			pml
+application/vnd.ctct.ws+xml
+application/vnd.cups-pdf
+application/vnd.cups-postscript
+application/vnd.cups-ppd			ppd
+application/vnd.cups-raster
+application/vnd.cups-raw
+application/vnd.curl				curl
+application/vnd.cyan.dean.root+xml
+application/vnd.cybank
+# json: application/json
+application/vnd.cyclonedx+json
+# xml: text/xml
+application/vnd.cyclonedx+xml
+application/vnd.d2l.coursepackage1p0+zip
+# json: application/json
+application/vnd.d3m-dataset
+# json: application/json
+application/vnd.d3m-problem
+application/vnd.dart				dart
+application/vnd.data-vision.rdz			rdz
+application/vnd.datalog                 dl
+application/vnd.datapackage+json
+application/vnd.dataresource+json
+application/vnd.dbf				dbf
+application/vnd.debian.binary-package		deb udeb
+application/vnd.dece.data			uvf uvvf uvd uvvd
+application/vnd.dece.ttml+xml			uvt uvvt
+application/vnd.dece.unspecified		uvx uvvx
+application/vnd.dece.zip			uvz uvvz
+application/vnd.denovo.fcselayout-link		fe_launch
+application/vnd.desmume.movie			dsm
+application/vnd.dir-bi.plate-dl-nosuffix
+application/vnd.dm.delegation+xml
+application/vnd.dna				dna
+application/vnd.document+json			docjson
+application/vnd.dolby.mobile.1
+application/vnd.dolby.mobile.2
+application/vnd.doremir.scorecloud-binary-document	scld
+application/vnd.dpgraph				dpg mwc dpgraph
+application/vnd.dreamfactory			dfac
+application/vnd.drive+json
+application/vnd.dtg.local
+application/vnd.dtg.local.flash			fla
+application/vnd.dtg.local.html
+application/vnd.dvb.ait				ait
+application/vnd.dvb.dvbisl+xml
+# class: application/octet-stream
+application/vnd.dvb.dvbj
+application/vnd.dvb.esgcontainer
+application/vnd.dvb.ipdcdftnotifaccess
+application/vnd.dvb.ipdcesgaccess
+application/vnd.dvb.ipdcesgaccess2
+application/vnd.dvb.ipdcesgpdd
+application/vnd.dvb.ipdcroaming
+application/vnd.dvb.iptv.alfec-base
+application/vnd.dvb.iptv.alfec-enhancement
+application/vnd.dvb.notif-aggregate-root+xml
+application/vnd.dvb.notif-container+xml
+application/vnd.dvb.notif-generic+xml
+application/vnd.dvb.notif-ia-msglist+xml
+application/vnd.dvb.notif-ia-registration-request+xml
+application/vnd.dvb.notif-ia-registration-response+xml
+application/vnd.dvb.notif-init+xml
+# pfr: application/font-tdpfr
+application/vnd.dvb.pfr
+application/vnd.dvb.service			svc
+# dxr: application/x-director
+application/vnd.dxr
+application/vnd.dynageo				geo
+application/vnd.dzr				dzr
+application/vnd.easykaraoke.cdgdownload
+application/vnd.ecdis-update
+application/vnd.ecip.rlp
+application/vnd.eclipse.ditto+json
+application/vnd.ecowin.chart			mag
+application/vnd.ecowin.filerequest
+application/vnd.ecowin.fileupdate
+application/vnd.ecowin.series
+application/vnd.ecowin.seriesrequest
+application/vnd.ecowin.seriesupdate
+# img: application/octet-stream
+application/vnd.efi.img
+# iso: application/octet-stream
+application/vnd.efi.iso
+application/vnd.eln+zip             eln
+application/vnd.emclient.accessrequest+xml
+application/vnd.enliven				nml
+application/vnd.enphase.envoy
+application/vnd.eprints.data+xml
+application/vnd.epson.esf			esf
+application/vnd.epson.msf			msf
+application/vnd.epson.quickanime		qam
+application/vnd.epson.salt			slt
+application/vnd.epson.ssf			ssf
+application/vnd.ericsson.quickcall		qcall qca
+application/vnd.espass-espass+zip		espass
+application/vnd.eszigno3+xml			es3 et3
+application/vnd.etsi.aoc+xml
+application/vnd.etsi.asic-e+zip			asice sce
+# scs: application/scvp-cv-response
+application/vnd.etsi.asic-s+zip			asics
+application/vnd.etsi.cug+xml
+application/vnd.etsi.iptvcommand+xml
+application/vnd.etsi.iptvdiscovery+xml
+application/vnd.etsi.iptvprofile+xml
+application/vnd.etsi.iptvsad-bc+xml
+application/vnd.etsi.iptvsad-cod+xml
+application/vnd.etsi.iptvsad-npvr+xml
+application/vnd.etsi.iptvservice+xml
+application/vnd.etsi.iptvsync+xml
+application/vnd.etsi.iptvueprofile+xml
+application/vnd.etsi.mcid+xml
+application/vnd.etsi.mheg5
+application/vnd.etsi.overload-control-policy-dataset+xml
+application/vnd.etsi.pstn+xml
+application/vnd.etsi.sci+xml
+application/vnd.etsi.simservs+xml
+application/vnd.etsi.timestamp-token		tst
+application/vnd.etsi.tsl.der
+application/vnd.eu.kasparian.car+json       carjson
+application/vnd.etsi.tsl+xml
+application/vnd.eudora.data
+application/vnd.exstream-empower+zip		mpw
+application/vnd.exstream-package		pub
+application/vnd.evolv.ecig.profile		ecigprofile
+application/vnd.evolv.ecig.settings		ecig
+application/vnd.evolv.ecig.theme		ecigtheme
+application/vnd.ezpix-album			ez2
+application/vnd.ezpix-package			ez3
+application/vnd.f-secure.mobile
+application/vnd.fastcopy-disk-image		dim
+application/vnd.familysearch.gedcom+zip     gdz
+application/vnd.fdf				fdf
+application/vnd.fdsn.mseed			msd mseed
+application/vnd.fdsn.seed			seed dataless
+application/vnd.ffsns
+application/vnd.ficlab.flb+zip			flb
+application/vnd.filmit.zfc			zfc
+# all extensions: application/vnd.hbci
+application/vnd.fints
+application/vnd.firemonkeys.cloudcell
+application/vnd.FloGraphIt			gph
+application/vnd.fluxtime.clip			ftc
+application/vnd.font-fontforge-sfd		sfd
+application/vnd.framemaker			fm
+application/vnd.frogans.fnc			fnc
+application/vnd.frogans.ltf			ltf
+application/vnd.fsc.weblaunch			fsc
+# xdw: application/vnd.fujixerox.docuworks
+application/vnd.fujifilm.fb.docuworks
+# xbd: application/vnd.fujixerox.docuworks.binder
+application/vnd.fujifilm.fb.docuworks.binder
+# xct: application/vnd.fujixerox.docuworks.container
+application/vnd.fujifilm.fb.docuworks.container
+application/vnd.fujifilm.fb.jfi+xml
+application/vnd.fujitsu.oasys			oas
+application/vnd.fujitsu.oasys2			oa2
+application/vnd.fujitsu.oasys3			oa3
+application/vnd.fujitsu.oasysgp			fg5
+application/vnd.fujitsu.oasysprs		bh2
+application/vnd.fujixerox.ART-EX
+application/vnd.fujixerox.ART4
+application/vnd.fujixerox.ddd			ddd
+application/vnd.fujixerox.docuworks     xdw
+application/vnd.fujixerox.docuworks.binder      xbd
+application/vnd.fujixerox.docuworks.container       xct
+application/vnd.fujixerox.HBPL
+application/vnd.fut-misnet
+application/vnd.futoin+cbor
+application/vnd.futoin+json
+application/vnd.fuzzysheet			fzs
+application/vnd.genomatix.tuxedo		txd
+application/vnd.genozip                 genozip
+application/vnd.gentics.grd+json
+application/vnd.gentoo.catmetadata+xml
+application/vnd.gentoo.ebuild           ebuild
+application/vnd.gentoo.eclass           eclass
+application/vnd.gentoo.gpkg             gpkg.tar
+application/vnd.gentoo.manifest
+application/vnd.gentoo.xpak             tbz2 xpak
+application/vnd.gentoo.pkgmetadata+xml
+# application/vnd.geo+json obsoleted by application/geo+json
+application/vnd.geocube+xml			g3 g³
+application/vnd.geogebra.file			ggb
+application/vnd.geogebra.slides         ggs
+application/vnd.geogebra.tool			ggt
+application/vnd.geometry-explorer		gex gre
+application/vnd.geonext				gxt
+application/vnd.geoplan				g2w
+application/vnd.geospace			g3w
+# gbr: application/rpki-ghostbusters
+application/vnd.gerber
+application/vnd.globalplatform.card-content-mgt
+application/vnd.globalplatform.card-content-mgt-response
+application/vnd.gmx				gmx
+application/vnd.gnu.taler.exchange+json
+application/vnd.gnu.taler.merchant+json
+application/vnd.google-earth.kml+xml		kml
+application/vnd.google-earth.kmz		kmz
+application/vnd.gov.sk.e-form+xml
+application/vnd.gov.sk.e-form+zip
+application/vnd.gov.sk.xmldatacontainer+xml
+application/vnd.gpxsee.map+xml
+application/vnd.grafeq				gqf gqs
+application/vnd.gridmp
+application/vnd.groove-account			gac
+application/vnd.groove-help			ghf
+application/vnd.groove-identity-message		gim
+application/vnd.groove-injector			grv
+application/vnd.groove-tool-message		gtm
+application/vnd.groove-tool-template		tpl
+application/vnd.groove-vcard			vcg
+application/vnd.hal+json
+application/vnd.hal+xml				hal
+application/vnd.HandHeld-Entertainment+xml	zmm
+application/vnd.hbci				hbci hbc kom upa pkd bpd
+application/vnd.hc+json
+# rep: application/vnd.businessobjects
+application/vnd.hcl-bireports
+application/vnd.hdt				hdt
+application/vnd.heroku+json
+application/vnd.hhe.lesson-player		les
+application/vnd.hp-HPGL				hpgl
+application/vnd.hp-hpid				hpi hpid
+application/vnd.hp-hps				hps
+application/vnd.hp-jlyt				jlt
+application/vnd.hp-PCL				pcl
+application/vnd.hp-PCLXL
+application/vnd.hsl                 hsl
+application/vnd.httphone
+application/vnd.hydrostatix.sof-data		sfd-hdstx
+application/vnd.hyper+json
+application/vnd.hyper-item+json
+application/vnd.hyperdrive+json
+application/vnd.hzn-3d-crossword		x3d
+# application/vnd.ibm.afplinedata obsoleted by application/vnd.afpc.afplinedata
+application/vnd.ibm.electronic-media		emm
+application/vnd.ibm.MiniPay			mpy
+# application/vnd.ibm.modcap obsoleted by application/vnd.afpc.modca
+application/vnd.ibm.rights-management		irm
+application/vnd.ibm.secure-container		sc
+application/vnd.iccprofile			icc icm
+application/vnd.ieee.1905			1905.1
+application/vnd.igloader			igl
+application/vnd.imagemeter.folder+zip		imf
+application/vnd.imagemeter.image+zip		imi
+application/vnd.immervision-ivp			ivp
+application/vnd.immervision-ivu			ivu
+application/vnd.ims.imsccv1p1			imscc
+application/vnd.ims.imsccv1p2
+application/vnd.ims.imsccv1p3
+application/vnd.ims.lis.v2.result+json
+application/vnd.ims.lti.v2.toolconsumerprofile+json
+application/vnd.ims.lti.v2.toolproxy.id+json
+application/vnd.ims.lti.v2.toolproxy+json
+application/vnd.ims.lti.v2.toolsettings+json
+application/vnd.ims.lti.v2.toolsettings.simple+json
+application/vnd.informedcontrol.rms+xml
+# application/vnd.informix-visionary obsoleted by application/vnd.visionary
+application/vnd.infotech.project
+application/vnd.infotech.project+xml
+application/vnd.innopath.wamp.notification
+application/vnd.insors.igm			igm
+application/vnd.intercon.formnet		xpw xpx
+application/vnd.intergeo			i2g
+application/vnd.intertrust.digibox
+application/vnd.intertrust.nncp
+application/vnd.intu.qbo			qbo
+application/vnd.intu.qfx			qfx
+application/vnd.ipld.car            car
+application/vnd.ipld.dag-cbor
+application/vnd.ipld.dag-json
+application/vnd.ipld.raw
+application/vnd.iptc.g2.catalogitem+xml
+application/vnd.iptc.g2.conceptitem+xml
+application/vnd.iptc.g2.knowledgeitem+xml
+application/vnd.iptc.g2.newsitem+xml
+application/vnd.iptc.g2.newsmessage+xml
+application/vnd.iptc.g2.packageitem+xml
+application/vnd.iptc.g2.planningitem+xml
+application/vnd.ipunplugged.rcprofile		rcprofile
+application/vnd.irepository.package+xml		irp
+application/vnd.is-xpr				xpr
+application/vnd.isac.fcs			fcs
+application/vnd.jam				jam
+application/vnd.iso11783-10+zip
+application/vnd.japannet-directory-service
+application/vnd.japannet-jpnstore-wakeup
+application/vnd.japannet-payment-wakeup
+application/vnd.japannet-registration
+application/vnd.japannet-registration-wakeup
+application/vnd.japannet-setstore-wakeup
+application/vnd.japannet-verification
+application/vnd.japannet-verification-wakeup
+application/vnd.jcp.javame.midlet-rms		rms
+application/vnd.jisp				jisp
+application/vnd.joost.joda-archive		joda
+application/vnd.jsk.isdn-ngn
+application/vnd.kahootz				ktz ktr
+application/vnd.kde.karbon			karbon
+application/vnd.kde.kchart			chrt
+application/vnd.kde.kformula			kfo
+application/vnd.kde.kivio			flw
+application/vnd.kde.kontour			kon
+application/vnd.kde.kpresenter			kpr kpt
+application/vnd.kde.kspread			ksp
+application/vnd.kde.kword			kwd kwt
+application/vnd.kenameaapp			htke
+application/vnd.kidspiration			kia
+application/vnd.Kinar				kne knp sdf
+application/vnd.koan				skp skd skm skt
+application/vnd.kodak-descriptor		sse
+application/vnd.las                 las
+application/vnd.las.las+json			lasjson
+application/vnd.las.las+xml			lasxml
+application/vnd.laszip
+application/vnd.leap+json
+application/vnd.liberty-request+xml
+application/vnd.llamagraphics.life-balance.desktop	lbd
+application/vnd.llamagraphics.life-balance.exchange+xml	lbe
+application/vnd.logipipe.circuit+zip		lcs lca
+application/vnd.loom				loom
+application/vnd.lotus-1-2-3			123 wk4 wk3 wk1
+application/vnd.lotus-approach			apr vew
+application/vnd.lotus-freelance			prz pre
+application/vnd.lotus-notes			nsf ntf ndl ns4 ns3 ns2 nsh nsg
+application/vnd.lotus-organizer			or3 or2 org
+application/vnd.lotus-screencam			scm
+application/vnd.lotus-wordpro			lwp sam
+application/vnd.macports.portpkg		portpkg
+application/vnd.mapbox-vector-tile		mvt
+application/vnd.marlin.drm.actiontoken+xml
+application/vnd.marlin.drm.conftoken+xml
+application/vnd.marlin.drm.license+xml
+application/vnd.marlin.drm.mdcf			mdc
+application/vnd.mason+json
+application/vnd.maxar.archive.3tz+zip   3tz
+application/vnd.maxmind.maxmind-db		mmdb
+application/vnd.mcd				mcd
+application/vnd.mdl             mdl
+application/vnd.mdl-mbsdf       mbsdf
+application/vnd.medcalcdata			mc1
+application/vnd.mediastation.cdkey		cdkey
+application/vnd.medicalholodeck.recordxr    rxr
+application/vnd.meridian-slingshot
+application/vnd.MFER				mwf
+application/vnd.mfmp				mfm
+application/vnd.micro+json
+application/vnd.micrografx.flo			flo
+application/vnd.micrografx.igx			igx
+application/vnd.microsoft.portable-executable
+application/vnd.microsoft.windows.thumbnail-cache
+application/vnd.miele+json
+application/vnd.mif				mif
+application/vnd.minisoft-hp3000-save
+application/vnd.mitsubishi.misty-guard.trustweb
+application/vnd.Mobius.DAF			daf
+application/vnd.Mobius.DIS			dis
+application/vnd.Mobius.MBK			mbk
+application/vnd.Mobius.MQY			mqy
+application/vnd.Mobius.MSL			msl
+application/vnd.Mobius.PLC			plc
+application/vnd.Mobius.TXF			txf
+application/vnd.modl                modl
+application/vnd.mophun.application		mpn
+application/vnd.mophun.certificate		mpc
+application/vnd.motorola.flexsuite
+application/vnd.motorola.flexsuite.adsi
+application/vnd.motorola.flexsuite.fis
+application/vnd.motorola.flexsuite.gotap
+application/vnd.motorola.flexsuite.kmr
+application/vnd.motorola.flexsuite.ttc
+application/vnd.motorola.flexsuite.wem
+application/vnd.motorola.iprm
+application/vnd.mozilla.xul+xml			xul
+application/vnd.ms-3mfdocument			3mf
+application/vnd.ms-artgalry			cil
+application/vnd.ms-asf				asf
+application/vnd.ms-cab-compressed		cab
+application/vnd.ms-excel			xls xlm xla xlc xlt xlw
+application/vnd.ms-excel.template.macroEnabled.12	xltm
+application/vnd.ms-excel.addin.macroEnabled.12	xlam
+application/vnd.ms-excel.sheet.binary.macroEnabled.12	xlsb
+application/vnd.ms-excel.sheet.macroEnabled.12	xlsm
+application/vnd.ms-fontobject			eot
+application/vnd.ms-htmlhelp			chm
+application/vnd.ms-ims				ims
+application/vnd.ms-lrm				lrm
+application/vnd.ms-office.activeX+xml
+application/vnd.ms-officetheme			thmx
+application/vnd.ms-playready.initiator+xml
+application/vnd.ms-powerpoint			ppt pps pot
+application/vnd.ms-powerpoint.addin.macroEnabled.12	ppam
+application/vnd.ms-powerpoint.presentation.macroEnabled.12	pptm
+application/vnd.ms-powerpoint.slide.macroEnabled.12	sldm
+application/vnd.ms-powerpoint.slideshow.macroEnabled.12	ppsm
+application/vnd.ms-powerpoint.template.macroEnabled.12	potm
+application/vnd.ms-PrintDeviceCapabilities+xml
+application/vnd.ms-PrintSchemaTicket+xml
+application/vnd.ms-project			mpp mpt
+application/vnd.ms-tnef				tnef tnf
+application/vnd.ms-windows.devicepairing
+application/vnd.ms-windows.nwprinting.oob
+application/vnd.ms-windows.printerpairing
+application/vnd.ms-windows.wsd.oob
+application/vnd.ms-wmdrm.lic-chlg-req
+application/vnd.ms-wmdrm.lic-resp
+application/vnd.ms-wmdrm.meter-chlg-req
+application/vnd.ms-wmdrm.meter-resp
+application/vnd.ms-word.document.macroEnabled.12	docm
+application/vnd.ms-word.template.macroEnabled.12	dotm
+application/vnd.ms-works			wcm wdb wks wps
+application/vnd.ms-wpl				wpl
+application/vnd.ms-xpsdocument			xps
+application/vnd.msa-disk-image			msa
+application/vnd.mseq				mseq
+application/vnd.msign
+application/vnd.multiad.creator			crtr
+application/vnd.multiad.creator.cif		cif
+application/vnd.music-niff
+application/vnd.musician			mus
+application/vnd.muvee.style			msty
+application/vnd.mynfc				taglet
+application/vnd.nacamar.ybrid+json
+application/vnd.ncd.control
+application/vnd.ncd.reference
+application/vnd.nearst.inv+json
+application/vnd.nebumind.line       nebul line
+application/vnd.nervana				entity request bkm kcm
+application/vnd.netfpx
+application/vnd.nimn				nimn
+# ntf: application/vnd.lotus-notes
+application/vnd.nitf				nitf
+application/vnd.neurolanguage.nlu		nlu
+application/vnd.nintendo.nitro.rom		nds
+application/vnd.nintendo.snes.rom		sfc smc
+application/vnd.noblenet-directory		nnd
+application/vnd.noblenet-sealer			nns
+application/vnd.noblenet-web			nnw
+application/vnd.nokia.catalogs
+application/vnd.nokia.conml+wbxml
+application/vnd.nokia.conml+xml
+application/vnd.nokia.iptv.config+xml
+application/vnd.nokia.iSDS-radio-presets
+application/vnd.nokia.landmark+wbxml
+application/vnd.nokia.landmark+xml
+application/vnd.nokia.landmarkcollection+xml
+application/vnd.nokia.n-gage.ac+xml		ac
+application/vnd.nokia.n-gage.data		ngdat
+application/vnd.nokia.n-gage.symbian.install	n-gage
+application/vnd.nokia.ncd
+application/vnd.nokia.pcd+wbxml
+application/vnd.nokia.pcd+xml
+application/vnd.nokia.radio-preset		rpst
+application/vnd.nokia.radio-presets		rpss
+application/vnd.novadigm.EDM			edm
+application/vnd.novadigm.EDX			edx
+application/vnd.novadigm.EXT			ext
+application/vnd.ntt-local.content-share
+application/vnd.ntt-local.file-transfer
+application/vnd.ntt-local.ogw_remote-access
+application/vnd.ntt-local.sip-ta_remote
+application/vnd.ntt-local.sip-ta_tcp_stream
+application/vnd.oasis.opendocument.base             odb
+application/vnd.oasis.opendocument.chart			odc
+application/vnd.oasis.opendocument.chart-template		otc
+# application/vnd.oasis.opendocument.database obsoleted by application/vnd.oasis.opendocument.base
+application/vnd.oasis.opendocument.formula			odf
+# otf: font/otf
+application/vnd.oasis.opendocument.formula-template
+application/vnd.oasis.opendocument.graphics			odg
+application/vnd.oasis.opendocument.graphics-template		otg
+application/vnd.oasis.opendocument.image			odi
+application/vnd.oasis.opendocument.image-template		oti
+application/vnd.oasis.opendocument.presentation			odp
+application/vnd.oasis.opendocument.presentation-template	otp
+application/vnd.oasis.opendocument.spreadsheet			ods
+application/vnd.oasis.opendocument.spreadsheet-template		ots
+application/vnd.oasis.opendocument.text				odt
+application/vnd.oasis.opendocument.text-master			odm
+application/vnd.oasis.opendocument.text-master-template otm
+application/vnd.oasis.opendocument.text-template		ott
+application/vnd.oasis.opendocument.text-web			oth
+application/vnd.obn
+application/vnd.ocf+cbor
+application/vnd.oci.image.manifest.v1+json
+application/vnd.oftn.l10n+json
+application/vnd.oipf.contentaccessdownload+xml
+application/vnd.oipf.contentaccessstreaming+xml
+application/vnd.oipf.cspg-hexbinary
+application/vnd.oipf.dae.svg+xml
+application/vnd.oipf.dae.xhtml+xml
+application/vnd.oipf.mippvcontrolmessage+xml
+application/vnd.oipf.pae.gem
+application/vnd.oipf.spdiscovery+xml
+application/vnd.oipf.spdlist+xml
+application/vnd.oipf.ueprofile+xml
+application/vnd.oipf.userprofile+xml
+application/vnd.olpc-sugar			xo
+application/vnd.oma.bcast.associated-procedure-parameter+xml
+application/vnd.oma.bcast.drm-trigger+xml
+application/vnd.oma.bcast.imd+xml
+application/vnd.oma.bcast.ltkm
+application/vnd.oma.bcast.notification+xml
+application/vnd.oma.bcast.provisioningtrigger
+application/vnd.oma.bcast.sgboot
+application/vnd.oma.bcast.sgdd+xml
+application/vnd.oma.bcast.sgdu
+application/vnd.oma.bcast.simple-symbol-container
+application/vnd.oma.bcast.smartcard-trigger+xml
+application/vnd.oma.bcast.sprov+xml
+application/vnd.oma.bcast.stkm
+application/vnd.oma.cab-address-book+xml
+application/vnd.oma.cab-feature-handler+xml
+application/vnd.oma.cab-pcc+xml
+application/vnd.oma.cab-subs-invite+xml
+application/vnd.oma.cab-user-prefs+xml
+application/vnd.oma.dcd
+application/vnd.oma.dcdc
+application/vnd.oma.dd2+xml			dd2
+application/vnd.oma.drm.risd+xml
+application/vnd.oma.group-usage-list+xml
+application/vnd.oma.lwm2m+cbor
+application/vnd.oma.lwm2m+json
+application/vnd.oma.lwm2m+tlv
+application/vnd.oma.pal+xml
+application/vnd.oma.poc.detailed-progress-report+xml
+application/vnd.oma.poc.final-report+xml
+application/vnd.oma.poc.groups+xml
+application/vnd.oma.poc.invocation-descriptor+xml
+application/vnd.oma.poc.optimized-progress-report+xml
+application/vnd.oma.push
+application/vnd.oma.scidm.messages+xml
+application/vnd.oma.xcap-directory+xml
+application/vnd.oma-scws-config
+application/vnd.oma-scws-http-request
+application/vnd.oma-scws-http-response
+application/vnd.omads-email+xml
+application/vnd.omads-file+xml
+application/vnd.omads-folder+xml
+application/vnd.omaloc-supl-init
+application/vnd.onepager			tam
+application/vnd.onepagertamp			tamp
+application/vnd.onepagertamx			tamx
+application/vnd.onepagertat			tat
+application/vnd.onepagertatp			tatp
+application/vnd.onepagertatx			tatx
+application/vnd.onvif.metadata
+application/vnd.openblox.game+xml		obgx
+application/vnd.openblox.game-binary		obg
+application/vnd.openeye.oeb			oeb
+application/vnd.openofficeorg.extension		oxt
+application/vnd.openstreetmap.data+xml		osm
+application/vnd.opentimestamps.ots
+application/vnd.openxmlformats-officedocument.custom-properties+xml
+application/vnd.openxmlformats-officedocument.customXmlProperties+xml
+application/vnd.openxmlformats-officedocument.drawing+xml
+application/vnd.openxmlformats-officedocument.drawingml.chart+xml
+application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml
+application/vnd.openxmlformats-officedocument.drawingml.diagramColors+xml
+application/vnd.openxmlformats-officedocument.drawingml.diagramData+xml
+application/vnd.openxmlformats-officedocument.drawingml.diagramLayout+xml
+application/vnd.openxmlformats-officedocument.drawingml.diagramStyle+xml
+application/vnd.openxmlformats-officedocument.extended-properties+xml
+application/vnd.openxmlformats-officedocument.presentationml.commentAuthors+xml
+application/vnd.openxmlformats-officedocument.presentationml.comments+xml
+application/vnd.openxmlformats-officedocument.presentationml.handoutMaster+xml
+application/vnd.openxmlformats-officedocument.presentationml.notesMaster+xml
+application/vnd.openxmlformats-officedocument.presentationml.notesSlide+xml
+application/vnd.openxmlformats-officedocument.presentationml.presProps+xml
+application/vnd.openxmlformats-officedocument.presentationml.presentation pptx
+application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml
+application/vnd.openxmlformats-officedocument.presentationml.slide	sldx
+application/vnd.openxmlformats-officedocument.presentationml.slide+xml
+application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml
+application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml
+application/vnd.openxmlformats-officedocument.presentationml.slideUpdateInfo+xml
+application/vnd.openxmlformats-officedocument.presentationml.slideshow	ppsx
+application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml
+application/vnd.openxmlformats-officedocument.presentationml.tableStyles+xml
+application/vnd.openxmlformats-officedocument.presentationml.tags+xml
+application/vnd.openxmlformats-officedocument.presentationml.template	potx
+application/vnd.openxmlformats-officedocument.presentationml.template.main+xml
+application/vnd.openxmlformats-officedocument.presentationml.viewProps+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.calcChain+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.externalLink+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheDefinition+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.pivotCacheRecords+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.pivotTable+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.queryTable+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.revisionHeaders+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.revisionLog+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.sheet	xlsx
+application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.sheetMetadata+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.tableSingleCells+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.template	xltx
+application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.userNames+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.volatileDependencies+xml
+application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml
+application/vnd.openxmlformats-officedocument.theme+xml
+application/vnd.openxmlformats-officedocument.themeOverride+xml
+application/vnd.openxmlformats-officedocument.vmlDrawing
+application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.document	docx
+application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.template	dotx
+application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml
+application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml
+application/vnd.openxmlformats-package.core-properties+xml
+application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml
+application/vnd.openxmlformats-package.relationships+xml
+application/vnd.oracle.resource+json
+application/vnd.orange.indata
+application/vnd.osa.netdeploy			ndc
+application/vnd.osgeo.mapguide.package		mgp
+application/vnd.osgi.bundle
+application/vnd.osgi.dp				dp
+application/vnd.osgi.subsystem			esa
+application/vnd.otps.ct-kip+xml
+application/vnd.oxli.countgraph			oxlicg
+application/vnd.pagerduty+json
+application/vnd.palm				prc pdb pqa oprc
+application/vnd.panoply				plp
+application/vnd.paos.xml
+application/vnd.paos+xml
+application/vnd.patentdive			dive
+application/vnd.patientecommsdoc
+application/vnd.pawaafile			paw
+application/vnd.pcos
+application/vnd.pg.format		    	str
+application/vnd.pg.osasli			ei6
+application/vnd.piaccess.application-licence	pil
+application/vnd.picsel				efif
+application/vnd.pmi.widget			wg
+application/vnd.poc.group-advertisement+xml
+application/vnd.pocketlearn			plf
+application/vnd.powerbuilder6			pbd
+application/vnd.powerbuilder6-s
+application/vnd.powerbuilder7
+application/vnd.powerbuilder7-s
+application/vnd.powerbuilder75
+application/vnd.powerbuilder75-s
+application/vnd.preminet			preminet
+application/vnd.previewsystems.box		box vbox
+application/vnd.proteus.magazine		mgz
+application/vnd.psfs				psfs
+application/vnd.pt.mundusmundi
+application/vnd.publishare-delta-tree		qps
+# pti: image/prs.pti
+application/vnd.pvi.ptid1			ptid
+application/vnd.pwg-multiplexed
+application/vnd.pwg-xhtml-print+xml
+application/vnd.qualcomm.brew-app-res		bar
+application/vnd.quarantainenet
+application/vnd.Quark.QuarkXPress		qxd qxt qwd qwt qxl qxb
+application/vnd.quobject-quoxdocument		quox quiz
+application/vnd.radisys.moml+xml
+application/vnd.radisys.msml-audit-conf+xml
+application/vnd.radisys.msml-audit-conn+xml
+application/vnd.radisys.msml-audit-dialog+xml
+application/vnd.radisys.msml-audit-stream+xml
+application/vnd.radisys.msml-audit+xml
+application/vnd.radisys.msml-conf+xml
+application/vnd.radisys.msml-dialog-base+xml
+application/vnd.radisys.msml-dialog-fax-detect+xml
+application/vnd.radisys.msml-dialog-fax-sendrecv+xml
+application/vnd.radisys.msml-dialog-group+xml
+application/vnd.radisys.msml-dialog-speech+xml
+application/vnd.radisys.msml-dialog-transform+xml
+application/vnd.radisys.msml-dialog+xml
+application/vnd.radisys.msml+xml
+application/vnd.rainstor.data			tree
+application/vnd.rapid
+application/vnd.rar				rar
+application/vnd.realvnc.bed			bed
+application/vnd.recordare.musicxml		mxl
+application/vnd.recordare.musicxml+xml
+application/vnd.RenLearn.rlprint
+application/vnd.resilient.logic         rlm reload
+application/vnd.restful+json
+application/vnd.rig.cryptonote			cryptonote
+application/vnd.route66.link66+xml		link66
+# gbr: application/rpki-ghostbusters
+application/vnd.rs-274x
+application/vnd.ruckus.download
+application/vnd.s3sms
+application/vnd.sailingtracker.track		st
+application/vnd.sar				SAR
+application/vnd.sbm.cid
+application/vnd.sbm.mid2
+application/vnd.scribus				scd sla slaz
+application/vnd.sealed.3df			s3df
+application/vnd.sealed.csf			scsf
+application/vnd.sealed.doc			sdoc sdo s1w
+application/vnd.sealed.eml			seml sem
+application/vnd.sealed.mht			smht smh
+application/vnd.sealed.net
+# spp: application/scvp-vp-response
+application/vnd.sealed.ppt			sppt s1p
+application/vnd.sealed.tiff			stif
+application/vnd.sealed.xls			sxls sxl s1e
+# stm: audio/x-stm
+application/vnd.sealedmedia.softseal.html	stml s1h
+application/vnd.sealedmedia.softseal.pdf	spdf spd s1a
+application/vnd.seemail				see
+# json: application/json
+application/vnd.seis+json
+application/vnd.sema				sema
+application/vnd.semd				semd
+application/vnd.semf				semf
+application/vnd.shade-save-file			ssv
+application/vnd.shana.informed.formdata		ifm
+application/vnd.shana.informed.formtemplate	itp
+application/vnd.shana.informed.interchange	iif
+application/vnd.shana.informed.package		ipk
+application/vnd.shootproof+json
+application/vnd.shopkick+json
+application/vnd.shp				shp
+application/vnd.shx				shx
+application/vnd.sigrok.session			sr
+application/vnd.SimTech-MindMapper		twd twds
+application/vnd.siren+json
+application/vnd.smaf				mmf
+application/vnd.smart.notebook			notebook
+application/vnd.smart.teacher			teacher
+application/vnd.smintio.portals.archive sipa
+application/vnd.snesdev-page-table		ptrom pt
+application/vnd.software602.filler.form+xml	fo
+application/vnd.software602.filler.form-xml-zip	zfo
+application/vnd.solent.sdkm+xml			sdkm sdkd
+application/vnd.spotfire.dxp			dxp
+application/vnd.spotfire.sfs			sfs
+# db: too generic
+application/vnd.sqlite3				sqlite sqlite3
+application/vnd.sss-cod
+application/vnd.sss-dtf
+application/vnd.sss-ntf
+application/vnd.stepmania.package		smzip
+application/vnd.stepmania.stepchart		sm
+application/vnd.street-stream
+application/vnd.sun.wadl+xml			wadl
+application/vnd.sus-calendar			sus susp
+application/vnd.svd
+application/vnd.swiftview-ics
+application/vnd.sybyl.mol2          ml2 mol2 sy2
+application/vnd.sycle+xml           scl
+application/vnd.syft+json           syft.json
+application/vnd.syncml+xml			xsm
+application/vnd.syncml.dm+wbxml			bdm
+application/vnd.syncml.dm+xml			xdm
+application/vnd.syncml.dm.notification
+application/vnd.syncml.dmddf+wbxml
+application/vnd.syncml.dmddf+xml		ddf
+application/vnd.syncml.dmtnds+wbxml
+application/vnd.syncml.dmtnds+xml
+application/vnd.syncml.ds.notification
+application/vnd.tableschema+json
+application/vnd.tao.intent-module-archive	tao
+application/vnd.tcpdump.pcap			pcap cap dmp
+application/vnd.theqvd				qvd
+application/vnd.think-cell.ppttc+json		ppttc
+application/vnd.tmd.mediaflex.api+xml
+application/vnd.tml				vfr viaframe
+application/vnd.tmobile-livetv			tmo
+application/vnd.tri.onesource
+application/vnd.trid.tpt			tpt
+application/vnd.triscape.mxs			mxs
+application/vnd.trueapp				tra
+application/vnd.truedoc
+# cab: application/vnd.ms-cab-compressed
+application/vnd.ubisoft.webplayer
+application/vnd.ufdl				ufdl ufd frm
+application/vnd.uiq.theme			utz
+application/vnd.umajin				umj
+application/vnd.unity				unityweb
+application/vnd.uoml+xml			uoml uo
+application/vnd.uplanet.alert
+application/vnd.uplanet.alert-wbxml
+application/vnd.uplanet.bearer-choice
+application/vnd.uplanet.bearer-choice-wbxml
+application/vnd.uplanet.cacheop
+application/vnd.uplanet.cacheop-wbxml
+application/vnd.uplanet.channel
+application/vnd.uplanet.channel-wbxml
+application/vnd.uplanet.list
+application/vnd.uplanet.list-wbxml
+application/vnd.uplanet.listcmd
+application/vnd.uplanet.listcmd-wbxml
+application/vnd.uplanet.signal
+application/vnd.uri-map				urim urimap
+application/vnd.valve.source.material		vmt
+application/vnd.vcx				vcx
+# sxi: application/vnd.sun.xml.impress
+application/vnd.vd-study			mxi study-inter model-inter
+# mcd: application/vnd.mcd
+application/vnd.vectorworks			vwx
+application/vnd.vel+json
+application/vnd.verimatrix.vcas
+application/vnd.veritone.aion+json  aion vtnstd
+application/vnd.veryant.thin			istc isws
+application/vnd.ves.encrypted			VES
+application/vnd.vidsoft.vidconference		vsc
+application/vnd.visio				vsd vst vsw vss
+application/vnd.visionary			vis
+# vsc: application/vnd.vidsoft.vidconference
+application/vnd.vividence.scriptfile
+application/vnd.vsf				vsf
+application/vnd.wap.sic				sic
+application/vnd.wap.slc				slc
+application/vnd.wap.wbxml			wbxml
+application/vnd.wap.wmlc			wmlc
+application/vnd.wap.wmlscriptc			wmlsc
+application/vnd.wasmflow.wafl       wafl
+application/vnd.webturbo			wtb
+application/vnd.wfa.dpp
+application/vnd.wfa.p2p				p2p
+application/vnd.wfa.wsc				wsc
+application/vnd.windows.devicepairing
+application/vnd.wmc				wmc
+application/vnd.wmf.bootstrap
+# nb: application/mathematica for now
+application/vnd.wolfram.mathematica
+application/vnd.wolfram.mathematica.package	m
+application/vnd.wolfram.player			nbp
+application/vnd.wordlift
+application/vnd.wordperfect			wpd
+application/vnd.wqd				wqd
+application/vnd.wrq-hp3000-labelled
+application/vnd.wt.stf				stf
+application/vnd.wv.csp+xml
+application/vnd.wv.csp+wbxml			wv
+application/vnd.wv.ssp+xml
+application/vnd.xacml+json
+application/vnd.xara				xar
+application/vnd.xfdl				xfdl xfd
+application/vnd.xfdl.webform
+application/vnd.xmi+xml
+application/vnd.xmpie.cpkg			cpkg
+application/vnd.xmpie.dpkg			dpkg
+# dpkg: application/vnd.xmpie.dpkg
+application/vnd.xmpie.plan
+application/vnd.xmpie.ppkg			ppkg
+application/vnd.xmpie.xlim			xlim
+application/vnd.yamaha.hv-dic			hvd
+application/vnd.yamaha.hv-script		hvs
+application/vnd.yamaha.hv-voice			hvp
+application/vnd.yamaha.openscoreformat		osf
+application/vnd.yamaha.openscoreformat.osfpvg+xml
+application/vnd.yamaha.remote-setup
+application/vnd.yamaha.smaf-audio		saf
+application/vnd.yamaha.smaf-phrase		spf
+application/vnd.yamaha.through-ngn
+application/vnd.yamaha.tunnel-udpencap
+application/vnd.yaoweme				yme
+application/vnd.yellowriver-custom-menu		cmp
+# application/vnd.youtube.yt OBSOLETED in favor of video/vnd.youtube.yt
+application/vnd.zul				zir zirz
+application/vnd.zzazz.deck+xml			zaz
+application/voicexml+xml			vxml
+application/voucher-cms+json			vcj
+application/vq-rtcpxr
+application/wasm                    wasm
+application/vq-rtcp-xr
+application/watcherinfo+xml			wif
+application/webpush-options+json
+application/whoispp-query
+application/whoispp-response
+application/widget				wgt
+application/wita
+application/wordperfect5.1
+application/wsdl+xml				wsdl
+application/wspolicy+xml			wspolicy
+# yes, this *is* IANA registered despite of x-
+application/x-pki-message
+application/x-www-form-urlencoded
+application/x-x509-ca-cert
+application/x-x509-ca-ra-cert
+application/x-x509-next-ca-cert
+application/x400-bp
+application/xacml+xml
+application/xcap-att+xml			xav
+application/xcap-caps+xml			xca
+application/xcap-diff+xml			xdf
+application/xcap-el+xml				xel
+application/xcap-error+xml			xer
+application/xcap-ns+xml				xns
+application/xcon-conference-info-diff+xml
+application/xcon-conference-info+xml
+application/xenc+xml
+application/xfdf                    xfdf
+application/xhtml+xml				xhtml xhtm xht
+application/xliff+xml				xlf
+# xml, xsd, rng: text/xml
+application/xml
+# mod: audio/x-mod
+application/xml-dtd				dtd
+# ent: text/xml-external-parsed-entity
+application/xml-external-parsed-entity
+application/xml-patch+xml
+application/xmpp+xml
+application/xop+xml				xop
+application/xslt+xml				xsl xslt
+application/xv+xml				mxml xhvml xvml xvm
+application/yang				yang
+application/yang-data+json
+application/yang-data+xml
+application/yang-data+cbor
+application/yang-patch+json
+application/yang-patch+xml
+application/yin+xml				yin
+application/zip					zip
+application/zlib
+application/zstd				zst
+audio/1d-interleaved-parityfec
+audio/32kadpcm					726
+# 3gp, 3gpp: video/3gpp
+audio/3gpp
+# 3g2, 3gpp2: video/3gpp2
+audio/3gpp2
+# loas: audio/usac
+audio/aac					adts aac ass
+audio/ac3					ac3
+audio/AMR					amr
+audio/AMR-WB					awb
+audio/amr-wb+
+audio/aptx
+audio/asc					acn
+# aa3, omg: audio/ATRAC3
+audio/ATRAC-ADVANCED-LOSSLESS			aal
+# aa3, omg: audio/ATRAC3
+audio/ATRAC-X					atx
+audio/ATRAC3					at3 aa3 omg
+audio/basic					au snd
+audio/BV16
+audio/BV32
+audio/clearmode
+audio/CN
+audio/DAT12
+audio/dls					dls
+audio/dsr-es201108
+audio/dsr-es202050
+audio/dsr-es202211
+audio/dsr-es202212
+audio/DV
+audio/DVI4
+audio/eac3
+audio/encaprtp
+audio/EVRC					evc
+# qcp: audio/qcelp
+audio/EVRC-QCP
+audio/EVRC0
+audio/EVRC1
+audio/EVRCB					evb
+audio/EVRCB0
+audio/EVRCB1
+audio/EVRCNW					enw
+audio/EVRCNW0
+audio/EVRCNW1
+audio/EVRCWB					evw
+audio/EVRCWB0
+audio/EVRCWB1
+audio/EVS
+audio/example
+audio/flexfec
+audio/fwdred
+audio/G711-0
+audio/G719
+audio/G722
+audio/G7221
+audio/G723
+audio/G726-16
+audio/G726-24
+audio/G726-32
+audio/G726-40
+audio/G728
+audio/G729
+audio/G7291
+audio/G729D
+audio/G729E
+audio/GSM
+audio/GSM-EFR
+audio/GSM-HR-08
+audio/iLBC					lbc
+audio/ip-mr_v2.5
+# wav: audio/x-wav
+audio/L16					l16
+audio/L20
+audio/L24
+audio/L8
+audio/LPC
+audio/MELP
+audio/MELP600
+audio/MELP1200
+audio/MELP2400
+audio/mhas					mhas
+audio/mobile-xmf				mxmf
+# mp4, mpg4: video/mp4, see RFC 4337
+audio/mp4					m4a
+audio/MP4A-LATM
+audio/MPA
+audio/mpa-robust
+audio/mpeg					mp3 mpga mp1 mp2
+audio/mpeg4-generic
+audio/ogg					oga ogg opus spx
+audio/opus
+audio/parityfec
+audio/PCMA
+audio/PCMA-WB
+audio/PCMU
+audio/PCMU-WB
+audio/prs.sid					sid psid
+audio/QCELP					qcp
+audio/raptorfec
+audio/RED
+audio/rtp-enc-aescm128
+audio/rtp-midi
+audio/rtploopback
+audio/rtx
+audio/scip
+audio/SMV					smv
+# qcp: audio/qcelp, see RFC 3625
+audio/SMV-QCP
+audio/sofa                  sofa
+audio/SMV0
+# mid: audio/midi
+audio/sp-midi
+audio/speex
+audio/t140c
+audio/t38
+audio/telephone-event
+audio/TETRA_ACELP
+audio/TETRA_ACELP_BB
+audio/tone
+audio/TSVCIS
+audio/UEMCLIP
+audio/ulpfec
+audio/usac					loas xhe
+audio/VDVI
+audio/VMR-WB
+audio/vnd.3gpp.iufp
+audio/vnd.4SB
+audio/vnd.audiokoz				koz
+audio/vnd.CELP
+audio/vnd.cisco.nse
+audio/vnd.cmles.radio-events
+audio/vnd.cns.anp1
+audio/vnd.cns.inf1
+audio/vnd.dece.audio				uva uvva
+audio/vnd.digital-winds				eol
+audio/vnd.dlna.adts
+audio/vnd.dolby.heaac.1
+audio/vnd.dolby.heaac.2
+audio/vnd.dolby.mlp				mlp
+audio/vnd.dolby.mps
+audio/vnd.dolby.pl2
+audio/vnd.dolby.pl2x
+audio/vnd.dolby.pl2z
+audio/vnd.dolby.pulse.1
+audio/vnd.dra
+# wav: audio/x-wav, cpt: application/mac-compactpro
+audio/vnd.dts					dts
+audio/vnd.dts.hd				dtshd
+audio/vnd.dts.uhd
+# dvb: video/vnd.dvb.file
+audio/vnd.dvb.file
+audio/vnd.everad.plj				plj
+# rm: audio/x-pn-realaudio
+audio/vnd.hns.audio
+audio/vnd.lucent.voice				lvp
+audio/vnd.ms-playready.media.pya		pya
+# mxmf: audio/mobile-xmf
+audio/vnd.nokia.mobile-xmf
+audio/vnd.nortel.vbk				vbk
+audio/vnd.nuera.ecelp4800			ecelp4800
+audio/vnd.nuera.ecelp7470			ecelp7470
+audio/vnd.nuera.ecelp9600			ecelp9600
+audio/vnd.octel.sbc
+audio/vnd.presonus.multitrack			multitrack
+# audio/vnd.qcelp deprecated in favour of audio/qcelp
+audio/vnd.rhetorex.32kadpcm
+audio/vnd.rip					rip
+audio/vnd.sealedmedia.softseal.mpeg		smp3 smp s1m
+audio/vnd.vmx.cvsd
+audio/vorbis
+audio/vorbis-config
+font/collection					ttc
+font/otf					otf
+font/sfnt
+font/ttf					ttf
+font/woff					woff
+font/woff2					woff2
+image/aces					exr
+image/apng
+image/avci					avci
+image/avcs					avcs
+# heif: image/heif
+# heifs: images/heif-sequence
+image/avif                  avif hif
+image/bmp					bmp dib
+image/cgm					cgm
+image/dicom-rle					drle
+image/dpx                   dpx
+image/emf					emf
+image/example
+image/fits					fits fit fts
+image/g3fax
+image/heic					heic
+image/heic-sequence				heics
+image/heif					heif
+image/heif-sequence				heifs
+image/hej2k					hej2
+image/hsj2					hsj2
+image/gif					gif
+image/ief					ief
+image/jls					jls
+image/jp2					jp2 jpg2
+image/jph					jph
+image/jphc					jhc
+image/jpeg					jpg jpeg jpe jfif
+image/jpm					jpm jpgm
+image/jpx					jpx jpf
+image/jxl                   jxl
+image/jxr					jxr
+image/jxrA					jxra
+image/jxrS					jxrs
+image/jxs					jxs
+image/jxsc					jxsc
+image/jxsi					jxsi
+image/jxss					jxss
+image/ktx					ktx
+image/ktx2                  ktx2
+image/naplps
+image/png					png
+image/prs.btif					btif btf
+image/prs.pti					pti
+image/pwg-raster
+image/svg+xml					svg svgz
+image/t38					t38
+image/tiff					tiff tif
+image/tiff-fx					tfx
+image/vnd.adobe.photoshop			psd
+image/vnd.airzip.accelerator.azv		azv
+image/vnd.cns.inf2
+image/vnd.dece.graphic				uvi uvvi uvg uvvg
+image/vnd.djvu					djvu djv
+# sub: text/vnd.dvb.subtitle
+image/vnd.dvb.subtitle
+image/vnd.dwg					dwg
+image/vnd.dxf					dxf
+image/vnd.fastbidsheet				fbs
+image/vnd.fpx					fpx
+image/vnd.fst					fst
+image/vnd.fujixerox.edmics-mmr			mmr
+image/vnd.fujixerox.edmics-rlc			rlc
+image/vnd.globalgraphics.pgb			pgb
+image/vnd.microsoft.icon			ico
+image/vnd.mix
+image/vnd.mozilla.apng				apng
+image/vnd.ms-modi				mdi
+image/vnd.net-fpx
+image/vnd.pco.b16               b16
+image/vnd.radiance				hdr rgbe xyze
+image/vnd.sealed.png				spng spn s1n
+image/vnd.sealedmedia.softseal.gif		sgif sgi s1g
+image/vnd.sealedmedia.softseal.jpg		sjpg sjp s1j
+image/vnd.svf
+image/vnd.tencent.tap				tap
+image/vnd.valve.source.texture			vtf
+image/vnd.wap.wbmp				wbmp
+image/vnd.xiff					xif
+image/vnd.zbrush.pcx				pcx
+image/wmf					wmf
+message/bhttp
+message/CPIM
+message/delivery-status
+message/disposition-notification
+message/example
+message/external-body
+message/feedback-report
+message/global					u8msg
+message/global-delivery-status			u8dsn
+message/global-disposition-notification		u8mdn
+message/global-headers				u8hdr
+message/http
+# cl: application/simple-filter+xml
+message/imdn+xml
+message/mls
+# message/news obsoleted by message/rfc822
+message/ohttp-req
+message/ohttp-res
+message/partial
+message/rfc822					eml mail art
+message/s-http
+message/sip
+message/sipfrag
+message/tracking-status
+message/vnd.si.simp
+# wsc: application/vnd.wfa.wsc
+message/vnd.wfa.wsc
+# 3mf: application/vnd.ms-3mfdocument
+model/3mf
+model/e57
+model/example
+model/gltf-binary				glb
+model/gltf+json					gltf
+model/JT                        jt
+model/iges					igs iges
+model/mesh					msh mesh silo
+model/mtl					mtl
+model/obj					obj
+model/prc
+model/step
+model/step+xml              stpx
+model/step+zip
+model/step-xml+zip          stpxz
+model/stl					stl
+model/u3d                   u3d
+model/vnd.bary              bary
+model/vnd.cld               cld
+model/vnd.collada+xml				dae
+model/vnd.dwf					dwf
+# 3dml, 3dm: text/vnd.in3d.3dml
+model/vnd.flatland.3dml
+model/vnd.gdl					gdl gsm win dor lmp rsm msm ism
+model/vnd.gs-gdl
+model/vnd.gtw					gtw
+model/vnd.moml+xml				moml
+model/vnd.mts					mts
+model/vnd.opengex				ogex
+model/vnd.parasolid.transmit.binary		x_b xmt_bin
+model/vnd.parasolid.transmit.text		x_t xmt_txt
+model/vnd.pytha.pyox            pyo pyox
+model/vnd.rosette.annotated-data-model
+model/vnd.sap.vds               vds
+model/vnd.usda                  usda
+model/vnd.usdz+zip				usdz
+model/vnd.valve.source.compiled-map		bsp
+model/vnd.vtu					vtu
+model/vrml					wrl vrml
+# x3db: model/x3d+xml
+model/x3d+fastinfoset
+# x3d: application/vnd.hzn-3d-crossword
+model/x3d+xml					x3db
+model/x3d-vrml					x3dv x3dvz
+multipart/alternative
+multipart/appledouble
+multipart/byteranges
+multipart/digest
+multipart/encrypted
+multipart/form-data
+multipart/header-set
+multipart/mixed
+multipart/multilingual
+multipart/parallel
+multipart/related
+multipart/report
+multipart/signed
+multipart/vnd.bint.med-plus			bmed
+multipart/voice-message				vpm
+multipart/x-mixed-replace
+text/1d-interleaved-parityfec
+text/cache-manifest				appcache manifest
+text/calendar					ics ifb
+text/cql                    CQL
+text/cql-expression
+text/cql-identifier
+text/css					css
+text/csv					csv
+text/csv-schema					csvs
+text/directory
+text/dns					soa zone
+text/encaprtp
+text/fhirpath
+# text/ecmascript obsoleted by application/ecmascript
+text/enriched
+text/example
+text/flexfec
+text/fwdred
+text/gff3                   gff3
+text/grammar-ref-list
+text/hl7v2
+text/html					html htm
+text/javascript                 js mjs
+text/jcr-cnd					cnd
+text/markdown					markdown md
+text/mizar					miz
+text/n3						n3
+text/parameters
+text/parityfec
+text/plain		txt asc text pm el c h cc hh cxx hxx f90 conf log
+text/provenance-notation			provn
+text/prs.fallenstein.rst			rst
+text/prs.lines.tag				tag dsc
+text/prs.prop.logic
+text/raptorfec
+text/RED
+text/rfc822-headers
+text/richtext					rtx
+# rtf: application/rtf
+text/rtf
+text/rtp-enc-aescm128
+text/rtploopback
+text/rtx
+text/SGML					sgml sgm
+text/shaclc                 shaclc shc
+text/shex                   shex
+text/spdx                   spdx
+text/strings
+text/t140
+text/tab-separated-values			tsv
+text/troff					t tr roff
+text/turtle					ttl
+text/ulpfec
+text/uri-list					uris uri
+text/vcard					vcf vcard
+text/vnd.a					a
+text/vnd.abc					abc
+text/vnd.ascii-art				ascii
+# curl: application/vnd.curl
+text/vnd.curl
+text/vnd.debian.copyright			copyright
+text/vnd.DMClientScript				dms
+text/vnd.dvb.subtitle				sub
+text/vnd.esmertec.theme-descriptor		jtd
+text/vnd.exchangeable           vfk
+text/vnd.familysearch.gedcom    ged
+text/vnd.ficlab.flt				flt
+text/vnd.fly					fly
+text/vnd.fmi.flexstor				flx
+# gml: application/gml+xml
+text/vnd.gml
+text/vnd.graphviz				gv dot
+text/vnd.hans                   hans
+text/vnd.hgl					hgl
+text/vnd.in3d.3dml				3dml 3dm
+text/vnd.in3d.spot				spot spo
+text/vnd.IPTC.NewsML
+text/vnd.IPTC.NITF
+text/vnd.latex-z
+text/vnd.motorola.reflex
+text/vnd.ms-mediapackage			mpf
+text/vnd.net2phone.commcenter.command		ccc
+text/vnd.radisys.msml-basic-layout
+text/vnd.senx.warpscript			mc2
+text/vnd.si.uricatalogue			uric
+text/vnd.sun.j2me.app-descriptor		jad
+text/vnd.sosi					sos
+text/vnd.trolltech.linguist			ts
+text/vnd.wap.si					si
+text/vnd.wap.sl					sl
+text/vnd.wap.wml				wml
+text/vnd.wap.wmlscript				wmls
+text/vtt					vtt
+text/wgsl                   wgsl
+text/xml					xml xsd rng
+text/xml-external-parsed-entity			ent
+video/1d-interleaved-parityfec
+video/3gpp					3gp 3gpp
+video/3gpp2					3g2 3gpp2
+video/3gpp-tt
+video/AV1
+video/BMPEG
+video/BT656
+video/CelB
+video/DV
+video/encaprtp
+video/FFV1
+video/example
+video/flexfec
+video/H261
+video/H263
+video/H263-1998
+video/H263-2000
+video/H264
+video/H264-RCDO
+video/H264-SVC
+video/H265
+video/H266
+video/iso.segment				m4s
+video/JPEG
+video/jpeg2000
+video/jxsv
+video/mj2					mj2 mjp2
+video/MP1S
+video/MP2P
+video/MP2T
+video/mp4					mp4 mpg4 m4v
+video/MP4V-ES
+video/mpeg					mpeg mpg mpe m1v m2v
+video/mpeg4-generic
+video/MPV
+video/nv
+video/ogg					ogv
+video/parityfec
+video/pointer
+video/quicktime					mov qt
+video/raptorfec
+video/raw
+video/rtp-enc-aescm128
+video/rtploopback
+video/rtx
+video/scip
+video/smpte291
+video/SMPTE292M
+video/ulpfec
+video/vc1
+video/vc2
+video/vnd.CCTV
+video/vnd.dece.hd				uvh uvvh
+video/vnd.dece.mobile				uvm uvvm
+video/vnd.dece.mp4				uvu uvvu
+video/vnd.dece.pd				uvp uvvp
+video/vnd.dece.sd				uvs uvvs
+video/vnd.dece.video				uvv uvvv
+video/vnd.directv.mpeg
+video/vnd.directv.mpeg-tts
+video/vnd.dlna.mpeg-tts
+video/vnd.dvb.file				dvb
+video/vnd.fvt					fvt
+# rm: audio/x-pn-realaudio
+video/vnd.hns.video
+video/vnd.iptvforum.1dparityfec-1010
+video/vnd.iptvforum.1dparityfec-2005
+video/vnd.iptvforum.2dparityfec-1010
+video/vnd.iptvforum.2dparityfec-2005
+video/vnd.iptvforum.ttsavc
+video/vnd.iptvforum.ttsmpeg2
+video/vnd.motorola.video
+video/vnd.motorola.videop
+video/vnd.mpegurl				mxu m4u
+video/vnd.ms-playready.media.pyv		pyv
+video/vnd.nokia.interleaved-multimedia		nim
+video/vnd.nokia.mp4vr
+video/vnd.nokia.videovoip
+# mp4: video/mp4
+video/vnd.objectvideo
+video/vnd.radgamettools.bink			bik bk2
+video/vnd.radgamettools.smacker			smk
+video/vnd.sealed.mpeg1				smpg s11
+# smpg: video/vnd.sealed.mpeg1
+video/vnd.sealed.mpeg4				s14
+video/vnd.sealed.swf				sswf ssw
+video/vnd.sealedmedia.softseal.mov		smov smo s1q
+# uvu, uvvu: video/vnd.dece.mp4
+video/vnd.uvvu.mp4
+video/vnd.youtube.yt				yt
+video/vnd.vivo					viv
+video/VP8
+video/VP9
+
+# Non-IANA types
+
+application/mac-compactpro			cpt
+application/metalink+xml			metalink
+application/owl+xml				owx
+application/rss+xml				rss
+application/vnd.android.package-archive		apk
+application/vnd.oma.dd+xml			dd
+application/vnd.oma.drm.content			dcf
+# odf: application/vnd.oasis.opendocument.formula
+application/vnd.oma.drm.dcf			o4a o4v
+application/vnd.oma.drm.message			dm
+application/vnd.oma.drm.rights+wbxml		drc
+application/vnd.oma.drm.rights+xml		dr
+application/vnd.sun.xml.calc			sxc
+application/vnd.sun.xml.calc.template		stc
+application/vnd.sun.xml.draw			sxd
+application/vnd.sun.xml.draw.template		std
+application/vnd.sun.xml.impress			sxi
+application/vnd.sun.xml.impress.template	sti
+application/vnd.sun.xml.math			sxm
+application/vnd.sun.xml.writer			sxw
+application/vnd.sun.xml.writer.global		sxg
+application/vnd.sun.xml.writer.template		stw
+application/vnd.symbian.install			sis
+application/vnd.wap.mms-message			mms
+application/x-annodex				anx
+application/x-bcpio				bcpio
+application/x-bittorrent			torrent
+application/x-bzip2				bz2
+application/x-cdlink				vcd
+application/x-chrome-extension			crx
+application/x-cpio				cpio
+application/x-csh				csh
+application/x-director				dcr dir dxr
+application/x-dvi				dvi
+application/x-futuresplash			spl
+application/x-gtar				gtar
+application/x-hdf				hdf
+application/x-java-jnlp-file			jnlp
+application/x-java-pack200			pack
+application/x-killustrator			kil
+application/x-latex				latex
+application/x-netcdf				nc cdf
+application/x-perl				pl
+application/x-rpm				rpm
+application/x-sh				sh
+application/x-shar				shar
+application/x-stuffit				sit
+application/x-sv4cpio				sv4cpio
+application/x-sv4crc				sv4crc
+application/x-tar				tar
+application/x-tcl				tcl
+application/x-tex				tex
+application/x-texinfo				texinfo texi
+application/x-troff-man				man 1 2 3 4 5 6 7 8
+application/x-troff-me				me
+application/x-troff-ms				ms
+application/x-ustar				ustar
+application/x-wais-source			src
+application/x-xpinstall				xpi
+application/x-xspf+xml				xspf
+application/x-xz				xz
+audio/midi					mid midi kar
+audio/x-aiff					aif aiff aifc
+audio/x-annodex					axa
+audio/x-flac					flac
+audio/x-matroska				mka
+audio/x-mod					mod ult uni m15 mtm 669 med
+audio/x-mpegurl					m3u
+audio/x-ms-wax					wax
+audio/x-ms-wma					wma
+audio/x-pn-realaudio				ram rm
+audio/x-realaudio				ra
+audio/x-s3m					s3m
+audio/x-stm					stm
+audio/x-wav					wav
+chemical/x-xyz					xyz
+image/webp					webp
+image/x-cmu-raster				ras
+image/x-portable-anymap				pnm
+image/x-portable-bitmap				pbm
+image/x-portable-graymap			pgm
+image/x-portable-pixmap				ppm
+image/x-rgb					rgb
+image/x-targa					tga
+image/x-xbitmap					xbm
+image/x-xpixmap					xpm
+image/x-xwindowdump				xwd
+text/html-sandboxed				sandboxed
+text/x-pod					pod
+text/x-setext					etx
+video/webm					webm
+video/x-annodex					axv
+video/x-flv					flv
+video/x-javafx					fxm
+video/x-matroska				mkv
+video/x-matroska-3d				mk3d
+video/x-ms-asf					asx
+video/x-ms-wm					wm
+video/x-ms-wmv					wmv
+video/x-ms-wmx					wmx
+video/x-ms-wvx					wvx
+video/x-msvideo					avi
+video/x-sgi-movie				movie
+x-conference/x-cooltalk				ice
+x-epoc/x-sisx-app				sisx
